/*====================================================================

Objectweb Browser framework
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.browser.plugin.java;

import java.awt.Color;
import java.util.Enumeration;
import java.util.Properties;

import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;

import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.api.Panel;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * 
 * @version 0.1
 */
public class PropertiesPanel
  implements Panel {

    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    /** The JPanel to display */
    protected JPanel panel_;

    //==================================================================
    //
    // Constructor.
    // 
    //==================================================================

    /**
     * Empty constructor
     */
    public PropertiesPanel() {
        panel_ = new JPanel();
        panel_.setBackground(Color.white);
        panel_.setLayout(new BoxLayout(panel_, BoxLayout.Y_AXIS));
    }

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public methods for ViewPanel interface.
    //
    //==================================================================

	/**
	 * @see org.objectweb.util.browser.api.Panel#selected(org.objectweb.util.browser.api.TreeView)
	 */
	public void selected(TreeView treeView) {
        String[] titre = {"Keys","Values"};
	    Properties properties = (Properties)treeView.getSelectedObject();
        Enumeration keys, elements;
        keys = properties.keys();
        elements = properties.elements();
        String[][] contenu = new String[properties.size()][2];
        for (int i = 0; i < properties.size(); i++) {
            contenu[i] = new String[]{(String) keys.nextElement(),(String)elements.nextElement()}; 
        }
        panel_.add(new JScrollPane(new JTable(contenu,titre)));
	}

	/**
	 * @see org.objectweb.util.browser.api.Panel#getPanel()
	 */
	public JPanel getPanel() {
		return panel_;
	}

    /**
     * Overriding methods
     * @see org.objectweb.util.browser.api.Panel#unselected(org.objectweb.util.browser.api.TreeView)
     */
    public void unselected(TreeView treeview) {
        // Nothing to do
    }

}