package org.objectweb.util.browser.plugin.java;

/** The console's imports */
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.core.api.ContextContainer;

public class RemoveFromContextAction 
    implements MenuItem {

    public void actionPerformed(MenuItemTreeView treeView) {
        if (treeView != null) {
            Entry entry = treeView.getSelectedEntry();
            String value = entry.getName().toString();
            ContextContainer context = (ContextContainer) treeView.getParentObject();
            context.removeEntry(value);
        }
    }
    
    /**
     * @see org.objectweb.util.browser.api.MenuItem#getStatus(org.objectweb.util.browser.api.TreeView)
     */
    public int getStatus(TreeView treeView) {
        return MenuItem.ENABLED_STATUS;
    }
    
}
