/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: StopComponentAction.java,v 1.1 2004/04/20 16:37:27 moroy Exp $
 ====================================================================*/

package org.objectweb.util.browser.plugins.fractal.menu;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.plugins.fractal.FcBrowser;

/**
 * This action allows to start/stop the component. 
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 * @version 0.1
 */
public class StopComponentAction 
  implements MenuItem 
{
    //==================================================================
    //
    // No internal state.
    //
    //==================================================================
    
    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================
    
    //==================================================================
    //
    // No internal method.
    //
    //==================================================================
    
    //==================================================================
    //
    // Public methods for ExtendedActionListener interface.
    //
    //==================================================================
    
    public void actionPerformed(MenuItemTreeView e) {
        Component ci = (Component)e.getSelectedObject();
        try {
            LifeCycleController lcc = FcBrowser.getLifeCycleController(ci);
            lcc.stopFc();
        } catch (NoSuchInterfaceException e1) {
            e1.printStackTrace();
        } catch (IllegalLifeCycleException e1) {
            e1.printStackTrace();
        }
    }
    
    /**
     * @see org.objectweb.util.browser.api.MenuItem#isActive(org.objectweb.util.browser.gui.common.TreeView)
     */
    public int getStatus(TreeView treeView) {
        Component ci = (Component)treeView.getSelectedObject();
        try {
            LifeCycleController lcc = FcBrowser.getLifeCycleController(ci);
            String status = lcc.getFcState();
            if (status.equals(LifeCycleController.STOPPED))
                return MenuItem.NOT_VISIBLE_STATUS;
        } catch (NoSuchInterfaceException e) {
            return MenuItem.NOT_VISIBLE_STATUS;
        }
        return MenuItem.ENABLED_STATUS;   
    }
}