package test;

/** The console's imports */
import org.objectweb.util.browser.api.Entry;
import org.objectweb.util.browser.api.MenuItem;
import org.objectweb.util.browser.api.MenuItemTreeView;
import org.objectweb.util.browser.api.TreeView;
import org.objectweb.util.browser.core.api.ContextContainer;

/** The manipulated object */

public class RemoveFromContextAction implements MenuItem {

    public void actionPerformed(MenuItemTreeView treeView) {
        if (treeView != null) {
            Entry entry = treeView.getSelectedEntry();
            String value = entry.getName().toString();
            ContextContainer context = (ContextContainer) treeView.getParentObject();
            context.removeEntry(value);
        }
    }
    
    /**
     * Enabled only if the ContextContainer contains more than one element 
     * @see org.objectweb.util.browser.api.MenuItem#isActive(java.lang.Object)
     */
    public int getStatus(TreeView treeView) {
        ContextContainer cc = (ContextContainer)treeView.getParentObject();
        Entry[] entries = cc.getEntries();
        int cpt = 0;
        for (int i = 0; i < entries.length; i++) {
			Entry element = (Entry) entries[i];
            cpt++;
            if(cpt>1)
                return MenuItem.ENABLED_STATUS;
		}
        return MenuItem.DISABLED_STATUS;
    }
    
}
