/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.explorer.CosTrading;

import org.objectweb.util.explorer.api.MenuItem;
import org.objectweb.util.explorer.api.MenuItemTreeView;
import org.objectweb.util.explorer.api.TreeView;
import org.omg.CosTradingRepos.ServiceTypeRepository;

/**
 * This action removes an existing service type from the service type
 * repository. <b>Warning</b>: using this action causes the OpenORB
 * service type repository crash.
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 * @version 0.1
 */
public class RemoveServiceType 
  implements MenuItem 
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.api.MenuItem#getStatus(org.objectweb.util.explorer.api.TreeView)
     */
    public int getStatus(TreeView arg0){
        return MenuItem.ENABLED_STATUS;
    }

    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.api.MenuItem#actionPerformed(org.objectweb.util.explorer.api.MenuItemTreeView)
     */
    public void actionPerformed(MenuItemTreeView e) throws Exception{
        String name = e.getSelectedEntry().getName().toString();
        ServiceTypeRepository parent = (ServiceTypeRepository)e.getParentObject();
        try {
            parent.remove_type(name);
        } catch (org.omg.CosTrading.IllegalServiceType ex) {
            throw new Exception("bad service type '" + ex.type + "'.");
        } catch (org.omg.CosTrading.UnknownServiceType ex) {
            throw new Exception("bad service type '" + ex.type + "'.");
        } catch (org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.HasSubTypes ex) {
            throw new Exception("the service type '" + ex.the_type + "' have subtype '" + ex.sub_type +"'." );
        }
    }

}
