/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s):Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.explorer.CosTrading.gui;


import javax.swing.JPanel;

import org.objectweb.util.explorer.api.Panel;
import org.objectweb.util.explorer.api.TreeView;

/**
 * Default implementation of the node view panel. Does nothing in the
 * three methods to implement except storring the tree view and
 * calling the <code>onSetTreeView</code> method.
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 * @version 0.1
 */
public class DefaultNodeViewPanel 
     extends JPanel 
  implements Panel 
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /**
     * The last setted tree view or <code>null</code> if never setted.
     */
    private TreeView treeView_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * Default constructor.
     */
    public DefaultNodeViewPanel() {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    /**
     * The last setted tree view or <code>null</code> if never setted.
     */
    protected TreeView getTreeView() {
        return treeView_;
    }

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     * Actions to do after setting the tree view. Here does nothing.
     */
    public void onSetTreeView() {
    }

    // ==================================================================
    //
    // Public methods for interface TreeHandling.
    //
    // ==================================================================

    /**
     * Invokes just after instanciation. Here does nothing.
     */
    public void selected(TreeView treeView) {
        treeView_ = treeView;
        onSetTreeView();
    }

    /**
     * Provides the panel to display.
     * @return The panel to display.
     */
    public Object getPanel(){
        return this;    
    }

    /**
     * Invokes just before removing. Here does nothing.
     */
    public void unselected(TreeView treeView) {
    }

}














