/*===========================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Sylvain Leblanc.
Contributor(s):  ______________________________________.

===========================================================================*/

package org.objectweb.openccm.explorer.CosTrading.gui;

import javax.swing.JLabel;
import javax.swing.BoxLayout;
import java.awt.Dimension;
import java.awt.Color;
import javax.swing.Box;

/**
 * A Box used to display an OMG IDL Interface.
 *
 * @author <a href="mailto:Sylvain.Leblanc@lifl.fr">Sylvain Leblanc</a>
 * @version 0.1
 *
 */
public class ItfGUI 
     extends Box 
{

    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** The OMG IDL interface name. */
    protected String itf_;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     * Default contructor.
     *
     * @param itf  The OMG IDL interface name.
     */
    public ItfGUI(String itf) {
        super(BoxLayout.X_AXIS);
        setBackground(Color.white);

        itf_ = itf;

        add(Box.createHorizontalGlue());

        JLabel label = new JLabel(itf_);
        label.setPreferredSize(new Dimension(350, 20));
        add(label);

        add(Box.createHorizontalGlue());
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

}







