/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy.
Contributor(s):  ______________________________________.

====================================================================*/
package org.objectweb.openccm.explorer.Deployment;

import org.objectweb.openccm.explorer.CORBA.TypageCORBA;
import org.objectweb.util.explorer.api.Context;
import org.objectweb.util.explorer.api.Entry;
import org.objectweb.util.explorer.core.naming.lib.DefaultEntry;
import org.omg.Components.CCMHome;
import org.omg.Components.Deployment.Container;

/**
 * Basic implementation of the Context interface
 * for managing Container object.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jerome Moroy</a>
 *
 * @version 0.1
 */
public class ContainerContext
    implements Context {

	// ==================================================================
	//
	// Internal state.
	//
	// ==================================================================

	// ==================================================================
	//
	// No Constructors.
	//
	// ==================================================================

	// ==================================================================
	//
	// Internal methods.
	//
	// ==================================================================

	/**
	 * Return the name of the Entry
	 */
	protected String getName(org.omg.CORBA.Object o) {
		TypageCORBA tc = new TypageCORBA(o, org.objectweb.openccm.corba.TheORB.getORB());
		return tc.getTypeID();
	}

	// ==================================================================
	//
	// Public methods for interface Context.
	//
	// ==================================================================

	public Entry[] getEntries(Object object) {
        Container container = (Container) object;
		CCMHome[] objects = container.get_homes();
		Entry[] values = new Entry[objects.length];
		for (int i = 0; i < objects.length; i++)
			values[i] = new DefaultEntry(getName(objects[i]) + " (" + i + ")", objects[i]);
		return values;
	}

}
