/***************************************************************************/
/* COACH: Component Based Open Source Architecture for                     */
/*        Distributed Telecom Applications                                 */
/* See:   http://www.objectweb.org/                                        */
/*                                                                         */
/* Copyright (C) 2003 Lucent Technologies Nederland BV                     */
/*                    Bell Labs Advanced Technologies - EMEA               */
/*                                                                         */
/* Initial developer(s): Willem A. Romijn (based the work of Mathieu Vadet */
/*                                         and Phillipe Merle              */
/* This library is free software; you can redistribute it and/or           */
/* modify it under the terms of the GNU Lesser General Public              */
/* License as published by the Free Software Foundation; either            */
/* version 2.1 of the License, or (at your option) any later version.      */
/*                                                                         */
/* This library is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of          */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU        */
/* Lesser General Public License for more details.                         */
/*                                                                         */
/* You should have received a copy of the GNU Lesser General Public        */
/* License along with this library; if not, write to the Free Software     */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */
/***************************************************************************/

package org.coach.reactor;

/**
 * This class is launched by the ir3_rimpl script.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>
 *         <a href="mailto:Mathieu.Vadet@lifl.fr">Mathieu Vadet</a>
 *
 * @version 0.3
 */

public class IR3toReactorImpl
       extends org.objectweb.openccm.corba.Application
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructor.
    //
    // ==================================================================

    /**
     **  The default constructor.
     **/
    public
    IR3toReactorImpl()
    {
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

    /**
     ** The main bootstrap method.
     **/
    public static void
    main(String[] args)
    {
        IR3toReactorImpl ir3 = new IR3toReactorImpl();
        ir3.start(args);
    }

    // ==================================================================
    //
    //  Methods for the org.objectweb.openccm.corba.Application class.
    //
    // ==================================================================

    /**
     **  Run the application.
     **
     **  @param args The command line arguments.
     **
     **  @return The status.
     **/
    public int
    run(String[] args)
    {
        // Obtain the Interface Repository.
        org.omg.CORBA.ComponentIR.Repository repositoryRef =
            org.objectweb.openccm.corba.TheInterfaceRepository.getRepository();

        // Start an IDL3 Repository
        org.objectweb.ccm.IDL3.Repository rep = 
            new org.objectweb.ccm.IDL3.Repository(repositoryRef);

        try
        {
            IDL3_ReactorImpl mi = new IDL3_ReactorImpl(rep);

            mi.generate(args[0]);
        }
        catch(fr.lifl.cim.jidlscript.lang.JISError ex)
        {
            System.err.println(ex.exception.toString());
            return 1;
        }

	return 0;
    }
}
