/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base;

/**
 * The DeployerExceptionWrappeur is a exception wrapper use to 
 * encapsulate the exception that occured during the deployment
 * process.
 *
 * @author <a href="mailto:briclet@lifl.fr">Frederic Briclet</a>
 *
 * @version 0.1
 */
public class DeployerExceptionWrapper 
    extends Exception 
{
    
    //  ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    //The initial exception
    protected Exception source;
    
    protected String message;
    //  ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    //  ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    //  ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    
    /**
     * The default constructor taking in parameters the initial exception
     * and an explaination of the problem encounted.
     * @param e The source exception
     * @param message The explaination message 
     */
    public 
    DeployerExceptionWrapper(Exception e, 
                             String message)
    {
        super(message);
        source=e;       
        this.message=message; 
    }
    
    /**
     * Method accessor to the initial exception thrown.
     * @return
     */
    public Exception 
    getInitialException()
    {
        return source;
    }
    
    public void
    printStackTrace()
    {
        super.printStackTrace();
        if(source!=null)
        {
            System.err.println("Due to:\n");
            source.printStackTrace();
        }
           
    }
    
}
