/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.binder;

// Local Interface Import Statements
import org.objectweb.openccm.descriptor.componentassembly.beans.ConnecteventBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
/**
 * This handler is used to produce connecteventdeployer deployer from an
 * connectevent bean .
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ConnecteventDeployerHandler
       extends HandlerBase
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ConnecteventDeployer _deploy;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================    
    /**
    * Produce the connectinterface deployer binded
    * to the given @param connect.
    * 
    * @param connnect The connectinterface bean 
    * @return the deployer produced in initialize state
    * @throws InitializationError thrown if a problem is detected
    */  
    public Object 
    getInstance(ConnecteventBeanImpl connect)
    throws InitializationError
    {
        if(_deploy==null){
            _deploy=new ConnecteventDeployer();
            _deploy.connectConnectevent(connect);
            applyCommonConfig(_deploy);
            if(connect.getConsumesport()!=null)
            _deploy.connectConsumesportDeployer
                ((ConsumesportDeployer)getDeployer(connect.getConsumesport()));
            else if(connect.getExistinginterface()!=null)
                _deploy.connectExistinginterfaceDeployer
                 ((ExistinginterfaceDeployer)getDeployer(connect.getExistinginterface()));
          
            if(connect.getPublishesport()!=null)
                _deploy.connectPublishesportDeployer
                    ((PublishesportDeployer)getDeployer(connect.getPublishesport()));
            else if(connect.getEmitsport()!=null)
                 _deploy.connectEmitsportDeployer
                    ((EmitsportDeployer)getDeployer(connect.getEmitsport()));
            _deploy.initialize();       
        }
        return (_deploy);
    }

}
