/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.binder;

// Local Interface Import Statements
import org.objectweb.openccm.descriptor.componentassembly.beans.ConnecteventBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.beans.ConnectinterfaceBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.beans.ConnectionsBeanImpl;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.HandlerBase;
import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
/**
 * This handler is used to produce connectionsdeployer from an
 * connections bean .
 * 
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ConnectionsDeployerHandler 
       extends HandlerBase
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    private ConnectionsDeployer _deploy;
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Produce the connections deployer binded
     * to the givean @param connect.
     * 
     * @param cons The connections bean 
     * @return the deployer produced in initialize state
     * @throws InitializationError thrown if a problem is detected
     */      
    public Object 
    getInstance(ConnectionsBeanImpl connect)
    throws InitializationError 
    {
        if(_deploy==null){
            _deploy=new ConnectionsDeployer();
              applyCommonConfig(_deploy);
              _deploy.connectConnections(connect);
              for(java.util.Iterator i=connect.getConnecteventList().iterator();i.hasNext(); ){                                                    
                  _deploy.connectConnecteventDeployer
                    ((ConnecteventDeployer)getDeployer((ConnecteventBeanImpl)i.next()) );
                }
            for(java.util.Iterator i=connect.getConnectinterfaceList().iterator();i.hasNext(); ){                                                    
                _deploy.connectConnectinterfaceDeployer
                 ((ConnectinterfaceDeployer)getDeployer((ConnectinterfaceBeanImpl)i.next()) );
               }
            _deploy.initialize();
        }       
        return (_deploy);
    }
}
