/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.binder;

import org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.util.CannotResolveReferenceException;
import org.omg.CORBA.Object;
import org.omg.Components.EventConsumerBase;

/**
 * The existinginterface deployer is in charge to resolve an existing interface.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public class ExistinginterfaceDeployer
       extends ExistinginterfaceDeployerContext 
    {
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    // ==================================================================
    //
    //  Public methods.
    //
    // ==================================================================
    /**
     * Resolve and existing interface and return it like the consumed 
     * object. 
     *
     * @throws CannotResolveReferenceException is the consumer cannot be found
     * @return The existing interface
     */
    public  EventConsumerBase 
    getEventConsumerBase() 
    throws CannotResolveReferenceException 

    {
        EventConsumerBase e=
         org.omg.Components.EventConsumerBaseHelper
            .narrow(getCorbaObject()); 
        getLifeCycleManager().stepEndedSuccessFully();    
        return e;
    }
    
    
    /**
     * Resolve and existing interface and return it like the consumed object.
     * If any interface can be found an exception is thrown
     *
     * @param deployTable the internal table use to store information.
     * @param ei the existing interface to retrieve
     */
    public org.omg.CORBA.Object 
    getCorbaObject() 
    throws CannotResolveReferenceException
    {
        Object o=getFindbyDeployer().resolveReference();     
        return o;    
    }
    
    


    
    
    
}
