/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Briclet Frdric.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.ccm.deployer.installer;

import org.objectweb.openccm.descriptor.softpkg.ccm.DependencyDeployer;
import org.objectweb.openccm.descriptor.softpkg.ccm.DependencyResolutionFailureException;

/**
 * The DependecyDeployerVisitor defines the visitor method needed to 
 * process dependencies from a DestinationDeployer implementation.
 *
 * @author <a href="mailto:briclet@lifl.fr">Briclet Frdric</a>
 *
 * @version 0.1
 */
public interface DependencyDeployerVisitor {
    
    /**
     * Visitor method to process a dependency.
     *  
     * @param dependencyDeployer the dependency to process.
     * @throws DependencyResolutionFailureException if the resolution failed.
     */
    public void
    visit(DependencyDeployer dependencyDeployer)
    throws DependencyResolutionFailureException;
}
