/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfClientComponents.ManagedObjectClientComposition;

import intt.itu.itut_x780.*;
import java.text.DateFormat;
import ist.coach.coachEmfCommon.Utils;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmfClientComponents/ManagedObjectClientComposition/ManagedObjectClientHome_impl/ManagedObjectClient_impl/stateChangeSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class stateChangeSegImpl
     extends ist.coach.coachEmfClientComponents.ManagedObjectClientComposition.stateChangeSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public stateChangeSegImpl()
    {

    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816Components::CCM_StateChangedEventConsumer::push operation.
     */
    public void
    push(ist.coach.itut_q816Components.StateChangedEvent event)
    {
       //
        //  DONE : implement
        //
		System.err.println("---->StateChangedEvent received: ");
		System.err.println("Source Object Name = " + Utils.name2string(event.source));
		System.err.println("Source Object Type = " + event.sourceClass);
		System.err.println("Notification Id = " + event.notificationIdentifier);
		String details = new String();
		for(int i = 0; i < event.attributeList.length; i++) {
		  details += event.attributeList[i].attributeName + " changed ";
		  if (event.attributeList[i].oldValue != null) {
			OperationalStateType oldState = OperationalStateTypeHelper.extract(
					  event.attributeList[i].oldValue);
			details += " from ";
			switch(oldState.value()) {
			  case OperationalStateType._disabled :
				details += "Disabled";
				 break;
			  case OperationalStateType._enabled :
				details += "Enabled";
				break;
			  default:
                details += "Unknown";
		   }
		  }
		  if (event.attributeList[i].newValue != null) {
			OperationalStateType newState = OperationalStateTypeHelper.extract(
					  event.attributeList[i].newValue);
			details += " to ";
			switch(newState.value()) {
			  case OperationalStateType._disabled :
				details += "Disabled";
				 break;
			  case OperationalStateType._enabled :
				details += "Enabled";
				break;
			  default:
                details += "Unknown";
		   }
		  }
        }

		System.err.println("Details = " + details);
		java.util.Date event_date = new java.util.Date(event.eventTime.time);
		DateFormat df = DateFormat.getDateTimeInstance(DateFormat.DEFAULT, DateFormat.DEFAULT);
		String time_str = df.format(event_date);
		System.err.println("Date = " + time_str);

		ManagedObjectClientImpl main_segment = (ManagedObjectClientImpl) get_main_segment();
		//System.err.println("StateChange is pushed to Gui Client");
		main_segment.ui_client.print_alarm(time_str,
				ist.coach.coachEmfClientComponents.gui.GuiMessages.state_changed_alarm,
				Utils.name2string(event.source), event.sourceClass,
				String.valueOf(event.notificationIdentifier), details);
    }

}
