package ist.coach.coachEmfClientComponents.gui;

import javax.swing.table.AbstractTableModel;
import java.util.Vector;

class AlarmTableModel extends AbstractTableModel {

        final String[] columnNames = {" Time            ",
				" Event Type      ",
				" Source Type     ",
				" Source          ",
				" Alarm Id ",
				" Details "
		};

		Vector data;
		protected static int NUM_COLUMNS = 6;
		protected static int TIME_C	 = 0;
		protected static int EVENT_C	 = 1;
		protected static int SOURCE_T_C	 = 2;
		protected static int SOURCE_C	 = 3;
		protected static int ID_C 	 = 4;
		protected static int DETAILS_C	 = 5;

		private int nextEmptyRow = 0;
		private static int START_NUM_ROWS = 30;//20
		int numRows = 0;

        AlarmTableModel() {

			data = new Vector();
			//data = new Vector(1000, 100);
		//	System.err.println("AlarmTableModel default capacity = " + data.capacity());
        }

        public int getColumnCount() {
            return columnNames.length;
        }

        public int getRowCount() {

			if (numRows < START_NUM_ROWS)
				return START_NUM_ROWS;
			else
            	return numRows;
        }

        public String getColumnName(int col) {

            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {

			try {
				AlarmRecord alarmR = (AlarmRecord) data.elementAt(row);

				switch(col) {
				case 0:
					return alarmR.timeR;
				case 1:
					return alarmR.eventType;
				case 2:
					return alarmR.sourceClass;
				case 3:
					return alarmR.source;
				case 4:
					return alarmR.notifId;
				case 5:
					return alarmR.details;
				}
			}
			catch(Exception e) {}

            return new String();

        }

        /*
         * JTable uses this method to determine the default renderer/
         * editor for each cell.  If we didn't implement this method,
         * then the last column would contain text ("true"/"false"),
         * rather than a check box.
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * Don't need to implement this method unless your table's
         * editable.
         */
        public boolean isCellEditable(int row, int col) {
                return false;
        }

	public synchronized void updateAlarmTable(String dateR, String eventType,
					String source, String sourceClass,
					String notifId, String details) {

		//System.err.println("updateAlarmTable called.. NumRows = " +
		//		numRows + " NextEmptyRow = " + nextEmptyRow);
		AlarmRecord alarmR = new AlarmRecord(dateR, eventType, source,
					sourceClass,notifId, details);
		//alarmR.print();
	
		data.addElement(alarmR);

		if (data.size() == data.capacity()) {
		//	System.err.println("------->Alarm Vector capacity reached...");
			data.ensureCapacity(data.size() + 100);
		//	System.err.println("------->Alarm Vector new capacity is " + 
				//data.capacity());
		}

		//System.err.println("\t\tproceed to fire event to GUI...");
		numRows++;
		fireTableRowsInserted(nextEmptyRow, nextEmptyRow);
		nextEmptyRow++;
		//System.err.println("\t\t...Finished OK");
        }

		public synchronized void clear() {

			int oldNumRows = numRows;

			numRows = START_NUM_ROWS;
			data.removeAllElements();
			nextEmptyRow = 0;

			if (oldNumRows > START_NUM_ROWS)
				fireTableRowsDeleted(START_NUM_ROWS, oldNumRows - 1);

			fireTableRowsUpdated(0, START_NUM_ROWS - 1);
		}

       public void printDebugData() {

          int numRows = getRowCount();

	    AlarmRecord record ;
            for (int i=0; i < numRows; i++) {
		System.err.println("------> AlarmRecord" + i + " <-----------");
		record = (AlarmRecord) data.get(i);
		record.print();
	    }
        }

	private class AlarmRecord {

		String timeR = new String();
		String notifId = new String();
		String eventType = new String();
		String source = new String();
		String sourceClass = new String();
		String details = new String();

		AlarmRecord() {}
		AlarmRecord(String timeR, String eventType, String source,
					String sourceClass, String notifId, String details) {


			this.timeR = timeR;
			this.notifId = notifId;
			this.eventType = eventType;
			this.source = source;
			this.sourceClass = sourceClass;
			this.details = details;
		}

		void print() {
			System.err.println("Time =" + timeR +
					"\tEvent Type =" + eventType +
					"\tSource = " + source +
					"\tSourceClass = " + sourceClass +
					"\tId = " + notifId +
					"\tDetails = " + details);
		}

	}
}

