package ist.coach.coachEmfClientComponents.gui;

import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JTree;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.tree.*;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JSplitPane;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeModelListener;
import javax.swing.event.TreeModelEvent;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.JTextField;

import javax.swing.event.ListSelectionListener;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;

import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.MouseListener;
import java.awt.event.ActionListener;
import java.awt.event.ItemListener;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.Dimension;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Properties;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfClientComponents.InvokeSetData;
//import org.omg.CosNaming.NameComponent;

public class GuiClient extends JFrame
implements MouseListener, Runnable {

	GuiMaster master;
	private String name;
	//Hashtable objectVisualTypeTable;
	Properties objectVisualTypeProps;
	Hashtable actions_popups;
	Hashtable alarmTableH, logTableH;

 	final MOTree treePanel;

	private SubordinateListener subListener;
	private PropertiesListener propertiesListener;
	private DeleteListener deleteListener;
	private RefreshListener refreshListener;

	private AlarmTableModel alarmModel = null;
	private LogTableModel logModel = null;

	JCheckBoxMenuItem[] cbox_item;
	ClientListener clientListener;
	AlarmButtonListener alarmButtonListener;
	LogButtonListener logButtonListener;

	int logSelectedRow, logSelectedCol, alarmSelectedRow, alarmSelectedCol;
	JTextField logTextField, alarmTextField;


	private static final String typesConfigFile = "elementTypes.conf";

	public GuiClient(String name, 
			String root_name, GuiMaster master) {

		super(name);
		this.master = master;
		set_name(name);

		configure_data();
		clientListener = new  ClientListener();
		alarmButtonListener = new  AlarmButtonListener();
		logButtonListener = new  LogButtonListener();


		logTextField = new JTextField(60);
		logTextField.setEditable(false);
		logTextField.setBackground(java.awt.Color.LIGHT_GRAY);
		java.awt.Font textDisplayFont = logTextField.getFont();
		textDisplayFont = textDisplayFont.deriveFont((float) textDisplayFont.getSize()-1);
		logTextField.setFont(textDisplayFont);

		alarmTextField = new JTextField(60);
		alarmTextField.setEditable(false);
		alarmTextField.setBackground(java.awt.Color.LIGHT_GRAY);
		alarmTextField.setFont(textDisplayFont);

		treePanel = new MOTree(this, root_name);
		treePanel.setBorder(BorderFactory.createTitledBorder(GuiMessages.gui_client_mib));
		treePanel.addMouseListener(this);
		treePanel.tree.addMouseListener(this);

		AlarmTypeItemListener alarmTypeListener = new AlarmTypeItemListener();
		HeartbeatTypeItemListener heartbeatTypeItemListener = new HeartbeatTypeItemListener();

		LogTypeItemListener logTypeListener = new LogTypeItemListener();
        // Constructs and shows the GUI.

		JMenuBar centralBar = new JMenuBar();
		JMenu fileMenu = new JMenu("File");
		JMenuItem exitItem = new JMenuItem(GuiMessages.exit_str);
		exitItem.addActionListener(clientListener);
		fileMenu.add(exitItem);
		centralBar.add(fileMenu);
		setJMenuBar(centralBar);

			/** Setup the LOG Panel ****/
		JPanel logPanel = new JPanel();
		logPanel.setLayout(new BorderLayout());

				  // set up menu bar to hold log options
		JMenuBar logMenuBar = new JMenuBar();
		logMenuBar.setBorderPainted(true);
		logMenuBar.setBorder(BorderFactory.createLineBorder(java.awt.Color.black));
		logMenuBar.setMargin(new java.awt.Insets(0,0,0,0));

				  // set up log menu to filter logs
		JMenu logTypeMenu = new JMenu(GuiMessages.log_menu_title);
		logTypeMenu.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));

		logTypeMenu.getAccessibleContext().setAccessibleDescription(
			GuiMessages.log_filter_event_types);

		cbox_item = new JCheckBoxMenuItem[logTableH.size()];
		int j = 0;
		for (Enumeration e = logTableH.keys(); e.hasMoreElements();) {
			cbox_item[j] = new JCheckBoxMenuItem((String) e.nextElement(), true);
			cbox_item[j].addItemListener(logTypeListener);
			logTypeMenu.add(cbox_item[j]);
			j++;
		}
		logMenuBar.add(logTypeMenu);
			    // add archives button to LogTable
		JButton log_archives_button = new JButton(GuiMessages.log_archives_title);
		log_archives_button.addActionListener(logButtonListener);
		log_archives_button.setToolTipText(GuiMessages.log_archives_tooltip_str);
		logMenuBar.add(log_archives_button);

				// add clear button to Log Table
		logMenuBar.add(javax.swing.Box.createHorizontalGlue());
		JButton log_clear_button = new JButton(GuiMessages.clear_str);
        log_clear_button.addActionListener(logButtonListener);
        log_clear_button.setToolTipText(GuiMessages.clear_tooltip_str);
		logMenuBar.add(log_clear_button);


				// Setup thr log Tanle panel....
		JLogTable logTable = new JLogTable(logModel);
		logTable.setPreferredScrollableViewportSize(new Dimension(700, 150)); //700, 200
		logTable.setCellSelectionEnabled(false);
		//logTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);

		logTable.getColumnModel().getColumn(AlarmTableModel.TIME_C).setPreferredWidth(120);
		logTable.getColumnModel().getColumn(AlarmTableModel.EVENT_C).setPreferredWidth(100);
		logTable.getColumnModel().getColumn(AlarmTableModel.SOURCE_C).setPreferredWidth(200);
		logTable.getColumnModel().getColumn(AlarmTableModel.SOURCE_T_C).setPreferredWidth(100);
		logTable.getColumnModel().getColumn(AlarmTableModel.ID_C).setPreferredWidth(60);
		logTable.getColumnModel().getColumn(AlarmTableModel.DETAILS_C).setPreferredWidth(120);

        JScrollPane scrollPane = new JScrollPane(logTable);
/** get selections **/
		logTable.getColumnModel().getSelectionModel().
			addListSelectionListener( new ListSelectionListener() {

  				public void valueChanged(ListSelectionEvent e) {

      				if(e.getValueIsAdjusting()) return;
				 	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
					if (! lsm.isSelectionEmpty()) {
						logSelectedCol = lsm.getMinSelectionIndex();
						if (logModel.getValueAt(logSelectedRow, logSelectedCol) != null)
							logTextField.setText((String) logModel.getValueAt(
									logSelectedRow, logSelectedCol)); 
					}
      			}
    	});
		logTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

  			public void valueChanged(ListSelectionEvent e) {

      				if(e.getValueIsAdjusting()) return;
				 	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
					if (! lsm.isSelectionEmpty()) {
						logSelectedRow = lsm.getMinSelectionIndex();
						if (logModel.getValueAt(logSelectedRow, logSelectedCol) != null)
							logTextField.setText((String) logModel.getValueAt(													logSelectedRow, logSelectedCol)); 
					}
			} 
			}
		);
/** end - get selections **/
        scrollPane.setPreferredSize(new Dimension(250, 150)); //300, 500
        scrollPane.setMinimumSize(new Dimension(100, 100));
        logPanel.add(logMenuBar, BorderLayout.NORTH);
        logPanel.add(scrollPane);

        logPanel.add(logTextField, BorderLayout.SOUTH);
        logPanel.setBorder(BorderFactory.createTitledBorder(GuiMessages.gui_client_log));


					/****Position Log Panel ***/
		JSplitPane splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
				treePanel, logPanel);
		splitPane.setOneTouchExpandable(true);
        splitPane.setDividerLocation(150);

		//Provide a preferred size for the split pane
        splitPane.setPreferredSize(new Dimension(700, 400)); //700, 500
        getContentPane().add(splitPane);

				/* Setup the Alarm Panel */
		  // set up menu bar to hold alarm options
		JMenuBar alarmMenuBar = new JMenuBar();
		alarmMenuBar.setBorderPainted(true);
		alarmMenuBar.setBorder(BorderFactory.createLineBorder(java.awt.Color.black));
		alarmMenuBar.setMargin(new java.awt.Insets(0,0,0,0));

		  // set up alarm menu to subscribe/unsubscribe to alarms
		JMenu alarmTypeMenu = new JMenu(GuiMessages.alarm_menu_title);
		alarmTypeMenu.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));

		alarmTypeMenu.getAccessibleContext().setAccessibleDescription(
			GuiMessages.alarm_filter_event_types);

		cbox_item = new JCheckBoxMenuItem[alarmTableH.size()];
		int k = 0;
		for (Enumeration e = alarmTableH.keys(); e.hasMoreElements();) {
			cbox_item[k] = new JCheckBoxMenuItem((String) e.nextElement(), true);
			cbox_item[k].addItemListener(alarmTypeListener);
			alarmTypeMenu.add(cbox_item[k]);
			k++;
		}
		alarmMenuBar.add(alarmTypeMenu);

		  // set up heatbeat period options
	    JMenu heartbeatTypeMenu = new JMenu(GuiMessages.heartbeat_menu_title);
		heartbeatTypeMenu.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));

		javax.swing.ButtonGroup group = new javax.swing.ButtonGroup();
		heartbeatTypeMenu.getAccessibleContext().setAccessibleDescription(
			GuiMessages.heartbeat_tooltip_str);
		JRadioButtonMenuItem[] heartbeat_items = new JRadioButtonMenuItem[5];
		heartbeat_items[0] = new JRadioButtonMenuItem(GuiMessages.heartbeat_period_200, false);
		heartbeat_items[1] = new JRadioButtonMenuItem(GuiMessages.heartbeat_period_100, true);
		heartbeat_items[2] = new JRadioButtonMenuItem(GuiMessages.heartbeat_period_50, false);
		heartbeat_items[3] = new JRadioButtonMenuItem(GuiMessages.heartbeat_period_20, false);
		heartbeat_items[4] = new JRadioButtonMenuItem(GuiMessages.heartbeat_period_0, false);

		for (int h = 0; h <  heartbeat_items.length; h++) {
		    heartbeat_items[h].addItemListener(heartbeatTypeItemListener);
			group.add(heartbeat_items[h]);
			heartbeatTypeMenu.add(heartbeat_items[h]);
		}
		alarmMenuBar.add(heartbeatTypeMenu);

		// add clear button
		alarmMenuBar.add(javax.swing.Box.createHorizontalGlue());
		JButton clear_button = new JButton(GuiMessages.clear_str);
        clear_button.addActionListener(alarmButtonListener);
        clear_button.setToolTipText(GuiMessages.clear_tooltip_str);
		alarmMenuBar.add(clear_button);


		JPanel alarmPanel = new JPanel();
		alarmPanel.setLayout(new BorderLayout());

		JAlarmTable alarmTable = new JAlarmTable(alarmModel);
		alarmTable.setPreferredScrollableViewportSize(new Dimension(700, 150)); //700, 200
		alarmTable.setCellSelectionEnabled(false);
		//alarmTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
		alarmTable.getColumnModel().getColumn(AlarmTableModel.TIME_C).setPreferredWidth(120);
		alarmTable.getColumnModel().getColumn(AlarmTableModel.EVENT_C).setPreferredWidth(100);
		alarmTable.getColumnModel().getColumn(AlarmTableModel.SOURCE_C).setPreferredWidth(100);
		alarmTable.getColumnModel().getColumn(AlarmTableModel.SOURCE_T_C).setPreferredWidth(100);
		alarmTable.getColumnModel().getColumn(AlarmTableModel.ID_C).setPreferredWidth(60);
		alarmTable.getColumnModel().getColumn(AlarmTableModel.DETAILS_C).setPreferredWidth(220);
/** get selections **/
		alarmTable.getColumnModel().getSelectionModel().
			addListSelectionListener( new ListSelectionListener() {

  				public void valueChanged(ListSelectionEvent e) {

      				if(e.getValueIsAdjusting()) return;
				 	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
					if (! lsm.isSelectionEmpty()) {
						alarmSelectedCol = lsm.getMinSelectionIndex();
						if (alarmModel.getValueAt(alarmSelectedRow, alarmSelectedCol) != null)
							alarmTextField.setText((String) alarmModel.getValueAt(
								alarmSelectedRow, alarmSelectedCol)); 
					}
      			}
    	});
		alarmTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

  			public void valueChanged(ListSelectionEvent e) {

      				if(e.getValueIsAdjusting()) return;
				 	ListSelectionModel lsm = (ListSelectionModel)e.getSource();
					if (! lsm.isSelectionEmpty()) {
						alarmSelectedRow = lsm.getMinSelectionIndex();
						if (alarmModel.getValueAt(alarmSelectedRow, alarmSelectedCol) != null)
							alarmTextField.setText((String) alarmModel.getValueAt(												alarmSelectedRow, alarmSelectedCol)); 
					}
			} 
			}
		);
/** end - get selections **/
        JScrollPane alarmScrollPane = new JScrollPane(alarmTable);

        alarmScrollPane.setPreferredSize(new Dimension(200, 150));
        alarmScrollPane.setMinimumSize(new Dimension(10, 10));
        alarmPanel.add(alarmMenuBar, BorderLayout.NORTH);
        alarmPanel.add(alarmScrollPane);
		alarmPanel.add(alarmTextField, BorderLayout.SOUTH);
        alarmPanel.setBorder(BorderFactory.createTitledBorder(GuiMessages.gui_client_alarms));

		JSplitPane alarmSplitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT,
			splitPane, alarmPanel);
		alarmSplitPane.setOneTouchExpandable(true);
			//300
        alarmSplitPane.setDividerLocation(400);

		getContentPane().add(alarmSplitPane);


		subListener = new SubordinateListener(this);
		propertiesListener = new PropertiesListener();
		deleteListener = new DeleteListener();
		refreshListener = new RefreshListener();


		// update tree model
		String[] children = getContained(
			((MOTreeObject) treePanel.rootNode.getUserObject()).key());

        if (children != null && children.length > 0) {
            for(int i = 0; i < children.length; i++)
                create(treePanel.rootNode, children[i]);
        }
		pack();
		show();

	}

	//HACK THREAD
	public void run() {}
	public void configure_data() {

		// HACK - needs improvement
		// this part could be externally configured through
		// properties file
		//

		objectVisualTypeProps = new Properties();
		try {
			System.out.println("Loading file " + typesConfigFile);
			objectVisualTypeProps.load(GuiClient.class.getResourceAsStream(typesConfigFile));
		}
		catch (Exception e) {
			e.printStackTrace();
			return;
		}

		//objectVisualTypeTable = new Hashtable();
		actions_popups = new Hashtable();
		alarmTableH = new Hashtable();
		logTableH = new Hashtable();

		alarmModel = new AlarmTableModel();
		logModel = new LogTableModel();
/**********************************
		objectVisualTypeTable.put("ManagedObject",
			"ist.coach.coachEmfClientComponents.gui.MOTreeObject");

		objectVisualTypeTable.put("ManagedElement",
			"ist.coach.coachEmfClientComponents.gui.VisualManagedElement");

		objectVisualTypeTable.put("IpNode",
			"ist.coach.coachEmfClientComponents.gui.VisualIpNode");

		objectVisualTypeTable.put("LogicalInterface",
			"ist.coach.coachEmfClientComponents.gui.VisualLogicalInterface");

		objectVisualTypeTable.put("IpProtocolMonitor",
			"ist.coach.coachEmfClientComponents.gui.VisualIpProtocolMonitor");

		objectVisualTypeTable.put("IpAddressData",
			 "ist.coach.coachEmfClientComponents.gui.VisualIpAddressData");

		objectVisualTypeTable.put("IpRoutingEntry",
			 "ist.coach.coachEmfClientComponents.gui.VisualIpRoutingEntry");

		objectVisualTypeTable.put("IpToMACAddress",
			   "ist.coach.coachEmfClientComponents.gui.VisualIpToMACAddress");
********************************************/
		alarmTableH.put(GuiMessages.object_creation_alarm,
							GuiMaster.OBJECT_CREATION_ALARM);
        alarmTableH.put(GuiMessages.object_deletion_alarm,
							GuiMaster.OBJECT_DELETION_ALARM);
        alarmTableH.put(GuiMessages.state_changed_alarm,
							GuiMaster.STATE_CHANGED_ALARM);
        alarmTableH.put(GuiMessages.operation_violation_alarm,
							GuiMaster.OPERATIONAL_ALARM);
        alarmTableH.put(GuiMessages.channel_change_alarm,
							GuiMaster.CHANNEL_CHANGE_ALARM);
        alarmTableH.put(GuiMessages.heartbeat_alarm,
							GuiMaster.HEARTBEAT_ALARM);

		logTableH.put(GuiMessages.info_log,
							GuiMaster.INFO_LOG);
		logTableH.put(GuiMessages.error_log,
							GuiMaster.ERROR_LOG);
		logTableH.put(GuiMessages.warning_log,
							GuiMaster.WARNING_LOG);
	}

	public void set_name(String name) {
		this.name = name;
		setTitle(name);
	}

	public synchronized void print(String dateR, String eventType, String source,
			String sourceClass, String notifId, String details) {

	  //System.err.println("GuiClient> print log event is called...");
	  if (logModel == null)
			return;
		//System.err.println("GuiClient> print proceed to update log table...");
		logModel.updateLogTable(dateR,
						eventType,
						source,
						sourceClass,
						notifId,
						details);
	}
	public static synchronized void println(String msg) {
		System.err.println(msg);

	}

	public synchronized void print_alarm(String dateR, String eventType, String source,
			String sourceClass, String notifId, String details) {


		if (alarmModel == null)
			return;

		alarmModel.updateAlarmTable(dateR,
					eventType,
					source,
					sourceClass,
					notifId,
					 details);

	}


public JPopupMenu get_menu(String visual_class_name) {

	if (actions_popups.containsKey(visual_class_name))
		return (JPopupMenu) actions_popups.get(visual_class_name);

	// else proceed to create
	//
	JPopupMenu popup = new JPopupMenu();
	String[] subordinate_names = null;
	Class object_class = null;
	boolean canRefresh = false;
	try {
		object_class =  Class.forName(visual_class_name);
		subordinate_names =
                    (String[])object_class.
                                getDeclaredField("subordinate_names").get(null);
		canRefresh = (boolean) ((Boolean) object_class.
                                getDeclaredField("canRefresh").get(null)).booleanValue();
	}
	catch(java.lang.ClassNotFoundException ex1) {
		System.err.println("mouseClicked> ClassNotFoundException " +
		ex1.getMessage());
	}
	catch(java.lang.IllegalAccessException ex2) {
		System.err.println("mouseClicked> IllegalAccessException " +
		ex2.getMessage());
	}
	catch(java.lang.NoSuchFieldException ex3) {
		System.err.println("mouseClicked> NoSuchFieldException " +
        		ex3.getMessage());
       		//	ex3.printStackTrace();
	}


           // If managers can create subordinate objects
    if (subordinate_names.length > 0) {
       JMenu create_menu = new JMenu(GuiMessages.options_create);
       JMenuItem subordinate;
        for (int i = 0; i < subordinate_names.length; i++) {
			  if (objectVisualTypeProps.getProperty(subordinate_names[i])== null)
					  continue;
              subordinate = new JMenuItem(subordinate_names[i]);
              subordinate.addActionListener(subListener);
              create_menu.add(subordinate);
        }
        popup.add(create_menu);
    }

    JMenuItem properties_item = new JMenuItem(GuiMessages.options_properties);
    properties_item.addActionListener(propertiesListener);
    popup.add(properties_item);

    JMenuItem delete_item = new JMenuItem(GuiMessages.options_delete);
    delete_item.addActionListener(deleteListener);
    popup.add(delete_item);

	if (canRefresh) {
		JMenuItem refresh_item = new JMenuItem(GuiMessages.options_refresh);
    	refresh_item.addActionListener(refreshListener);
    	popup.add(refresh_item);
	}
	actions_popups.put(visual_class_name, popup);
	return popup;
}

public String getObjectType(String key) {

	//System.err.println("getObjectType called for " + key);
	String obj_type = new String();
	//String obj_type = MOTreeObject.object_type;
	String label = key;

	int lastIndex = key.lastIndexOf("/");
	int objIndex = 0;
	if (lastIndex > 0) {
        String object_id = key.substring(0, lastIndex);
        if (object_id != null && object_id.length() > 0 &&
                (objIndex = object_id.lastIndexOf("/")) > 0) {

						// label contains both name and kind

                label = object_id.substring(objIndex+1);
        }
	}
	if (label!= null && label.length() > 0) {
    	lastIndex =label.lastIndexOf(".");

    	if (lastIndex > 0)
        	obj_type = label.substring(lastIndex+1);
    }

	return obj_type;
}

public String[] getContained(String key) {
	return master.getContained(key);
}

//
// this operation is called by the GUI on start-up for recursive creation
//
public void create(DefaultMutableTreeNode parent, String key) {

	DefaultMutableTreeNode node  = create(parent, key, getObjectType(key));
	String [] children = master.getContained(key);
	for (int i = 0; i < children.length; i++)
		create(node, children[i]);
}

//
// this operation is called by the recursive create on start-up
//
public DefaultMutableTreeNode create(DefaultMutableTreeNode parent,
		String key,  String obj_type) {

	DefaultMutableTreeNode node = new DefaultMutableTreeNode();
   // String visual_class = (String) objectVisualTypeTable.get(obj_type);
	String visual_class = (String) objectVisualTypeProps.getProperty(obj_type);
	//System.err.println("Visually create " + visual_class + " with key= " + key);

    Class vtype;
    Class[] consArgsClass = new Class[] {String.class};
    java.lang.reflect.Constructor vtype_constructor;

    try {
        vtype = Class.forName(visual_class);
        vtype_constructor = vtype.getConstructor(consArgsClass);
        node = treePanel.addObject(parent, vtype_constructor.newInstance(new Object[] {key}));

        //treePanel.addObject(new MOTreeObject(key));
        //treePanel.addObject(new MOTreeObject(key, obj));
    }
    catch(java.lang.IllegalArgumentException e1) {
            System.err.println("IllegalArgumentException");
    }
    catch(java.lang.IllegalAccessException e2) {
            System.err.println("IllegalAccessException");
    }
    catch(java.lang.ClassNotFoundException e3) {
            System.err.println("ClassNotFoundException");
    }
    catch(java.lang.NoSuchMethodException e4) {
          System.err.println("NoSuchMethodException");
    }
    catch(java.lang.InstantiationException e5) {
          System.err.println("InstantiationException");
    }
    catch(java.lang.reflect.InvocationTargetException e6) {
          System.err.println("InvocationTargetException:" + e6.getMessage());
            e6.printStackTrace();
    }

	return node;
}

public void create(String key, String obj_type) {

	//String visual_class = (String) objectVisualTypeTable.get(obj_type);
	String visual_class = (String) objectVisualTypeProps.getProperty(obj_type);

	Class vtype;
	Class[] consArgsClass = new Class[] {String.class};
	java.lang.reflect.Constructor vtype_constructor;

	try {
		vtype = Class.forName(visual_class);
		vtype_constructor = vtype.getConstructor(consArgsClass);
		treePanel.addObject(vtype_constructor.newInstance(new Object[] {key}));

		//treePanel.addObject(new MOTreeObject(key));
		//treePanel.addObject(new MOTreeObject(key, obj));
	}
	catch(java.lang.IllegalArgumentException e1) {
            System.err.println("IllegalArgumentException");
    }
    catch(java.lang.IllegalAccessException e2) {
            System.err.println("IllegalAccessException");
    }
    catch(java.lang.ClassNotFoundException e3) {
            System.err.println("ClassNotFoundException");
    }
    catch(java.lang.NoSuchMethodException e4) {
          System.err.println("NoSuchMethodException");
    }
    catch(java.lang.InstantiationException e5) {
          System.err.println("InstantiationException");
    }
    catch(java.lang.reflect.InvocationTargetException e6) {
          System.err.println("InvocationTargetException:" + e6.getMessage());
			e6.printStackTrace();
    }

}

/*
 * MouseListener Operations
 *
 */
    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

public void mouseClicked(MouseEvent e) {

        if (javax.swing.SwingUtilities.isRightMouseButton(e)) {
			JPopupMenu popup = null;

				String object_class = treePanel.getCurrentTreeSelection().
					getUserObject().getClass().getName();
				popup = get_menu(object_class);

			if (popup != null) {
            	popup.show(e.getComponent(),
                e.getX(), e.getY());
        	}
			else
				System.err.println("popup is null or event doesn't trigger popup");
    }
}

protected String getClassName(Object o) {
        String classString = o.getClass().getName();
        int dotIndex = classString.lastIndexOf(".");
        return classString.substring(dotIndex+1);
}

public void showAttributesError(String error_str) {

		JOptionPane.showMessageDialog(treePanel,
			error_str,
			GuiMessages.options_properties,
			JOptionPane.WARNING_MESSAGE);
}

public void showCreateError(String error_str) {

		JOptionPane.showMessageDialog(treePanel,
			error_str,
			GuiMessages.options_create,
			JOptionPane.WARNING_MESSAGE);
}

public void showDeleteError(String error_str) {

		JOptionPane.showMessageDialog(treePanel,
			error_str,
			GuiMessages.options_delete,
			JOptionPane.WARNING_MESSAGE);
}

private class SubordinateListener implements ActionListener {

	GuiClient parent = null;
	public SubordinateListener(GuiClient parent) {
		this.parent = parent;
	}

    public void actionPerformed(ActionEvent e) {

/*****
        println("Subordinate action has been caught!");
        String s = "Action event detected."
                   + "\n"
                   + "    Event source: " + source.getText()
                   + " (an instance of " + getClassName(source) + ")";

        println(s + "\n");
		println("Parent node : " +
			((MOTreeObject) treePanel.getCurrentTreeSelection().getUserObject()).key());

			// GuiMessages.options_create,
			//MOTreeObject.create_arg_name,
			//MOTreeObject.create_arg_editor, master,
******/

        JMenuItem source = (JMenuItem)(e.getSource());
		//String visual_class = (String) objectVisualTypeTable.get(source.getText());
		String visual_class = (String) objectVisualTypeProps.getProperty(source.getText());

		//String visual_class = treePanel.getCurrentTreeSelection().getUserObject().getClass().getName();
		//println("Object to be created = " + visual_class);
//HACK THREAD
/****
		CreateParamsFrame createFrame = new CreateParamsFrame(
			visual_class,
		((MOTreeObject) treePanel.getCurrentTreeSelection().getUserObject()).key(),
				master,
				parent,
				source.getX(), source.getY());
******/
	  new Thread(new CreateParamsFrame(
			visual_class,
			((MOTreeObject) treePanel.getCurrentTreeSelection().getUserObject()).key(),
			master,
			parent,
			source.getX(), source.getY()));

    }
}
private class PropertiesListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {

        JMenuItem source = (JMenuItem)(e.getSource());

		try {
			MOTreeObject tree_object = (MOTreeObject) treePanel.getCurrentTreeSelection().getUserObject();
			String v_class = tree_object.getClass().getName();

			String object_class = (String)Class.forName(v_class).getDeclaredField("object_type").get(null);

			//System.err.println("GuiClient>  attributeGet is called for " +
			//			object_class + " " + tree_object.key() + "...");

			intt.itu.itut_x780.ManagedObjectValueType attributes =
				master.attributesGet(
					object_class,
					tree_object.key(),
			 		new String[0]);

			if (attributes == null) {
				showAttributesError(GuiMessages.reply_error);
				return;
			}

			Object[] values = tree_object.translate_values(attributes);

			if (values.length > 0)
				new AttributesFrame(v_class, //tree_object.key(),
						tree_object,
                       values, master,
                       source.getX(), source.getY());
			else
				showAttributesError(GuiMessages.reply_error);

		}
		catch(java.lang.ClassNotFoundException e1) {
			System.err.println("java.lang.ClassNotFoundException");
		}
		catch(java.lang.NoSuchFieldException e2) {
			 System.err.println("java.lang.NoSuchFieldException ");
		}
		 catch(java.lang.IllegalAccessException e3) {
            System.err.println("IllegalAccessException");
        }
		catch(java.lang.IllegalArgumentException e4) {
            System.err.println("IllegalArgumentException");
        }

    }
}
private class DeleteListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {

        JMenuItem source = (JMenuItem)(e.getSource());
		DefaultMutableTreeNode selection = treePanel.getCurrentTreeSelection();
		String object_key = ((MOTreeObject) selection.getUserObject()).key();

		boolean res = master.removeByManager(object_key);


		if (res) {
			//println(object_key + "removed ok");
			treePanel.removeCurrentNode();

			JOptionPane.showMessageDialog(treePanel,
               GuiMessages.reply_ok,
               GuiMessages.options_delete,
               JOptionPane.WARNING_MESSAGE);
		}
    }
}

private class RefreshListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {

	    try {

            MOTreeObject tree_object =
					(MOTreeObject) treePanel.getCurrentTreeSelection().getUserObject();
            String v_class = tree_object.getClass().getName();

			System.err.println("Class = " + v_class);

            String object_class = (String) tree_object.getClass().
				getDeclaredField("object_type").get(null);

			String[] param_name  = (String [])
					tree_object.getClass().getDeclaredField("create_arg_name").get(null);

			String obj_key = tree_object.key();

            intt.itu.itut_x780.ManagedObjectValueType attributes =
                master.attributesGet(
                    object_class,
					obj_key,
                    new String[0]);

			if (attributes == null) {
                showAttributesError(GuiMessages.reply_error);
                return;
            }


			DefaultMutableTreeNode parent_node =
				(DefaultMutableTreeNode) treePanel.getCurrentTreeSelection().getParent();
			MOTreeObject superior_object = (MOTreeObject) parent_node.getUserObject();
			//(MOTreeObject) treePanel.getCurrentTreeSelection().getParent().getUserObject();

			System.err.println("Superior object key = " + superior_object.key());
			System.err.println("object key = " + obj_key);
			boolean res = master.removeByManager(obj_key);

					//delete from Gui
			treePanel.removeCurrentNode();

			String[] values = new String[0];
			if (object_class.equals("IpNode")) {

				ist.coach.coachEmsMib.IpNodeValueType ipnode_attributes =
						(ist.coach.coachEmsMib.IpNodeValueType) attributes;
				values = new String[12];
				values[0] =  new String(Utils.name2id(obj_key));
				values[1] = new String(ipnode_attributes.domainName);
				values[2] = new String(ipnode_attributes.hostname);
				values[3] = new String(ipnode_attributes.managementIPAddress);
				values[4] = String.valueOf(ipnode_attributes.supportedSnmpVersions);
				values[5] = new String(ipnode_attributes.userLabel);
				values[6] = new String(ipnode_attributes.vendorName);
				values[7] = new String(ipnode_attributes.version);
				values[8] = new String(ipnode_attributes.locationName);
				values[9] = String.valueOf(ipnode_attributes.snmpPort);
				values[10] = new String(ipnode_attributes.sysName);
				values[11] = new String(ipnode_attributes.sysContact);
/**********
				for(int k = 0; k < values.length; k++)
					System.err.println("---->VALUE[" + k + "] =  " +
					  					values[k]);
************/
			}
			String new_object_name = master.createByManager(object_class,
                param_name,  values, superior_object.key());

					// repaint in Gui
			create(obj_key, object_class);

 		}
        catch(java.lang.NoSuchFieldException e2) {
             System.err.println("java.lang.NoSuchFieldException ");
        }
         catch(java.lang.IllegalAccessException e3) {
            System.err.println("IllegalAccessException");
        }
        catch(java.lang.IllegalArgumentException e4) {
            System.err.println("IllegalArgumentException");
        }

    }
}

private class ClientListener implements ActionListener {

    public void actionPerformed(ActionEvent e) {
		JMenuItem source = (JMenuItem)(e.getSource());
		if (source.getText().equals(GuiMessages.exit_str)) {
			System.exit(0);
		}
	}
}

private class LogTypeItemListener implements ItemListener {
	public void itemStateChanged(ItemEvent e) {

		JCheckBoxMenuItem source = (JCheckBoxMenuItem)(e.getItem());
		if (e.getStateChange() == ItemEvent.SELECTED) {
			master.subscribe_log((String) logTableH.get(source.getText()));
		}
		else
			master.unsubscribe_log((String) logTableH.get(source.getText()));

	}
}

private class AlarmButtonListener implements ActionListener {

    public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) (e.getSource());
		if (source.getText().equals(GuiMessages.clear_str)) {
            alarmModel.clear();
        }
	}
}
private class LogButtonListener implements ActionListener {

    public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) (e.getSource());
		if (source.getText().equals(GuiMessages.clear_str)) {
            logModel.clear();
        }
		else {
		  if (source.getText().equals(GuiMessages.log_archives_title)) {
		    new Thread(new LogArchiveFrame(
			  master,
			  source.getX(), source.getY()));
		  }
		}
	}
}
private class AlarmTypeItemListener implements ItemListener {
	public void itemStateChanged(ItemEvent e) {

		JCheckBoxMenuItem source = (JCheckBoxMenuItem)(e.getItem());
		if (e.getStateChange() == ItemEvent.SELECTED) {
			master.subscribe_alarm((String) alarmTableH.get(source.getText()));
		}
		else
			master.unsubscribe_alarm((String) alarmTableH.get(source.getText()));

	}
}

private class HeartbeatTypeItemListener implements ItemListener {
	public void itemStateChanged(ItemEvent e) {

		JRadioButtonMenuItem source = (JRadioButtonMenuItem)(e.getItem());
		if (e.getStateChange() == ItemEvent.SELECTED) {
		    short period = 100;
		    if (source.getText().equals(GuiMessages.heartbeat_period_200))
			  period = 200;
			else
			if (source.getText().equals(GuiMessages.heartbeat_period_100))
			  period = 100;
			else
			if (source.getText().equals(GuiMessages.heartbeat_period_50))
			  period = 50;
			else
			if (source.getText().equals(GuiMessages.heartbeat_period_20))
			  period = 20;
			else
			if (source.getText().equals(GuiMessages.heartbeat_period_0))
			  period = 0;

			master.set_heartbeat_period(period);
		}
	  }
}

}
