/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmfServicesComponents.BasicLogProviderComposition;

import ist.coach.coachEmfServices.EmfBasicLog.*;
import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.LogNewRecordImpl;
import org.omg.CORBA.Any;
import java.sql.*;

import java.util.Calendar;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmfServicesComponents/BasicLogProviderComposition/BasicLogProviderHome_impl/BasicLogProvider_impl/basicLogSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class basicLogSegImpl
     extends ist.coach.coachEmfServicesComponents.BasicLogProviderComposition.basicLogSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

	private boolean 		logOffDuty_ = false;
	private boolean 		logLocked_ = false; 		// administrative state
	private boolean 		logDisabled_ = false; 		// operational state
	private long 		    dbTableMaxSize_ = -1;



    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public basicLogSegImpl()
    {
	}

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::BasicLog::destroy operation.
     */
    public void
    destroy()
    {
        //
        // DONE : Implement
        //
		try {
		  get_main_segment().ccm_remove();
		}
		catch(org.omg.Components.CCMException e) {}
    }

	    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::BasicLog::write_record operation.
     */
    public long
    write_record(org.omg.CORBA.Any record, ist.coach.coachEmfServices.EmfBasicLog.NVPair[] nv)
    throws ist.coach.coachEmfServices.EmfBasicLog.LogFull,
        ist.coach.coachEmfServices.EmfBasicLog.LogOffDuty,
        ist.coach.coachEmfServices.EmfBasicLog.LogLocked,
        ist.coach.coachEmfServices.EmfBasicLog.LogDisabled
    {
	    //
        // DONE : Implement
        //
		//System.err.println("basicLogSegImpl>write record called!!");
		long recordId = -1;

	    if (record == null)
			return recordId;

		if ( logOffDuty_  )
			throw new LogOffDuty();

		if ( logLocked_  )
			throw new LogLocked();

		if ( logDisabled_ ) {
			throw new LogDisabled();
		}


		// Connect to JDBC driver
		try
		{
			Class.forName(get_main_segment().databaseDriver()).newInstance();
        	}
		catch (Exception ex)
		{
			System.out.println("** BasicLogImpl: <EXCEPTION> While connecting to jdbx driver");
			System.out.println(ex.getMessage());
			return -1;
		}

		Connection dbConnection = null;

		// Perform test for LogFull
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());
		try	{

		  dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
		  Statement  dbTestStatement = dbConnection.createStatement();
		  ResultSet  dbTestResults = dbTestStatement.executeQuery("SHOW TABLE STATUS");

		  while (dbTestResults.next()) {
				if ( dbTestResults.getString(1).equalsIgnoreCase(logTableName) ) {
					long avgRowLength = dbTestResults.getLong(5);
					long dataLength = dbTestResults.getLong(6);
					long maxDataLength = dbTestResults.getLong(7);
					dbTableMaxSize_ = maxDataLength;
					short numOfRows = dbTestResults.getShort(4);

					if ( maxDataLength <= (dataLength + avgRowLength) ){
						LogFull ex_logFull = new LogFull(numOfRows);
						throw ex_logFull;
					}
				}
			}
		}
		catch (Exception ex){
			System.err.println("** BasicLogImpl: <EXCEPTION> While connecting to jdbx driver");
			System.err.println(ex.getMessage());
			return -1;
		}

		PreparedStatement dbStatement = null;

		try {
		    dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());

			dbStatement = dbConnection.prepareStatement("INSERT INTO " + logTableName +
										" (logRecordId, timeStamp, logDataType, logData)" +
										" VALUES(? , ?, ?, ?)"	);
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl: <EXCEPTION> While getting db connection");
			System.err.println(ex.getMessage());
			return -1;
		}

		AnyTypeTrans AT = new AnyTypeTrans();

		// For the received event extract the information based on the
		// 'LogRecord'(defined in Log.idl) and stored it in the given log
		// database and table.

		int anyKindInt = -1;

		Any receivedLogInfo = record;

		// Create timestamp
		java.util.Date currentDateTime = (java.util.Date) Calendar.getInstance().getTime();
		recordId = currentDateTime.getTime();
		java.sql.Timestamp logTimestamp = new java.sql.Timestamp(currentDateTime.getTime());
		String logTimestampStr = logTimestamp.toString();

		try	{

			dbStatement.setLong(1, recordId);
			dbStatement.setString(2, logTimestampStr);
			anyKindInt = AT.toDB(dbStatement, 4, record);

			dbStatement.setInt(3, anyKindInt);

			int res = dbStatement.executeUpdate();
		}
		catch (Exception ex)
		{
			System.err.println("** BasicLogImpl: <EXCEPTION> While getting db connection");
			System.err.println(ex.getMessage());
			return -1;
		}

		if ( nv != null && nv.length > 0) {
			String tblName = logTableName + "NVPairs";
			boolean tblExists = false;

			try {

    				Statement  dbTblCreateStatement = dbConnection.createStatement();

    				ResultSet  queryRes = dbTblCreateStatement.executeQuery("SHOW TABLES");

				while ( queryRes.next() )
				{
					if ( queryRes.getString(1).equalsIgnoreCase(tblName) ) {
						tblExists = true;
						break;
					}
				}

				if ( ! tblExists ) {
					String sqlStr = 	"CREATE TABLE " + tblName  +
								" (logRecordId BIGINT, " +
								"NVPairName VARCHAR(30), " +
								"NVPairValueType TINYINT, " +
								"NVPairValue BLOB)";

					  dbTblCreateStatement.execute(sqlStr);
				}

				dbStatement = dbConnection.prepareStatement(
					    "INSERT INTO " + tblName +
						" (logRecordId, NVPairName, NVPairValueType, NVPairValue)" +
						" VALUES(? , ?, ?, ?)"	);

				for(int i = 0; i < nv.length; i++) {

				  dbStatement.setLong(1, recordId);

				  dbStatement.setString(2, nv[i].name);
				  if ( nv[i].value != null ) {
					anyKindInt = AT.toDB(dbStatement, 4, nv[i].value);
				  }
				  else {
					dbStatement.setString(4, null);
				  }

				  dbStatement.setInt(3, anyKindInt);

				  int res = dbStatement.executeUpdate();
				}
			}
			catch (SQLException ex) {
            		System.err.println("*** basicLogSegImpl : SQLException: " + ex.getMessage());
            		System.err.println("*** basicLogSegImpl : SQLState: " + ex.getSQLState());
            		System.err.println("*** basicLogSegImpl : VendorError: " + ex.getErrorCode());
					return -1;
			}
		}
		LogNewRecordImpl log_newRecord_event = new LogNewRecordImpl();
		log_newRecord_event.eventTime =	new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);
		try {
		  for(int i = 0; i < nv.length; i++) {
		    if (nv[i].name.equals("Source"))
			  log_newRecord_event.source = Utils.string2name(nv[i].value.extract_string());
		   else
		   if (nv[i].name.equals("SourceClass"))
			  log_newRecord_event.sourceClass = nv[i].value.extract_string();
		   else
		   if (nv[i].name.equals("EventType"))
			  log_newRecord_event.severity = LogSeverity.from_int(nv[i].value.extract_short());
		   else
			  System.err.println("basicLogSegImpl> Unknown NVPair attribute...");
		  }
		  log_newRecord_event.logRecordId = recordId;
		  log_newRecord_event.info = record.extract_string();
		}
		catch(Exception e) {
		  System.err.println("basicLogSegImpl>write_record: Problem extracting logRecord data" + e.getMessage());
		  return -1;
		}


		get_context().push_log_newRecord(log_newRecord_event);

		return recordId;
    }


    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::id operation.
     */
    public int
    id()
    {
        //
        // DONE : Implement
        //
        return get_main_segment().logId();
    }

   /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_display_name operation.
     */
	public String
	get_display_name() {

	  return get_main_segment().display_name();
	}
    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_log_qos operation.
     */
    public short[]
    get_log_qos()
    {
        //
        // TO BE DONE : Implement
        //
        return null;
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::set_log_qos operation.
     */
    public void
    set_log_qos(short[] qos)
    throws ist.coach.coachEmfServices.EmfBasicLog.UnsupportedQoS
    {
        //
        // TO BE DO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_max_size operation.
     */
    public long
    get_max_size()
    {
        //
        // DONE : Implement
        //
        return get_main_segment().logMaxSize();
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::set_max_size operation.
     */
    public void
    set_max_size(long size)
    throws ist.coach.coachEmfServices.EmfBasicLog.InvalidParam
    {
        //
        // DONE : Implement
        //
		get_main_segment().logMaxSize((int) size);
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_current_size operation.
     */
    public long
    get_current_size()
    {
        //
        // DONE : Implement
        //
		long currentSize = 0;

		// Connect to JDBC driver
		try {
			Class.forName(get_main_segment().databaseDriver()).newInstance();
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'get_current_size': <EXCEPTION> " +
						" While connecting to jdbx driver");
			System.err.println(ex.getMessage());
			return currentSize;
       	}

		Connection dbConnection = null;
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());
		try {
            	dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
    			Statement  dbTestStatement = dbConnection.createStatement();
    			ResultSet  dbTestResults = dbTestStatement.executeQuery("SHOW TABLE STATUS");

			while (dbTestResults.next()) {
				if ( dbTestResults.getString(1).equalsIgnoreCase(logTableName) ) {
					currentSize = dbTestResults.getLong(6);
					break;
				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'get_current_size': <EXCEPTION> " +
						" While connecting to jdbx driver");
			System.err.println(ex.getMessage());
		}

		return currentSize ;
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_n_records operation.
     */
    public long
    get_n_records()
    {
        //
        // DONE : Implement
        //
		long numOfRecords = 0;

		// Connect to JDBC driver
		try {
			Class.forName(get_main_segment().databaseDriver()).newInstance();
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'get_current_size': <EXCEPTION> " +
						" While connecting to jdbx driver");
			System.err.println(ex.getMessage());
			return -1;
		}

		Connection dbConnection = null;
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());
		try	{
		    dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
    		Statement  dbTestStatement = dbConnection.createStatement();
			ResultSet  dbTestResults = dbTestStatement.executeQuery("SHOW TABLE STATUS");

			while (dbTestResults.next()) {
				if ( dbTestResults.getString(1).equalsIgnoreCase(logTableName) ) {
					numOfRecords = dbTestResults.getLong(4);
					break;
				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'get_current_size': <EXCEPTION> " +
						" While connecting to jdbx driver");
			System.err.println(ex.getMessage());
			return -1;
		}

		return numOfRecords ;

    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_log_full_action operation.
     */
    public short
    get_log_full_action()
    {
        //
        // DONE : Implement
        //
        return get_main_segment().logFullAction();
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::set_log_full_action operation.
     */
    public void
    set_log_full_action(short action)
    throws ist.coach.coachEmfServices.EmfBasicLog.InvalidLogFullAction
    {
        //
        // DONE : Implement
        //
		if (action > 1)
		  throw new InvalidLogFullAction();

		get_main_segment().logFullAction(action);
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_administrative_state operation.
     */
    public ist.coach.coachEmfServices.EmfBasicLog.AdministrativeState
    get_administrative_state()
    {
        //
        // DONE : Implement
        //
		AdministrativeState adState;

		if ( logLocked_ ) {
			adState = AdministrativeState.locked;
		}
		else {
			adState = AdministrativeState.unlocked;
		}

		return adState;

    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::set_administrative_state operation.
     */
    public void
    set_administrative_state(ist.coach.coachEmfServices.EmfBasicLog.AdministrativeState admin_state)
    {
        //
        // DONE : Implement
        //
		if ( admin_state.value() == 0 )
			logLocked_ = true;
		else
			logLocked_ = false;
	  }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_operational_state operation.
     */
    public ist.coach.coachEmfServices.EmfBasicLog.OperationalState
    get_operational_state()
    {
        //
        // DONE : Implement
        //

		OperationalState opState;

		if ( logDisabled_ ) {
			opState = OperationalState.disabled;
		}
		else {
			opState= OperationalState.enabled;
		}

		return opState;

    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_capacity_alarm_thresholds operation.
     */
    public short[]
    get_capacity_alarm_thresholds()
    {
        //
        // TO BE DO : Implement
        //
        return null;
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::set_capacity_alarm_thresholds operation.
     */
    public void
    set_capacity_alarm_thresholds(short[] threshs)
    throws ist.coach.coachEmfServices.EmfBasicLog.InvalidThreshold
    {
        //
        // TO BE DO : Implement
        //
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::retrieve operation.
     */
    public ist.coach.coachEmfServices.EmfBasicLog.LogRecord[]
    retrieve(long from_time, int how_many, ist.coach.coachEmfServices.EmfBasicLog.IteratorHolder iterRef)
    {
        //
        // DONE : Implement
        //
		LogRecord[] logRecords = new LogRecord[0];
		LogRecord[] tmpLgRecs = new LogRecord[0];


		// Extract the timestamp from the time parameter
		java.sql.Timestamp from_timeTS= new java.sql.Timestamp(from_time);
		//System.err.println("timestamp = " + from_timeTS + " (" + from_time + ")");
		String from_timeTSstr = from_timeTS.toString();
		//System.err.println("timestamp string = " + from_timeTSstr);

		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());

		Connection dbConnection = null;
		String NVPairTableName = logTableName + "NVPairs";
		NVPair[] tmpAttrList = null;
		Statement  dbStatement = null;
		boolean tblExists = false;
		int rowsFetched = 0;
		String sqlStmnt = "";

		// Connect to JDBC driver and check if there is an associated NVPair table
		try {
			// Connect to JDBC driver and to the database
			Class.forName(get_main_segment().databaseDriver()).newInstance();
			dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
			dbStatement = dbConnection.createStatement();

			// Check if there is an associated NVPair table
			ResultSet  queryRes = dbStatement.executeQuery("SHOW TABLES");

			while ( queryRes.next() ) {
				if ( queryRes.getString(1).equalsIgnoreCase(NVPairTableName) ) {
					tblExists = true;
					break;
				}
			}

			sqlStmnt = "SELECT * FROM " + logTableName +
					" WHERE timeStamp >= '" + from_timeTSstr +"'";

			queryRes = dbStatement.executeQuery(sqlStmnt);

			while ( queryRes.next() ) {
				  // if clause added by fset
				if (rowsFetched == how_many)
				  break;
				rowsFetched++;
			}

			queryRes.beforeFirst();

			AnyTypeTrans AT = new AnyTypeTrans();
			tmpLgRecs = new LogRecord[rowsFetched];

			int i = 0;
			String tmpTimeStamp;
			ResultSet  queryResFrmAsTbl;


			while ( queryRes.next() && i < rowsFetched ) {
				tmpLgRecs[i]= new LogRecord();

				tmpLgRecs[i].id = queryRes.getLong(1);

				tmpTimeStamp = queryRes.getString(2);
				java.sql.Timestamp tS = java.sql.Timestamp.valueOf(tmpTimeStamp);
				long timeLong = tS.getTime();
				tmpLgRecs[i].time = timeLong;

				tmpLgRecs[i].attr_list = null;

				int anyKindInt = queryRes.getInt(3);
				tmpLgRecs[i].info = AT.fromDB(queryRes, anyKindInt, 4);

				i++;
			}

			if ( tblExists ) {
				for (i=0; i < tmpLgRecs.length; i++) {
					// retrieve all NVPairs from associated table
					sqlStmnt = "SELECT * FROM " + NVPairTableName +
							" WHERE logRecordId=" + tmpLgRecs[i].id;
					queryResFrmAsTbl = dbStatement.executeQuery(sqlStmnt);

					int n = 0;
					while ( queryResFrmAsTbl.next() ) {
						n++;
					}

					queryResFrmAsTbl.beforeFirst();
					if ( n != 0 ) {
						tmpAttrList = new NVPair[n];
					}
					n = 0;

					while ( queryResFrmAsTbl.next() ) {

						tmpAttrList[n] = new NVPair();

						tmpAttrList[n].name = queryResFrmAsTbl.getString(2);
						int m = queryResFrmAsTbl.getInt(3);

						tmpAttrList[n].value = AT.fromDB(queryResFrmAsTbl, m, 4);
						n++;
					}

					if ( n != 0 ) {

						tmpLgRecs[i].attr_list = tmpAttrList;
					}
				}
			}
			// If the fetched records from the database is
			// greater than the indicated threshold then instantiate
			// an Iterator and assigned all data to be fetched via
			// the Iterator interface. Otherwise, Iterator interface
			// will be null and all the records will be returned by
			// the present method.

		    //System.err.println( "*** BasicLogImpl : <1> > rowsFetched= " + rowsFetched);
		    int numOfRecsRorIterator_ = get_main_segment().recordsReadRange();
			if ( rowsFetched != 0 ) {

				if (rowsFetched >  numOfRecsRorIterator_) {
				  System.err.println( "*** BasicLogImpl : <2> > Iterator CASE" );

				  IteratorImpl iteratorSrv = null;

				  try {
				   iteratorSrv = new IteratorImpl();
				   }
				   catch ( Exception ex ) {
					  System.err.println( "*** BasicLogImpl : <EXCEPTION> " +
									" While trying to instantiate IteratorImpl() " +
									  ex.getMessage());
					  ex.printStackTrace();
					}

					iterRef.value = iteratorSrv._this(org.objectweb.ccm.CORBA.TheORB.getORB());

					iteratorSrv.logRecords(tmpLgRecs);

					iteratorSrv.logRecordsSize(iteratorSrv.logRecords().length);

					logRecords = new LogRecord[numOfRecsRorIterator_];
					for (int j = 0; j < numOfRecsRorIterator_ ; j++) {
		 				logRecords[j] = tmpLgRecs[j];
					}
				}
				else {
					logRecords = new LogRecord[tmpLgRecs.length];
		 			logRecords = tmpLgRecs;
					iterRef.value = null;
				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'retrieve': <EXCEPTION> ");
			System.err.println(ex.getMessage());
		}

		return logRecords;

    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::delete_records_by_id operation.
     */
    public int
    delete_records_by_id(long[] ids)
    {
        //
        // DONE : Implement
        //
 		int numOfRecsDeleted = 0;

		// Connect to JDBC driver
		try {
			Class.forName(get_main_segment().databaseDriver()).newInstance();
        	}
		catch (Exception ex) {
			System.out.println("** BasicLogImpl - METHOD 'delete_records_by_id': <EXCEPTION> " +
						"While connecting to jdbx driver");
			System.out.println(ex.getMessage());
			return -1;
        	}

		Connection dbConnection = null;
		try {
			dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
        	}
		catch (Exception ex) {
			System.out.println("** BasicLogImpl - METHOD 'delete_records_by_id': <EXCEPTION> " +
						"While getting db connection");
			System.out.println(ex.getMessage());
			return -1;
		}
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());

		String NVPairTableName = logTableName + "NVPairs";
		boolean tblExists = false;
		Statement  dbDeleteStatement = null;

		// Check if there is an associated NVPair table
		try {
		    dbDeleteStatement = dbConnection.createStatement();
			ResultSet  queryRes = dbDeleteStatement.executeQuery("SHOW TABLES");
			while ( queryRes.next() ) {
				if ( queryRes.getString(1).equalsIgnoreCase(NVPairTableName) ) {
					tblExists = true;
					break;
				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'delete_records_by_id': <EXCEPTION> " +
						"While getting db connection");
			System.err.println(ex.getMessage());
			return -1;
		}

		// Delete all records specified (by their record id) from the main
		// table and if there exists an associated NVPair table, delete the
		// associated records.
		for (int i = 0; i < ids.length; i++) {
			try {
				String sqlStmnt = "DELETE FROM " + logTableName +
							" WHERE logRecordId = " + ids[i];
				boolean  dbDeleteResults = dbDeleteStatement.execute(sqlStmnt);
				numOfRecsDeleted++;

				if ( tblExists ) {

					sqlStmnt = "DELETE FROM " + NVPairTableName +
							" WHERE logRecordId = " + ids[i];
    					dbDeleteResults  = dbDeleteStatement.execute(sqlStmnt);
				}

			}
			catch (Exception ex) {
				System.err.println("** BasicLogImpl - METHOD 'delete_records_by_id': <EXCEPTION> " +
							"While deleting record");
				System.err.println(ex.getMessage());

			}
		}

		return numOfRecsDeleted;

    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::write_records operation.
     */
    public void
    write_records(org.omg.CORBA.Any[] records)
    throws ist.coach.coachEmfServices.EmfBasicLog.LogFull,
           ist.coach.coachEmfServices.EmfBasicLog.LogOffDuty,
           ist.coach.coachEmfServices.EmfBasicLog.LogLocked,
           ist.coach.coachEmfServices.EmfBasicLog.LogDisabled
    {
        //
        // DONE : Implement
        //
		// Perform tests for empty input, LogOffDuty, LogLocked, LogDisabled

		if (records.length == 0)
			return;

		if ( logOffDuty_  )
			throw new LogOffDuty();

		if ( logLocked_  )
			throw new LogLocked();

		if ( logDisabled_ ) {
			throw new LogDisabled();
		}


		// Connect to JDBC driver
		try
		{
			Class.forName(get_main_segment().databaseDriver()).newInstance();
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl: <EXCEPTION> While connecting to jdbc driver");
			System.err.println(ex.getMessage());
			return;
		}

		Connection dbConnection = null;
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());
		// Perform test for LogFull

		try
		{
		    dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
    		Statement  dbTestStatement = dbConnection.createStatement();
    		ResultSet  dbTestResults = dbTestStatement.executeQuery("SHOW TABLE STATUS");

			while (dbTestResults.next()) {
				if ( dbTestResults.getString(1).equalsIgnoreCase(logTableName) ) {
					long avgRowLength = dbTestResults.getLong(5);
					long dataLength = dbTestResults.getLong(6);
					long maxDataLength = dbTestResults.getLong(7);
					dbTableMaxSize_ = maxDataLength;
					short numOfRows = dbTestResults.getShort(4);

					if ( maxDataLength <= (dataLength + avgRowLength) )
							throw new LogFull(numOfRows);;

				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl: <EXCEPTION> While connecting to jdbx driver");
			System.err.println(ex.getMessage());
			return;
		}

		PreparedStatement dbStatement = null;

		try {

		    dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());

			dbStatement = dbConnection.prepareStatement(
						  "INSERT INTO " + logTableName +
						  " (logRecordId, timeStamp, logDataType, logData)" +
						" VALUES(? , ?, ?, ?)"
			  );
	  }
	  catch (Exception ex) {
			System.err.println("** BasicLogImpl: <EXCEPTION> While getting db connection");
			System.err.println(ex.getMessage());
			return;
	  }

	  AnyTypeTrans AT = new AnyTypeTrans();

		// For all the received events extract the information based on the
		// 'LogRecord'(defined in Log.idl) and stored it in the given log
		// database and table.

	  int anyKindInt = -1;
	  long prevRecId = 0;

	  for (int i = 0; i < records.length; i++)	{

			Any receivedLogInfo = records[i];

			// Create timestamp
			java.util.Date currentDateTime = (java.util.Date) Calendar.getInstance().getTime();
			long recordId = currentDateTime.getTime();
			java.sql.Timestamp logTimestamp = new java.sql.Timestamp(currentDateTime.getTime());
			String logTimestampStr = logTimestamp.toString();

			try	{
				if ( (new Long(recordId)).compareTo(new Long(prevRecId))== 0 ) {
					recordId++;
				}
				prevRecId = recordId;

				dbStatement.setLong(1, recordId);
				dbStatement.setString(2, logTimestampStr);
				if ( records[i] != null ) {
					anyKindInt = AT.toDB(dbStatement, 4, records[i]);
				}
				else {
					dbStatement.setString(4, null);
				}

				dbStatement.setInt(3, anyKindInt);

				int res = dbStatement.executeUpdate();
			}
			catch (Exception ex){
				System.err.println("** BasicLogImpl: <EXCEPTION> While getting db connection");
				System.err.println(ex.getMessage());
				return;
      	  	}
	  } // End of 'loop' For all received events

    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::set_record_attribute operation.
     */
    public void
    set_record_attribute(long id, ist.coach.coachEmfServices.EmfBasicLog.NVPair[] attr_list)
    throws ist.coach.coachEmfServices.EmfBasicLog.InvalidRecordId,
         ist.coach.coachEmfServices.EmfBasicLog.InvalidAttribute
    {
        //
        // DONE : Implement
        //
				// In case the record ID is 0 throw an exception
		if ( (new Long(id)).compareTo(new Long(0)) == 0 ) {
			InvalidRecordId ex_InvalidRecordId = new InvalidRecordId();
			throw ex_InvalidRecordId;
		}

		// In the case the NVPair list of parameters has no values, or in
		// the case the values are either null or invalid (for the any case)
		// throw an exception.

		if ( attr_list.length == 0 ) {

			InvalidAttribute ex_InvalidAttribute = new InvalidAttribute();
			ex_InvalidAttribute.attr_name = null;
			ex_InvalidAttribute.value = null;
			throw ex_InvalidAttribute;
		}
		else {

			for (int i = 0; i < attr_list.length; i++) {

				if ( (attr_list[i].name).length() == 0 ) {
					InvalidAttribute ex_InvalidAttribute = new InvalidAttribute();
					ex_InvalidAttribute.attr_name = attr_list[i].name;
					ex_InvalidAttribute.value = attr_list[i].value;
					throw ex_InvalidAttribute;
				}
				else {
					CheckAnyValueValidity chkVal = new CheckAnyValueValidity();
					if ( !chkVal.checkAny(attr_list[i].value) ){
						InvalidAttribute ex_InvalidAttribute = new InvalidAttribute();
						ex_InvalidAttribute.attr_name = attr_list[i].name;
						ex_InvalidAttribute.value = attr_list[i].value;
						throw ex_InvalidAttribute;
					}
				}
			}
		}

		Connection dbConnection = null;
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());
		String NVPairTableName = logTableName + "NVPairs";
		boolean tblExists = false;

		Statement  dbStatement = null;

		// Connect to JDBC driver and check if there is an associated NVPair table
		try {
			Class.forName(get_main_segment().databaseDriver()).newInstance();
			dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());

			dbStatement = dbConnection.createStatement();
			ResultSet  queryRes = dbStatement.executeQuery("SHOW TABLES");
			while ( queryRes.next() ) {
				if ( queryRes.getString(1).equalsIgnoreCase(NVPairTableName) ) {
					tblExists = true;
					break;
				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'set_record_attribute': <EXCEPTION> ");
			System.err.println(ex.getMessage());
			return;
		}

		// If associated table exists, delete all records associated in NVPair
		// with the given rtecord id. If associated table does not exist create one.
		if ( tblExists ) {
			try {
				String sqlStmnt = "DELETE FROM " + NVPairTableName  +
							" WHERE logRecordId = " + id;
    				boolean  dbDeleteResults = dbStatement.execute(sqlStmnt);
			}
			catch (Exception ex) {
				System.err.println("** BasicLogImpl - METHOD 'set_record_attribute': <EXCEPTION> " +
							"While deleting records from the associated NVPair table");

				System.err.println(ex.getMessage());
				return;
			}
		}
		else {
			String sqlStmnt = "CREATE TABLE " + NVPairTableName +
						" (logRecordId BIGINT, " +
						"NVPairName VARCHAR(30), " +
						"NVPairValueType TINYINT, " +
						"NVPairValue BLOB)";
			try {
    				boolean  tblCreatedInDb = dbStatement.execute(sqlStmnt);
			}
			catch (Exception ex) {
				System.err.println("** BasicLogImpl - METHOD 'set_record_attribute': <EXCEPTION> " +
							"While creating associated NVPair table");

				System.err.println(ex.getMessage());
				return;
			}
		}


			try {
				PreparedStatement dbStatement2 = dbConnection.prepareStatement(
						    "INSERT INTO " + NVPairTableName +
							" (logRecordId, NVPairName, NVPairValueType, NVPairValue)" +
							" VALUES(? , ?, ?, ?)"	);

				AnyTypeTrans AT = new AnyTypeTrans();

				for (int i = 0; i < attr_list.length; i++) {

					dbStatement2.setLong(1, id);
					dbStatement2.setString(2, attr_list[i].name);
					int anyKindInt = AT.toDB(dbStatement2, 4, attr_list[i].value);
					dbStatement2.setInt(3, anyKindInt);
					int res = dbStatement2.executeUpdate();
				}
			}
			catch (Exception ex) {
				System.err.println("** BasicLogImpl - METHOD 'set_record_attribute': <EXCEPTION> " +
							"While setting the attributes in the associated NVPair table");
				System.err.println(ex.getMessage());
			}


    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::get_record_attribute operation.
     */
    public ist.coach.coachEmfServices.EmfBasicLog.NVPair[]
    get_record_attribute(long id)
    throws ist.coach.coachEmfServices.EmfBasicLog.InvalidRecordId
    {
        //
        // DONE : Implement
        //
        		// In case the record ID is 0 throw an exception
		if ( (new Long(id)).compareTo(new Long(0)) == 0 ) {
			InvalidRecordId ex_InvalidRecordId = new InvalidRecordId();
			throw ex_InvalidRecordId;
		}
		String logTableName = get_main_segment().databaseTable() +
			Integer.toString(get_main_segment().logId());
		Connection dbConnection = null;
		String NVPairTableName = logTableName + "NVPairs";
		NVPair[] attrList = null;
		Statement  dbStatement = null;
		boolean tblExists = false;
		String sqlStmnt = "";

		// Connect to JDBC driver and check if there is an associated NVPair table
		try {
			// Connect to JDBC driver and to the database
			Class.forName(get_main_segment().databaseDriver()).newInstance();
			dbConnection = DriverManager.getConnection(get_main_segment().databaseConnection());
			dbStatement = dbConnection.createStatement();

			// Check if there is an associated NVPair table
			ResultSet  queryRes = dbStatement.executeQuery("SHOW TABLES");
			while ( queryRes.next() ) {
				if ( queryRes.getString(1).equalsIgnoreCase(NVPairTableName) ) {
					tblExists = true;
					break;
				}
			}

			// if there is an associated NVPair table extract all NVPairs
			if ( tblExists ) {
				sqlStmnt = "SELECT * FROM " + NVPairTableName +
							" WHERE logRecordId=" + id;
				queryRes = dbStatement.executeQuery(sqlStmnt);

				int rowsFetched = 0;
				while ( queryRes.next() ) {
					rowsFetched++;
				}

				attrList = new NVPair[rowsFetched];

				AnyTypeTrans AT = new AnyTypeTrans();
				int i = 0;

				queryRes.beforeFirst();
				while ( queryRes.next() ) {
					attrList[i] = new NVPair();
					attrList[i].name = queryRes.getString(2);
					int anyKindInt = queryRes.getInt(3);
					attrList[i].value = AT.fromDB(queryRes, anyKindInt, 4);
				}
			}
		}
		catch (Exception ex) {
			System.err.println("** BasicLogImpl - METHOD 'get_record_attribute': <EXCEPTION> ");
			System.err.println(ex.getMessage());
		}

		return attrList;
    }

    /**
     * Implementation of the ::coachEmfServices::EmfBasicLog::Log::flush operation.
     */
    public void
    flush()
    throws ist.coach.coachEmfServices.EmfBasicLog.UnsupportedQoS
    {
        //
        // TODO : Implement
        //
		System.err.println("basicLogSeqImpl> Flush is called!!");
    }

}
