/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_q816Components.ContainmentServiceProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.DeleteErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.DeleteError;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/itut_q816Components/ContainmentServiceProviderComposition/ContainmentServiceProviderHome_impl/ContainmentServiceProvider_impl/adminSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class adminSegImpl
     extends ist.coach.itut_q816Components.ContainmentServiceProviderComposition.adminSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public adminSegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816::ContainmentComponent::registerLocalRoot operation.
     */
    public void
    registerLocalRoot(org.omg.CosNaming.NameComponent[] name, org.omg.CosNaming.NamingContext localRoot)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		ContainmentServiceProviderImpl._local_root = Utils.name2string(name);
		if (! ContainmentServiceProviderImpl.tree.contains(
				  ContainmentServiceProviderImpl._local_root))
		    synchronized(ContainmentServiceProviderImpl.tree) {
        	  ContainmentServiceProviderImpl.tree.put(
				ContainmentServiceProviderImpl._local_root, new java.util.Vector());
			}
	}

    /**
     * Implementation of the ::itut_q816::ContainmentComponent::unregisterLocalRoot operation.
     */
    public void
    unregisterLocalRoot(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        // TODO : Implement
        //
    }

    /**
     * Implementation of the ::itut_q816::ContainmentComponent::addName operation.
     */
    public void
    addName(org.omg.CosNaming.NameComponent[] name, org.omg.CosNaming.NameComponent[] superior)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.CreateError
    {
              //
        //  DONE : implement
        //
    	java.util.Vector children = new java.util.Vector();

		String name_str = Utils.name2string(name);
		//System.err.println("ContainmentService called to add : " + name_str);

		String superior_str = Utils.name2string(superior);

    	if (ContainmentServiceProviderImpl.tree.containsKey(superior_str)) {
        	children =  (java.util.Vector) ContainmentServiceProviderImpl.tree.get(superior_str);
    	}
    	else {
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
			error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.badName.value);
			error_code.details = ExceptionMessages.parent_object_error;
        	throw new ApplicationError(error_code);
    	}

    	if (ContainmentServiceProviderImpl.tree.containsKey(name_str)) {
        	CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

           	error_code.details = name_str + ExceptionMessages.not_exists_error;
            throw new CreateError(error_code);

    	}
    	else {
		  synchronized(ContainmentServiceProviderImpl.tree) {
	    	ContainmentServiceProviderImpl.tree.put(name_str, new java.util.Vector());
			//System.err.println("ContainmentService added : " + name_str);
		  }
	  }

    	if (! children.contains(name_str)) {
        	children.add(name_str);
			synchronized(ContainmentServiceProviderImpl.tree) {
        	  ContainmentServiceProviderImpl.tree.put(superior_str, children);
			}
			synchronized(ContainmentServiceProviderImpl.reverse_tree) {
			  ContainmentServiceProviderImpl.reverse_tree.put(name_str, superior_str);
			}
		}
    }

    /**
     * Implementation of the ::itut_q816::ContainmentComponent::removeName operation.
     */
    public void
    removeName(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.DeleteError
    {
                //
        //  DONE : implement
        //
   	 	if (name.length <= 1) {
			ApplicationErrorInfoTypeImpl error_code =
					new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = ExceptionMessages.root_delete_error;

        	throw new ApplicationError(error_code);
		}

		String name_str = Utils.name2string(name);

    	if (!ContainmentServiceProviderImpl.tree.containsKey(name_str)) {

			//System.err.println("CS has " + 
			//ContainmentServiceProviderImpl.tree.size() + " objects ");	

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = name_str + ExceptionMessages.not_exists_error;

        	throw new ApplicationError(error_code);
    	}

		java.util.Vector children =
		  (java.util.Vector) ContainmentServiceProviderImpl.tree.get(name_str);

		 // There must be no contained names registered with
         // the Containment service when a name is removed.

		if (children != null && children.size() > 0) {
			DeleteErrorInfoTypeImpl error_code =
                new DeleteErrorInfoTypeImpl();
			error_code.error = new UIDType(
                intt.itu.itut_x780.DeleteErrorConst.moduleName.value,
				intt.itu.itut_x780.DeleteErrorConst.containsObjects.value);
			error_code.details = name_str + ExceptionMessages.contains_object_error;

			throw new DeleteError(error_code);
		}

		synchronized(ContainmentServiceProviderImpl.tree) {
          ContainmentServiceProviderImpl.tree.remove(name_str);
			//System.err.println("CS has removed " + name_str);
		}
        String superior = null;
		synchronized(ContainmentServiceProviderImpl.reverse_tree) {
		  superior = (String) ContainmentServiceProviderImpl.reverse_tree.remove(name_str);
		}
        if (superior == null)
            return;

        java.util.Vector superior_children =
		  (java.util.Vector) ContainmentServiceProviderImpl.tree.get(superior);
        if (superior_children.contains(name_str)) {
            superior_children.remove(name_str);
			synchronized(ContainmentServiceProviderImpl.tree) {
			    ContainmentServiceProviderImpl.tree.put(superior, superior_children);
			}
			//System.err.println("\tProceeding to remove from " + name_str
			//		+ " from " + superior);
        }

	}

}
