/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_q816Components.FactoryFinderProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_q816.FactoryInfoType;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/itut_q816Components/FactoryFinderProviderComposition/FactoryFinderProviderHome_impl/FactoryFinderProvider_impl/adminSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class adminSegImpl
     extends ist.coach.itut_q816Components.FactoryFinderProviderComposition.adminSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public adminSegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_q816::FactoryFinderComponent::register operation.
     */
    public void
    register(String factoryClass, intt.itu.itut_x780.ManagedObjectFactory factoryRef)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		if (factoryClass == null || factoryClass.length() == 0) {
			ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = new String("Factory class name is  not specified!");

            throw new ApplicationError(error_code);
		}
		if (factoryRef == null) {
			 ApplicationErrorInfoTypeImpl error_code =
                    new ApplicationErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
                intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
            error_code.details = new String("Factory reference is not provided!");

            throw new ApplicationError(error_code);
        }

		FactoryInfoType factory_info = new FactoryInfoType(factoryClass, factoryRef);
		synchronized(FactoryFinderProviderImpl.factories) {
		  FactoryFinderProviderImpl.factories.put(factoryClass, factory_info);
		}
    }

    /**
     * Implementation of the ::itut_q816::FactoryFinderComponent::unregister operation.
     */
    public void
    unregister(String factoryClass, intt.itu.itut_x780.ManagedObjectFactory factoryRef)
    throws intt.itu.itut_q816.FactoryNotFound,

           intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		if (! FactoryFinderProviderImpl.factories.containsKey(factoryClass))
			throw new intt.itu.itut_q816.FactoryNotFound(factoryClass +
				" has not been registered");
		synchronized(FactoryFinderProviderImpl.factories) {
		  FactoryFinderProviderImpl.factories.remove(factoryClass);
	   }
    }

}
