/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.itut_x780Components.ManagedObjectProviderComposition;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.ManagedObjectValueTypeImpl;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;


import intt.itu.itut_x780.CreateError;
import ist.coach.coachEmfCommon.ObjectCreationImpl;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.AttributeValueType;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/itut_x780Components/ManagedObjectProviderComposition/ManagedObjectProviderHome_impl/ManagedObjectProvider_impl/mgmtSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class mgmtSegImpl
     extends ist.coach.itut_x780Components.ManagedObjectProviderComposition.mgmtSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public mgmtSegImpl()
    {
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::ManagedObjectMgmt::create operation.
     */
    public void
    create(org.omg.CosNaming.NameComponent[] name, String objectClass, String[] packages, short deletePolicy, intt.itu.itut_x780.SourceIndicatorType sourceIndicator)
    throws intt.itu.itut_x780.CreateError,
           intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

		if (ManagedObjectProviderImpl.elements.containsKey(Utils.name2string(name))) {
			System.err.println(Utils.name2string(name) + " already exists!");
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

            error_code.details =  ExceptionMessages.already_exists_error;
            throw new CreateError(error_code);
		}

		ManagedObjectValueTypeImpl value_type =
				new ManagedObjectValueTypeImpl(name, objectClass, packages,
						sourceIndicator, deletePolicy);

		synchronized(ManagedObjectProviderImpl.elements) {
		    ManagedObjectProviderImpl.elements.put(Utils.name2string(name), value_type);
		}

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
					0,(short) 0,(short) 0);


		get_context().push_objectCreation_alarm(new ObjectCreationImpl(eventTime, name,
										objectClass,
										ManagedObjectProviderImpl.getUniqueNotificationIdentifier(),
										sourceIndicator,
										new AttributeValueType[0]));


    }

    /**
     * Implementation of the ::itut_x780Components::ManagedObjectMgmt::facade_name operation.
     */
    public String
    facade_name()
    {
              //
        //  DONE : implement
        //
        return get_main_segment().facade_name();
    }

}
