/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.IpAddressDataProviderComposition;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.AttributeValueType;

import ist.coach.coachEmfCommon.Utils;

import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;

import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.IpAddressDataValueType;
import ist.coach.coachEmsCommon.SnmpIdentifiers;
import ist.coach.coachEmsCommon.IpAddressDataValueTypeImpl;

import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;
import ist.coach.coachEmfServices.EmfBasicLog.*;
import org.opennms.protocols.snmp.SnmpSMI;

import java.util.Hashtable;
/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 IDL:coach.ist/coachEmsMibComponents/IpAddressDataProvider:1.0 component type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class IpAddressDataProviderImpl
     extends ist.coach.coachEmsMibComponents.IpAddressDataProviderComposition.IpAddressDataProvider_impl
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
    org.omg.CORBA.ORB orb = null;
    private String _facade_name;

    protected static  Hashtable elements;
	private static int notifId = 13000;
	private BasicLog logSupport;

    ist.coach.coachEmfServices.SnmpAdapter.SnmpConnector connector = null;

	private static final String READ_COMMUNITY = SnmpIdentifiers.READ_COMMUNITY;
	private static final String WRITE_COMMUNITY = SnmpIdentifiers.WRITE_COMMUNITY;

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public IpAddressDataProviderImpl()
    {
	  elements = new Hashtable();
    }
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //

		if ((connector = get_context().get_connection_connector()) == null)
            throw new org.omg.Components.InvalidConfiguration();
		orb = org.objectweb.ccm.CORBA.TheORB.getORB();
	  if ((logSupport = get_context().get_connection_basic_log()) == null)
			throw new org.omg.Components.InvalidConfiguration();

        System.err.println("IpAddressDataProvider configuration completed...");

    }
    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as accessor operation.
     */
    public String
    facade_name()
    {
        //
        // DONE : Implement
        //
        return _facade_name;
    }

    /**
     * Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::facade_name attribute as mutator operation.
     */
    public void
    facade_name(String val)
    {
       //
        //  DONE : implement
        //
		if (val != null)
            _facade_name = new String(val);

    }

    /**
     * Implementation of the ::coachEmsMib::IpAddressData_F::ipAdEntAddrGet operation.
     */
    public byte[]
    ipAdEntAddrGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {

		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
		ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		return data.ipAdEntAddress.getBytes();
    }

    /**
     * Implementation of the ::coachEmsMib::IpAddressData_F::ipAdEntIfIndexGet operation.
     */
    public int
    ipAdEntIfIndexGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}
		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		String ipAdEntAddress = new String(data.ipAdEntAddress);
		String ifIndexOid = SnmpIdentifiers.IP_ADDR_IFINDEX_OID + "." + ipAdEntAddress;

		DataType ifIndexData = null;

		try {
			ifIndexData = connector.get(
				ifIndexOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipAdEntIfIndex " +
					"for IpAddressData Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ifIndexOid +
					" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
		  (short) LogSeverity._Error,
		  "SNMP Error getting the ipAdEntIfIndex: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ifIndexData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpAddressData> Could not retrieve ipAdEntIfIndex " +
				"for IpAddressData Object with name " + key + ":" +
				" Object with Snmp Object Identifier " + ifIndexOid +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipAdEntIfIndex = value.extract_long();
		return ipAdEntIfIndex;
    }

    /**
     * Implementation of the ::coachEmsMib::IpAddressData_F::ipAdEntNetMaskGet operation.
     */
    public byte[]
    ipAdEntNetMaskGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}
		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		String ipAdEntAddress = new String(data.ipAdEntAddress);
		String ipNetMaskOid = SnmpIdentifiers.IP_ADDR_NETMASK_OID + "." + ipAdEntAddress;

		DataType ipNetMaskData = null;

		try {
			ipNetMaskData = connector.get(
				ipNetMaskOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipAdEntNetMask " +
					"for IpAddressData Object with name " + key + ":" +
					"\n  Object with Snmp Object Identifier " + ipNetMaskOid +
					" does not exist.");

		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			  (short) LogSeverity._Error,
			  "SNMP Error getting the ipAdEntNetMask: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipNetMaskData.value;

		if (value.type().kind().value() != TCKind._tk_string) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpAddressData> Could not retrieve ipAdEntNetMask " +
				"for IpAddressData Object with name " + key + ":" +
				"\n Object with Snmp Object Identifier " + ipNetMaskOid +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		String ipNetMask = value.extract_string();
		return ipNetMask.getBytes();
    }

    /**
     * Implementation of the ::coachEmsMib::IpAddressData_F::ipAdEntBcastAddrGet operation.
     */
    public int
    ipAdEntBcastAddrGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}
		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		String ipAdEntAddress = new String(data.ipAdEntAddress);
		String ipAdEntBcastOid = SnmpIdentifiers.IP_ADDR_BCASTADDR_OID + "." + ipAdEntAddress;

		DataType ipAdEntBcastData = null;

		try {
			ipAdEntBcastData = connector.get(
				ipAdEntBcastOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipAdEntBcastAddr " +
					"for IpAddressData Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipAdEntBcastOid +
					" does not exist.");

			  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			    (short) LogSeverity._Error,
			    "SNMP Error getting the ipAdEntBcastAddr: " + e.reason);

			throw new ApplicationError (error_code);
		}

		org.omg.CORBA.Any value = ipAdEntBcastData.value;


		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpAddressData> Could not retrieve ipAdEntBcastAddr " +
				"for IpAddressData Object with name " + key + ":" +
				"\n Object with Snmp Object Identifier " + ipAdEntBcastOid +
				" is not of expected type.");

			throw new ApplicationError (error_code);

		}

		int ipAdEntBcastAddr = value.extract_long();
		return ipAdEntBcastAddr;
    }

    /**
     * Implementation of the ::coachEmsMib::IpAddressData_F::ipAdEntReasmMaxSizeGet operation.
     */
    public short
    ipAdEntReasmMaxSizeGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
 		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}
		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		String ipAdEntAddress = new String(data.ipAdEntAddress);
		String ipAdEntReasmMaxSizeOid = SnmpIdentifiers.IP_ADDR_REASMMAX_OID + "." + ipAdEntAddress;

		DataType ipAdEntReasmMaxSizeData = null;

		try {
			ipAdEntReasmMaxSizeData = connector.get(
				ipAdEntReasmMaxSizeOid,
				new String (data.getMgmtIpAddress()),
				data.getSnmpPort(),
				READ_COMMUNITY);
		}
		catch (SnmpApplicationError e) {

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			if (e.reason.equals(ExceptionMessages.agent_response_error))
				error_code.details = ExceptionMessages.agent_response_error;
			else
				error_code.details = new String ("Could not retrieve ipAdEntReasmMaxSize " +
					"for IpAddressData Object with name " + key + ":" +
					"\n Object with Snmp Object Identifier " + ipAdEntReasmMaxSizeOid +
					" does not exist.");
			  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name),
			    (short) LogSeverity._Error,
			    "SNMP Error getting the ipAdEntReasmMaxSize: " + e.reason);

			throw new ApplicationError (error_code);


		}

		org.omg.CORBA.Any value = ipAdEntReasmMaxSizeData.value;

		//System.err.println("value.type().kind().value() = " + value.type().kind().value() );
		if (value.type().kind().value() != TCKind._tk_long) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String ("IpAddressData> Could not retrieve ipAdEntReasmMaxSize " +
				"for IpAddressData Object with name " + key + ":" +
				"\n Object with Snmp Object Identifier " + ipAdEntReasmMaxSizeOid +
				" is not of expected type.");

			//throw new ApplicationError (error_code);
			//System.err.println("IpAddressData> ipAdEntReasmMaxSize: error_code.details=" + error_code.details);
			return -1;
		}

		int ipAdEntReasmMaxSize = (int) value.extract_long();
		return (short) ipAdEntReasmMaxSize;

	}

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::nameGet operation.
     */
    public org.omg.CosNaming.NameComponent[]
    nameGet()
    {
        //
        //  DONE : implement
        //
        return Utils.string2name(_facade_name);
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::objectClassGet operation.
     */
    public String
    objectClassGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
         //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		return data.objectclass;

    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::attributesGet operation.
     */
    public intt.itu.itut_x780.ManagedObjectValueType
    attributesGet(org.omg.CosNaming.NameComponent[] name, intt.itu.itut_x780.StringSetTypeHolder attributeNames)
    throws intt.itu.itut_x780.ApplicationError
    {
       //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		IpAddressDataValueTypeImpl ipAddressDataValueType =
			new IpAddressDataValueTypeImpl(
				ipAdEntAddrGet(name),
				ipAdEntIfIndexGet(name),
				ipAdEntNetMaskGet(name),
				ipAdEntBcastAddrGet(name),
				ipAdEntReasmMaxSizeGet(name),
				data.name,
				data.objectclass,
				data.packages,
				data.sourceIndicator,
				data.deletePolicy
			);
		  Utils.pretty_log(logSupport, Utils.name2string(name), objectClassGet(name), (short) LogSeverity._Info,
		  "attributesGet finished OK");

			return ipAddressDataValueType;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::packagesGet operation.
     */
    public String[]
    packagesGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
                //
        //  DONE : implement
        //
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

        return data.packages;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::creationSourceGet operation.
     */
    public intt.itu.itut_x780.SourceIndicatorType
    creationSourceGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
 		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

		return data.sourceIndicator;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::deletePolicyGet operation.
     */
    public short
    deletePolicyGet(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
		String key = Utils.name2string(name);

		if (elements.containsKey(key) == false) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("object with name " +
				key + " does not exist.");

			throw new ApplicationError(error_code);
		}

		IpAddressDataStructure data =
			(IpAddressDataStructure) elements.get(key);

        return data.deletePolicy;
    }

    /**
     * Implementation of the ::itut_x780::ManagedObject_F::destroy operation.
     */
    public void
    destroy(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.DeleteError
    {


	  if (!elements.containsKey(Utils.name2string(name))) {

            ApplicationErrorInfoTypeImpl error_code =
            new ApplicationErrorInfoTypeImpl();

            error_code.error = new UIDType(
            intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
            intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

            error_code.details = new String ("object with name " +
            Utils.name2string(name) + " does not exist.");

            throw new ApplicationError(error_code);

	  }
	  IpAddressDataStructure ipAddressData = null;
	  synchronized(elements) {
	    ipAddressData =
	 		(IpAddressDataStructure) elements.remove(
			Utils.name2string(name));
	}
	org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
		0, (short) 0, (short) 0);
	get_context().push_objectDeletion(new ObjectDeletionImpl(eventTime, name,
						ipAddressData.objectclass,
						getUniqueNotificationIdentifier(),
						ipAddressData.sourceIndicator,
						new AttributeValueType[0]));
	Utils.pretty_log(logSupport,  Utils.name2string(name), 
			ipAddressData.objectclass, //objectClassGet(name),
		  (short) LogSeverity._Info,
		  "successfully removed from management system");

    }

    protected static int getUniqueNotificationIdentifier() {

		notifId++;
        return notifId;
	}

}
