/*====================================================================

This file was produced by the OpenCCM CIF_JIMPL generator.

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ______________________________________.

====================================================================*/

package ist.coach.coachEmsMibComponents.LogicalInterfaceProviderComposition;

import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.UIDType;

import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.AttributeValueChangeType;
import intt.itu.itut_x780.AttributeValueType;
import intt.itu.itut_x780.SourceIndicatorType;
import intt.itu.itut_x780.OperationalStateTypeHelper;
import intt.itu.itut_x780.OperationalStateType;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.StateChangedEventImpl;
import ist.coach.coachEmfCommon.StateChangedEventImpl;
import ist.coach.coachEmfCommon.ObjectCreationImpl;
import ist.coach.coachEmfCommon.ObjectDeletionImpl;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.DataTypeImpl;
import ist.coach.coachEmfServices.SnmpAdapter.DataType;
import ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError;

import ist.coach.coachEmsMib.LogicalInterfaceValueType;
//import ist.coach.coachEmsMib.LogicalInterface_F;
//import ist.coach.coachEmsMibComponents.LogicalInterfaceProviderHelper;

import ist.coach.coachEmsCommon.SnmpIdentifiers;
//import ist.coach.coachEmsCommon.LogicalInterfaceValueTypeImpl;

import org.omg.CosNaming.NameComponent;
import org.omg.CORBA.TCKind;

import org.opennms.protocols.snmp.SnmpSMI;

import java.util.Hashtable;

/**
 *  This is the CIDL-based implementation of the
 *  OMG IDL3 CIDL:coach.ist/coachEmsMibComponents/LogicalInterfaceProviderComposition/LogicalInterfaceProviderHome_impl/LogicalInterfaceProvider_impl/mgmtSeg:1.0 segment type.
 *
 *  @author OpenCCM CIF_Jimpl Compiler.
 */
public class mgmtSegImpl
     extends ist.coach.coachEmsMibComponents.LogicalInterfaceProviderComposition.mgmtSeg
{
    // ==================================================================
    //
    // Internal states.
    //
    // ==================================================================
    org.omg.CORBA.ORB orb = null;
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public mgmtSegImpl()
    {
	  orb = org.objectweb.ccm.CORBA.TheORB.getORB();
    }

    // ==================================================================
    //
    // Methods.
    //
    // ==================================================================

    /**
     * Implementation of the ::coachEmsMibComponents::LogicalInterfaceMgmt::create operation.
     */
    public void
    create(org.omg.CosNaming.NameComponent[] name,
		  String objectClass,
		  String[] packages,
		  short deletePolicy,
		  intt.itu.itut_x780.SourceIndicatorType sourceIndicator,
		  org.omg.CosNaming.NameComponent[] superior,
		  int ifIndex,
		  byte[] mgmtIpAddress,
		  int supportedSnmpVersions,
		  int snmpPort,
		String ifDescr)
    throws intt.itu.itut_x780.ApplicationError,

           intt.itu.itut_x780.CreateError
    {
         //
        //  DONE : implement
        //
		ist.coach.coachEmfServices.SnmpAdapter.SnmpTrapDaemon config = null;

		if ((config = get_context().get_connection_config()) == null) {
			CreateErrorInfoTypeImpl errorCode =
				new CreateErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.CreateErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			errorCode.details = new String(ExceptionMessages.components_connect_error);
			throw new intt.itu.itut_x780.CreateError(errorCode);
		}

		if (LogicalInterfaceProviderImpl.elements.containsKey(Utils.name2string(name))) {

			CreateErrorInfoTypeImpl errorCode =
				new CreateErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.CreateErrorConst.moduleName.value,
				intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

			errorCode.details = new String(Utils.name2string(name) +
			 " object already exists.");
			throw new intt.itu.itut_x780.CreateError(errorCode);
		}

	  //System.err.println("LogicalInterface packages = " + packages.length);

		LogicalInterfaceDataStructure logicalInterfaceData =
			new LogicalInterfaceDataStructure(
				ifIndex,
				name,
				objectClass,
				packages,
				sourceIndicator,
				deletePolicy,
				new String(mgmtIpAddress),
				snmpPort,
				supportedSnmpVersions,
				ifDescr);

		synchronized(LogicalInterfaceProviderImpl.elements) {
		  LogicalInterfaceProviderImpl.elements.put(Utils.name2string(name), logicalInterfaceData);
		}
		//System.err.println("LogicalInterfaceProvider setting data FINISHED...!");

		//by digi
		//ifDescrAny.insert_string(ifDescr);
		try {
		  org.omg.CORBA.Any ifDescrAny = orb.create_any();
		  //System.err.println("LogicalInterfaceProvider setting any data for " + ifDescr);
		  org.omg.CORBA.OctetSeqHelper.insert(ifDescrAny, ifDescr.getBytes());

			//System.err.println("Trying to register interface with description " +
			//	Utils.name2string(name));
			config.registerValue(name, new String(mgmtIpAddress), ifDescrAny);
		}
		catch (ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError snmp_ex) {

			System.err.println("Could not register LogicalInterface " +
				Utils.name2string(name) + " to the SNMP Trap Service");
			System.err.println("Reason = " + snmp_ex.reason);

			ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.downstreamError.value);

			error_code.details = snmp_ex.reason;

			throw new ApplicationError(error_code);
		}
		catch(Exception e) {
		  System.err.println("LogicalInterfaceProvider Exception caught: " + e.getMessage());
		  e.printStackTrace();
	   }

		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT (System.currentTimeMillis(),
					0, (short) 0, (short) 0);
		get_context().push_objectCreation(new ObjectCreationImpl(eventTime,
												name,
												objectClass,
												LogicalInterfaceProviderImpl.getUniqueNotificationIdentifier(),
												//logicalInterfaceData.getUniqueNotificationIdentifier(),
												sourceIndicator,
												new AttributeValueType[0]));

    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::notifyTrap operation.
     */
    public void
    notifyTrap(org.omg.CosNaming.NameComponent[] name, String community, int trapID, int trapType, ist.coach.coachEmfServices.SnmpAdapter.DataType[] trapData)
    throws intt.itu.itut_x780.ApplicationError,

           ist.coach.coachEmfServices.SnmpAdapter.SnmpApplicationError
    {
       //
        //  DONE : implement
        //

		String key = Utils.name2string(name);

		if (LogicalInterfaceProviderImpl.elements.containsKey(Utils.name2string(name)) == false) {

			ApplicationErrorInfoTypeImpl errorCode =
				new ApplicationErrorInfoTypeImpl();

			errorCode.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			errorCode.details = new String("object with name " +
			 key + " does not exists.");

			//System.err.println("Object with name " + key + " does not exist!");

			throw new intt.itu.itut_x780.ApplicationError(errorCode);
		}

		LogicalInterfaceDataStructure data =
			(LogicalInterfaceDataStructure) LogicalInterfaceProviderImpl.elements.get(key);

		intt.itu.itut_x780.OperationalStateType newValue = null;
		intt.itu.itut_x780.OperationalStateType oldValue = null;

		if (trapType == LogicalInterfaceProviderImpl.COACH_LINK_UP) {
			newValue = intt.itu.itut_x780.OperationalStateType.enabled;
			oldValue = intt.itu.itut_x780.OperationalStateType.disabled;
		}
		else
		if (trapType == LogicalInterfaceProviderImpl.COACH_LINK_DOWN) {
			newValue = intt.itu.itut_x780.OperationalStateType.disabled;
			oldValue = intt.itu.itut_x780.OperationalStateType.enabled;
		}
		else {
			System.err.println("LogicalInterface_F down not know how to handle trap of type " +
				trapType);

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = new String ("LogicalInterface_F does not know how to handle trap of type " + trapType + ".");

			throw new ApplicationError(error_code);
		}

		long trapTime = 0;
		boolean trapTimeFound = false;

		for (int i = 0; i < trapData.length; i++) {
			if (trapData[i].identifier.equals(SnmpIdentifiers.TIME_OID)) {
				//System.err.println("Found Time...");
				org.omg.CORBA.Any value = trapData[i].value;

				if (value.type().kind().value() != TCKind._tk_longlong) {

					ApplicationErrorInfoTypeImpl error_code =
						new ApplicationErrorInfoTypeImpl();

					error_code.error = new UIDType(
						intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
						intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);


					error_code.details = new String("Could not retrieve event time " +
						"for trap. Object with Snmp Object Identifier " + SnmpIdentifiers.TIME_OID +
						" is not of type long, as expected.");

					//System.err.println("Event time is not of type long, as expected...");

					throw new ApplicationError(error_code);
				}

				trapTime = value.extract_longlong();
				trapTimeFound = true;
				break;
			}
		}

		if (trapTimeFound == false) {

			System.err.println("Trap Time could not be determined. No such VarBinding");

			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();

			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);

			error_code.details = new String("Could not retrieve event time " +
				"for trap.");

			throw new ApplicationError(error_code);
		}

//		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(trapTime, 0, (short) 0, (short) 0);
		org.omg.TimeBase.UtcT eventTime = new org.omg.TimeBase.UtcT(System.currentTimeMillis(),
                        0,(short) 0,(short) 0);


		//int notificationId = data.getUniqueNotificationIdentifier();
		int notificationId = LogicalInterfaceProviderImpl.getUniqueNotificationIdentifier();

		String sourceClass = data.objectclass;

		SourceIndicatorType sourceIndicator = SourceIndicatorType.unknown;

		org.omg.CORBA.Any oldValue_any = orb.create_any();
		OperationalStateTypeHelper.insert(oldValue_any, oldValue);

		org.omg.CORBA.Any newValue_any  = orb.create_any();
		OperationalStateTypeHelper.insert(newValue_any, newValue);

		AttributeValueChangeType [] changedValues = new AttributeValueChangeType[1];

		changedValues[0] = new AttributeValueChangeType(
			"operationalState",
			oldValue_any,
			newValue_any);

		StateChangedEventImpl stateChangedEvent = new StateChangedEventImpl(
			eventTime,
			name,
			sourceClass,
			notificationId,
			sourceIndicator,
			changedValues);
		System.err.println("LogicalInterfaceProvider> Before pushing StateChange event with identifier " +
			stateChangedEvent.notificationIdentifier + " for " +
			Utils.name2string(stateChangedEvent.source) + " of objectclass " +
			stateChangedEvent.sourceClass + " generated after SNMP agent " +
			"has been up for " + stateChangedEvent.eventTime.time +
			" caused by an action of type " + sourceIndicator + ".");
		get_context().push_stateChange(stateChangedEvent);

    }

    /**
     * Implementation of the ::coachEmfServices::SnmpAdapter::TrapCallback::facade_name operation.
     */
    public String
    facade_name()
    {
        //
        // TODO : Implement
        //
        return get_main_segment().facade_name();
    }

}
