@echo off
rem # ====================================================================
rem #
rem # OpenCCM: The Open CORBA Component Model Platform
rem # Copyright (C) 2000-2003 INRIA - USTL - LIFL - GOAL
rem # Contact: openccm@objectweb.org
rem #
rem # This library is free software; you can redistribute it and/or
rem # modify it under the terms of the GNU Lesser General Public
rem # License as published by the Free Software Foundation; either
rem # version 2.1 of the License, or any later version.
rem #
rem # This library is distributed in the hope that it will be useful,
rem # but WITHOUT ANY WARRANTY; without even the implied warranty of
rem # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
rem # Lesser General Public License for more details.
rem #
rem # You should have received a copy of the GNU Lesser General Public
rem # License along with this library; if not, write to the Free Software
rem # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
rem # USA
rem #
rem # Initial developer(s): Philippe Merle.
rem # Contributor(s): Marc Navarro (mnavarro@wins.uva.nl),
rem #                 Sylvain Leblanc,
rem #                 Christophe Demarey,
rem #                 Jerome Offroy.
rem #
rem # ====================================================================

@setlocal

rem #  =====================
rem #  Compute Command Line
rem #  =====================

set /a nb_args=0
for %%i in (%*) do set /a nb_args=nb_args+1

set demo_name=hello
set /a nb=0
set services_args=
set with_ots="false"
set with_trace="false"

:initial
if "%1" == "-h" goto help
if "%1" == "--ots" goto ots
if "%1" == "--trace" goto trace
if %nb% == %nb_args% (goto end_command_line) else (goto arguments) 

:ots
set with_ots="true"
set services_args=%services_args% --ots
shift
set /a nb=nb+1
goto initial

:trace
set with_trace="true"
set services_args=%services_args% --trace
shift
set /a nb=nb+1
goto initial

:arguments
set command_args=%command_args% %1
shift
set /a nb=nb+1
goto initial

:help
echo usage: start_java [--ots] [--trace]
goto :eof

:end_command_line

rem # ===========================
rem # Ant compilation if needed.
rem # ===========================

if not exist generated\idl\%demo_name%.idl (call ant)
if not exist archives\%demo_name%.jar (call ant)

rem # =============================
rem # Install the OpenCCM Platform.
rem # =============================

call ccm_install

rem # =============================
rem # Start the Name Service.
rem # =============================

call ns_start

rem # =============================
rem # Start the transaction service
rem # =============================

if %with_ots% == "true" (call ots_start)

rem # ===========================================
rem # Obtain the IOR of the started Name Service.
rem # ===========================================

call ns_ior > %OpenCCM_CONFIG_DIR%\%demo_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\%demo_name%.tmp) do set ior_NS=%%i
del %OpenCCM_CONFIG_DIR%\%demo_name%.tmp

rem # ==================================================
rem # Obtain the IOR of the started Transaction Service.
rem # ==================================================

if %with_ots% == "false" goto jcs
call ots_ior > %OpenCCM_CONFIG_DIR%\%demo_name%.tmp
for /f %%i in (%OpenCCM_CONFIG_DIR%\%demo_name%.tmp) do set ior_OTS=%%i
del %OpenCCM_CONFIG_DIR%\%demo_name%.tmp

rem # =============================
rem # Start Java Component Servers.
rem # =============================

:jcs
call jcs_start %services_args% ComponentServer1
call jcs_start %services_args% ComponentServer2 

echo Demonstration hello is ready to be used ...
