/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Philippe Merle, Jerome Moroy.
Contributor(s): ______________________________________.

====================================================================
$Id: MapTable.java,v 1.2 2005/07/05 09:23:38 moroy Exp $
====================================================================*/

package org.objectweb.util.explorer.plugin.java.map;

import org.objectweb.util.explorer.api.Table;
import org.objectweb.util.explorer.api.TreeView;
import org.objectweb.util.explorer.core.naming.lib.DefaultEntry;

/**
 * Provides the list of elements contained in the map.
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class MapTable 
  implements Table 
{


    //==================================================================
    //
    // No internal state.
    //
    //==================================================================

    //==================================================================
    //
    // No constructor.
    // 
    //==================================================================

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // No public method.
    //
    //==================================================================

    /**
     * Returns the table headers.
     */
    public String[] getHeaders(TreeView treeView) 
    {
        return new String[]{"Keys","Values"};
    }

    /**
     * Returns the rows of the table.
     * Provides the list of elements contained in the map.
     */
    public Object[][] getRows(TreeView treeView) 
    {
        // Obtains the selected Map.
        java.util.Map map = (java.util.Map)treeView.getSelectedObject();
        
        // Obtains the map entries.
        java.util.Map.Entry[] elements = 
          (java.util.Map.Entry[])map.entrySet().toArray(new java.util.Map.Entry[0]);
        
        // Creates the array of entries.
        Object[][] mappings = new Object[map.size()][2];
        for (int i = 0; i < elements.length; i++) {
            mappings[i] = 
              new Object[]{elements[i].getKey(), 
                           new DefaultEntry(elements[i].getKey().toString(), elements[i].getValue())};
        }
        return mappings;
    }

}