/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.util.explorer.plugin.java.reflect;

/**
 * 
 *
 * @author <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>,
 *         <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>
 * 
 * @version 0.1
 */
public class ClassUtil 
    extends MemberUtil {

    //==================================================================
    //
    // Internal states.
    //
    //==================================================================

    protected Class class_;

    //==================================================================
    //
    // Constructor.
    // 
    //==================================================================

    public ClassUtil(Class theClass){
        super();
        class_ = theClass;
    }

    public ClassUtil(Class theClass, ClassVisibilityConfig config) {
        super(config);
        class_ = theClass;
    }

    //==================================================================
    //
    // No internal method.
    //
    //==================================================================

    //==================================================================
    //
    // Public method.
    //
    //==================================================================
    
    /**
     * Provides an HTML representation of a Class
     */
    public String toHTML(){
        String visibility = getVisibility(class_.getModifiers());
        StringBuffer name = new StringBuffer((visibility!=null?"<i>"+visibility+"</i>" + " ":"") + "<b>" + class_.getName().substring(class_.getName().lastIndexOf('$') + 1) + "</b>");
        return name.toString();
    } 

}

    