/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.menu.api;

import org.objectweb.util.explorer.core.common.api.Description;

/**
 * This interface represents the Accelerator element of the Explorer Descriptor file.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public interface AcceleratorDescription         
         extends Description
{

    public void setAcceleratorCharacter(char car);
    public char getAcceleratorCharacter();
    
    public void setCtrlKey(boolean ctrlKey);
    public boolean getCtrlKey();
    
    public void setAltKey(boolean altKey);
    public boolean getAltKey();
    
    public void setShiftKey(boolean shiftKey);
    public boolean getShiftKey();
    
    public void setMetaKey(boolean metaKey);
    public boolean getMetaKey();
    
    public String getName();
}
