/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.menu.lib;

import org.objectweb.util.explorer.core.common.api.Description;
import org.objectweb.util.explorer.core.menu.api.MnemonicDescription;

/**
 * Basic implementation of the <code>MnemonicDescription</code> interface. 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class BasicMnemonicDescription 
  implements MnemonicDescription 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    protected char char_=0;
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Public methods for Description interface.
    //
    // ==================================================================
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.core.common.api.Description#getDescriptionType()
     */
    public String getDescriptionType() {
        return Description.MNEMONIC_DESCRIPTION;
    }

    /* (non-Javadoc)
     * @see boolean#isNull()
     */
    public boolean isEmpty() {
        return char_==0;
    }
    
    // ==================================================================
    //
    // Public methods for ... interface.
    //
    // ==================================================================
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.core.menu.api.MnemonicDescription#setMnemonicCharacter(char)
     */
    public void setMnemonicCharacter(char car) {
        char_ = car;
    }

    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.core.menu.api.MnemonicDescription#getMnemonicCharacter()
     */
    public char getMnemonicCharacter() {
        return char_;
    }

    // ==================================================================
    //
    // Public methods surcharging Object class.
    //
    // ==================================================================    
    
    /**
     * Surcharging the Object.equals method.
     * @see Object#equals(java.lang.Object)
     */
    public boolean equals(Object o){
        if(o!=null && o instanceof BasicMnemonicDescription){
            return (char_==((BasicMnemonicDescription)o).char_);
        }
        return false;
    }
   
    /**
     * Return a String representation of a BasicMnemonicDescription 
     * @see Object#toString() 
     */    
    public String toString(){
        return "BasicMnemonicDescription[char=" + char_ + "]";
    } 
    
}
