/*
 * @(#)MyPortView 1.0.5 06/01/03
 * 
 * Copyright (C) 2003 Gaudenz Alder
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 *  
 */

package org.objectweb.util.explorer.swing.graph;

import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Shape;
import java.awt.geom.Rectangle2D;

import org.jgraph.JGraph;
import org.jgraph.graph.CellViewRenderer;
import org.jgraph.graph.EdgeRenderer;
import org.jgraph.graph.EdgeView;

public class MyBindingView extends EdgeView {

    private static int portCourantPosition = 0;

    protected static MyEdgeRenderer renderer = new MyEdgeRenderer();

    public MyBindingView(JGraph graph, org.jgraph.graph.CellMapper cm, Object cell) {
        super(cell, graph, cm);
    }

    /**
     * Returns the bounds for the port view.
     */
    public CellViewRenderer getRenderer() {
        return renderer;
    }
    
    public static class MyEdgeRenderer extends EdgeRenderer {
                
        public Rectangle2D getPaintBounds(EdgeView view) {
            Rectangle r = super.getPaintBounds(view).getBounds();
            return new Rectangle(r.x-40,r.y-40,r.width+80,r.height+80);
        }


        public void paint(Graphics g) {
            MyPortView sourceView = (MyPortView) view.getSource();
            MyPortView targetView = (MyPortView) view.getTarget();
            MyPort source = (MyPort)sourceView.getCell();
            MyPort target = (MyPort)targetView.getCell();
            
            Graphics2D g2 = (Graphics2D) g;
            int c = BasicStroke.CAP_BUTT;
            int j = BasicStroke.JOIN_MITER;
            g2.setStroke(new BasicStroke(lineWidth, c, j));
            //g2.setStroke(new BasicStroke(1.0f, BasicStroke.CAP_BUTT,
            // BasicStroke.JOIN_MITER, 1.0f, new float[]{.5f, .5f}, .0f));
            translateGraphics(g);
            g.setColor(getForeground());

            //paint line
            if (view.lineShape != null) {
                Shape s = view.lineShape;
                g2.draw(view.lineShape);
            }

            //paint label
                Object label = graph.convertValueToString(view);
                g2.setStroke(new BasicStroke(1));
                g.setFont(getFont());
                String targetName = target.getName();
                g.drawString(source.getName(),(int)sourceView.getLocation(view).getX(),(int)sourceView.getLocation(view).getY());
                g.drawString(targetName,(int)targetView.getLocation(view).getX()-(targetName.length()*6),(int)targetView.getLocation(view).getY());
                }
    }

}