/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.swing.lib;

import javax.swing.BorderFactory;
import javax.swing.JTextField;

import org.objectweb.util.explorer.core.common.api.TextComponent;
import org.objectweb.util.explorer.swing.api.StatusBar;

/**
 * Basic implementation of a Swing status bar.
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class DefaultStatusBar
     extends JTextField
  implements TextComponent, StatusBar 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    public DefaultStatusBar(){
        super();
        setBorder(BorderFactory.createLoweredBevelBorder());
        setEditable(false);
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods for TextComponent interface. 
    //
    // ==================================================================    
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.core.common.api.TextComponent#setText(java.lang.String)
     */
    public void setText(String message) {
        if(message!=null){
            super.setText(message);
        }
    }

    // ==================================================================
    //
    // Public methods for StatusBar interface. 
    //
    // ==================================================================    
    
    /* (non-Javadoc)
     * @see org.objectweb.util.explorer.swing.api.StatusBar#getStatusBar()
     */
    public JTextField getStatusBar() {
        return this;
    }
}


