/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.menu;

import org.objectweb.util.explorer.core.code.api.CodeDescription;
import org.objectweb.util.explorer.core.code.lib.BasicCodeDescription;
import org.objectweb.util.explorer.core.menu.api.ItemDescription;
import org.objectweb.util.explorer.core.menu.lib.BasicItemDescription;

import junit.framework.Assert;
import junit.framework.TestCase;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class ItemDescriptionTest 
     extends TestCase 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    protected String l1_="label 1", l2_="label 2";
    protected CodeDescription codeDesc_ = null;
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        codeDesc_ = new BasicCodeDescription();
        codeDesc_.setLanguage("Java");
        codeDesc_.setCode("java.lang.Object");
    }    
    
    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    
    
    public void testEqualsMethod(){        
        ItemDescription item1 = new BasicItemDescription();
        ItemDescription expected = new BasicItemDescription();
        Assert.assertEquals(expected,item1);
        expected.setCodeDescription(null);
        Assert.assertEquals(expected,item1);
        item1.setLabel(l1_);
        Assert.assertNotSame(expected, item1);
        expected.setLabel(l2_);
        Assert.assertNotSame(expected,item1);
        expected.setLabel(l1_);       
        Assert.assertEquals(expected,item1);
        item1.setCodeDescription(codeDesc_);
        Assert.assertNotSame(expected, item1);
        expected.setCodeDescription(codeDesc_);
        Assert.assertEquals(expected,item1);
    }
    
    public void testIsEmptyMethod(){
        ItemDescription itemDesc = new BasicItemDescription();
        Assert.assertTrue(itemDesc.isEmpty());
        itemDesc.setLabel(l1_);
        Assert.assertTrue(itemDesc.isEmpty());
        itemDesc.setLabel("");
        itemDesc.setCodeDescription(codeDesc_);
        Assert.assertTrue(itemDesc.isEmpty());
        itemDesc.setLabel(l1_);
        Assert.assertFalse(itemDesc.isEmpty());
    }
    
}


