/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================*/
package org.objectweb.util.explorer.core.menu;

import junit.framework.Assert;
import junit.framework.TestCase;

import org.objectweb.util.explorer.core.menu.api.MnemonicDescription;
import org.objectweb.util.explorer.core.menu.lib.BasicMnemonicDescription;


/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class MnemonicDescriptionTest 
      extends TestCase 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    protected char c1_='A',c2_='B';
    
    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // Internal method.
    //
    // ==================================================================

    // ==================================================================
    //
    // Public methods. 
    //
    // ==================================================================    

    public void testEqualsMethod(){
        MnemonicDescription mnemDesc = new BasicMnemonicDescription();
        mnemDesc.setMnemonicCharacter(c1_);
        MnemonicDescription expected = new BasicMnemonicDescription();
        expected.setMnemonicCharacter(c2_);
        Assert.assertNotSame(expected,mnemDesc);
        expected.setMnemonicCharacter(c1_);
        Assert.assertEquals(expected,mnemDesc);
    }
    
}

