/*====================================================================

Objectweb Explorer Framework
Copyright (C) 2000-2005 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Moroy, Philippe Merle.
Contributor(s): ______________________________________.

====================================================================
$Id: ParserUtilsTest.java,v 1.2 2005/07/06 15:36:02 moroy Exp $
====================================================================*/

package org.objectweb.util.explorer.parser.lib;

import org.objectweb.util.explorer.ExplorerUtils;

import junit.framework.Assert;
import junit.framework.TestCase;

/**
 * 
 *
 * @author <a href="mailto:Jerome.Moroy@lifl.fr">Jrme Moroy</a>,
 *         <a href="mailto:Philippe.Merle@lifl.fr">Philippe Merle</a>.  
 * 
 * @version 0.1
 */
public class ParserUtilsTest 
     extends TestCase 
{

    //==================================================================
    //
    // Internal States.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    // ==================================================================
    //
    // No internal method.
    //
    // ==================================================================

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
    }    

    /**
     * Compares the merge of the two arrays with the expected result.
     */
    protected void test(Object[] a1, Object[] a2, String result){
        Object[] m = ExplorerUtils.mergeArrays(a1,a2);
        String ms = ExplorerUtils.arrayToString(m);
        Assert.assertEquals(result, ms);        
    }
    
    // ==================================================================
    //
    // Public methods for ... interface.
    //
    // ==================================================================    
    
    /*
     * Checks the behavior of the mergeArrays() method from the ParserUtils class. 
     */
    public void testMergeArrays() {
        test(null, null, "{}");
        test(new String[]{"1","2","3"}, new String[]{"1","3","4"}, "{1,2,3,4}");
        test(new String[]{}, new String[]{"1","2","3"}, "{1,2,3}");
        test(new String[]{"1","2","3"}, null, "{1,2,3}");
        test(null, new String[]{"1","2","3"}, "{1,2,3}");
    }
        
}
