/*====================================================================

ObjectWeb Util Launcher Package.
Copyright (C) 2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Romain Rouvoy.
Contributor(s): .

--------------------------------------------------------------------
$Id: OptionVerbose.java,v 1.1 2004/05/19 15:58:29 rouvoy Exp $
====================================================================*/

package org.objectweb.util.launcher.option;


import org.objectweb.util.cmdline.api.Iterator;
import org.objectweb.util.cmdline.lib.DefaultOptionFlag ;

import org.objectweb.util.trace.TraceSystem;


/**
 * Definition of the --verbose option<BR>
 * <p>
 * This option display additional information for the launcher
 * </p>
 *
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public class OptionVerbose
     extends DefaultOptionFlag
{
    /**
     * Default Constructor
     */
    public OptionVerbose() {
        super("--launch_verbose",
              "Display information messages",
              false);
    }

    /**
     * Consumes command line arguments from an iterator.
     *
     * @param iterator The command line argument iterator.
     */
    public void
    consume(Iterator iterator) {
        super.consume(iterator);
        TraceSystem.setLevel("verbose");
    }
}
