#!/bin/sh
#
# usage:  idl3_to_idl2.sh -Iidl_include_dir1 -Iidl_include_dir2 ... component_type component_home_type idl3_file
#
# The selected IFR3.0 and generator are defined in $microCCM_DIR/etc/codegen_config.txt
#

IFR=`cat $microCCM_DIR/etc/codegen_config.txt | grep "USED_IFR" | awk ' { print $3 } ' `
GEN=`cat $microCCM_DIR/etc/codegen_config.txt | grep "USED_GENERATOR" | awk ' { print $3 }' `

OPTIONS=$@

## three last arguments == idl3_file component_type component_home_type

INCLUDE_OPTIONS=""
IDL3_FILE=""
COMPONENT_TYPE=""
COMPONENT_HOME_TYPE=""
is_it_include=""

nbargs=$#
let idl3_file_index=$nbargs
let idl3_comp_type_index=$nbargs-2
let idl3_comp_home_type_index=$nbargs-1

loop_counter=0

loop_counter_aux=""

for OPT in $OPTIONS
do
  let loop_counter=loop_counter+1
#  echo "loop_counter == $loop_counter"

  is_it_include=`echo $OPT | cut --characters=-2`
#  echo "is_it_include == $is_it_include" 

  if [ $is_it_include = "-I" ]
   then INCLUDE_OPTIONS=" $OPT $INCLUDE_OPTIONS"
#   echo "include_option == $INCLUDE_OPTIONS"
  fi

   loop_counter_aux=`echo $idl3_file_index`

 if [ $loop_counter_aux = $loop_counter ]
    then IDL3_FILE=$OPT
#    echo "set_idl3_file"
   fi

    loop_counter_aux=`echo $idl3_comp_type_index`

  if [ $loop_counter_aux = $loop_counter ]
    then COMPONENT_TYPE=$OPT
#    echo "set_comp_type"
   fi
    
    loop_counter_aux=`echo $idl3_comp_home_type_index`

  if [ $loop_counter_aux = $loop_counter ]
    then COMPONENT_HOME_TYPE=$OPT
#    echo "set_home_type"
   fi

done

echo component: $COMPONENT_TYPE
echo ifr: $IFR
echo target orb: $GEN

TAO_IFR="tao_ifr"
OPENCCM_IFR="openccm_ifr"

TAO_GEN="tao_generator"
OB_GEN="ob_generator"

if [ -z "$IFR" ] || [ -z "$GEN" ]; then
echo One of the variables is empty
exit
fi

if [ "$IFR" = "$TAO_IFR" ] && [ "$GEN" = "$TAO_GEN" ]; then
export IFR_IOR_DIR=$microCCM_DIR/etc
export IFR_IOR_FILE="IFR_ior.txt"
tao_ir3_start
tao_ir3_feed $INCLUDE_OPTIONS $IDL3_FILE
idl3_to_idl2.exe $COMPONENT_TYPE $COMPONENT_HOME_TYPE
tao_ir3_stop
elif [ "$IFR" = "$OPENCCM_IFR" ] && [ "$GEN" = "$TAO_GEN" ]; then
export IFR_IOR_DIR=$OpenCCM_CONFIG_DIR
export IFR_IOR_FILE="IR3.IOR"
mccm_ir3_start
ir3_feed $INCLUDE_OPTIONS $IDL3_FILE
idl3_to_idl2.exe $COMPONENT_TYPE $COMPONENT_HOME_TYPE
ir3_stop
else
echo Bad parameter
fi

