#!/bin/sh
#
# usage:  idl3_to_idl2.sh interface1 interface2 ... idl3_file
#
# The selected IFR3.0 and generator are defined in $microCCM_DIR/etc/codegen_config.txt
#


IFR=`cat $microCCM_DIR/etc/codegen_config.txt | grep "USED_IFR" | awk ' { print $3 } ' `
GEN=`cat $microCCM_DIR/etc/codegen_config.txt | grep "USED_GENERATOR" | awk ' { print $3 }' `

OPTIONS=$@


IDL3_FILE=""
INCLUDE_OPTIONS=""
INTERFACE_TYPE=""

nbargs=$#
let idl3_file_index=$nbargs
loop_counter=0
loop_counter_aux=""

for OPT in $OPTIONS
do
    let loop_counter=loop_counter+1
#    echo "loop_counter == $loop_counter"

    loop_counter_aux=`echo $idl3_file_index`

    if [ $loop_counter_aux = $loop_counter ]
    then IDL3_FILE=$OPT
#    echo "set_idl3_file"
    else INTERFACE_TYPE="$OPT $INTERFACE_TYPE"
    fi

done

echo idl3 file: $IDL3_FILE
echo target interfaces: $INTERFACE_TYPE

TAO_IFR="tao_ifr"
OPENCCM_IFR="openccm_ifr"

TAO_GEN="tao_generator"
OB_GEN="ob_generator"

if [ -z "$IFR" ] || [ -z "$GEN" ]; then
echo One of the variables is empty
exit
fi

if [ "$IFR" = "$TAO_IFR" ] && [ "$GEN" = "$TAO_GEN" ]; then
export IFR_IOR_DIR=$microCCM_DIR/etc
export IFR_IOR_FILE="IFR_ior.txt"
tao_ir3_start
tao_ir3_feed $INCLUDE_OPTIONS $IDL3_FILE

for i in $INTERFACE_TYPE
do 
    ir3_to_idl2_for_intf.exe $i 2> /dev/null
done

tao_ir3_stop
elif [ "$IFR" = "$OPENCCM_IFR" ] && [ "$GEN" = "$TAO_GEN" ]; then
export IFR_IOR_DIR=$OpenCCM_CONFIG_DIR
export IFR_IOR_FILE="IR3.IOR"
mccm_ir3_start
ir3_feed $INCLUDE_OPTIONS $IDL3_FILE

for i in $INTERFACE_TYPE
do
    ir3_to_idl2_for_intf.exe $i 2> /dev/null
done

ir3_stop
else
echo Bad parameter
fi

