#include <fstream>
#include <string>

#include <HomeFinderC.h>
#include <Lw_ComponentsC.h>
#include <microccm_my_interface_1C.h>

#include <obtain_ref_home_finder.h>
#include <signal.h>


using namespace std;

  
int main(int argc, char* argv[])
{
  CORBA::ORB_var the_orb = CORBA::ORB_init( argc, argv );

  Components::HomeFinder_var ref_for_home_finder
    = obtain_ref_for_home_finder( the_orb.in() );

  // --

  Components::CCMHome_var home_c1_ 
    = ref_for_home_finder->find_home_by_home_type( "IDL:C1_home/1.0" );

  Components::KeylessCCMHome_var home_c1
    = Components::KeylessCCMHome::_narrow( home_c1_.in() );

  // --

  Components::CCMHome_var home_c2_
    = ref_for_home_finder->find_home_by_home_type( "IDL:C2_home/1.0" );

  Components::KeylessCCMHome_var home_c2
    = Components::KeylessCCMHome::_narrow( home_c2_.in() );

  // --

  Components::CCMObject_ptr c1_instance = home_c1->create_component();
  Components::CCMObject_ptr c2_instance = home_c2->create_component();

  c1_instance->connect( "intf3", c2_instance->provide_facet( "the_intf3" ) );

  CORBA::Object_var obj_facet_c1 
    = c1_instance->provide_facet( "the_intf1" );

  my_interface_1_ptr the_intf1
    = my_interface_1::_narrow( obj_facet_c1.in() );

  the_intf1->do_something( "bidule" );

  home_c1_->remove_component(c1_instance);

  
  the_orb->shutdown();
  the_orb->destroy();

}
