#include <microccm_DesiredSpeed_executor.h>

class DesiredSpeed_impl : public CCM_DesiredSpeed,
			  public CCM_SpeedInterface
{
public:

  CCM_SpeedInterface_ptr get_speed_indic();

  void decrease_speed();

  CORBA::Float speed();
  void speed( CORBA::Float f );

  void configuration_complete() throw( Components::InvalidConfiguration );

private:

  float desired_velocity_;
};

// --------------------------------------------------------------------------

void DesiredSpeed_impl::configuration_complete() throw( Components::InvalidConfiguration )
{
}

CCM_SpeedInterface_ptr DesiredSpeed_impl::get_speed_indic()
{
  return this;
  // return CCM_SpeedInterface::_duplicate( this ); ??
}

void DesiredSpeed_impl::decrease_speed()
{
  desired_velocity_ -= 1.0;
  if( desired_velocity_ < 0 ) desired_velocity_ = 0;
}

CORBA::Float DesiredSpeed_impl::speed()
{
  return desired_velocity_;
}

void DesiredSpeed_impl::speed( CORBA::Float f )
{
  desired_velocity_ = f;
}

// --------------------------------------------------------------------------

class DesiredSpeedHome_impl : public CCM_DesiredSpeedHome
{
public:
  Components::EnterpriseComponent_ptr create() throw( Components::CCMException );
};

Components::EnterpriseComponent_ptr DesiredSpeedHome_impl::create()
  throw( Components::CCMException )
{
  return new DesiredSpeed_impl;
}

// --------------------------------------------------------------------------

// Entry point for home creation

extern "C"
{

  Components::HomeExecutorBase* create_home_exec()
  {
    return new DesiredSpeedHome_impl;
  }

}

// ---------------------------------------------------------------------------
