#include <microccm_Throttle_executor.h>

#include <threading_utils.h>

#include <iostream>
using std::cerr;
using std::endl;

class Throttle_impl : public CCM_Throttle,
		      public CCM_ThrottleInterface,
		      public Components::SessionComponent
{
public:

  CCM_ThrottleInterface_ptr get_a_throttle_intf();

  void set_session_context( Components::SessionContext_ptr the_ctx )
    throw( Components::CCMException );

  void configuration_complete() throw( Components::InvalidConfiguration );

  CORBA::Float throttle_value();
  void throttle_value( CORBA::Float value );

private:

  CCM_Throttle_Context_ptr ctx_;

  threading::protected_resource< CORBA::Float > throttle_value_;
};

// -----------------------------------------------------------------

CCM_ThrottleInterface_ptr Throttle_impl::get_a_throttle_intf()
{
  return this;
}

void 
Throttle_impl::set_session_context( Components::SessionContext_ptr the_ctx )
  throw( Components::CCMException )
{
  ctx_ = CCM_Throttle_Context::_narrow( the_ctx );
}

void Throttle_impl::configuration_complete() throw( Components::InvalidConfiguration )
{
}

CORBA::Float Throttle_impl::throttle_value()
{
  return throttle_value_;
}

void Throttle_impl::throttle_value( CORBA::Float f )
{
  cerr << "Throttle_impl::throttle_value called with value == " << f << endl;
  throttle_value_ = f;
}

// ------------------------------------------------------------------


class ThrottleHome_impl : public CCM_ThrottleHome
{
public:
  Components::EnterpriseComponent_ptr create() throw( Components::CCMException );
};

Components::EnterpriseComponent_ptr ThrottleHome_impl::create() 
  throw( Components::CCMException )
{
  return new Throttle_impl;
}

// ---------------------------------------------------------------------

extern "C"
{
  Components::HomeExecutorBase* create_home_exec()
  {
    return new ThrottleHome_impl;
  }
}

// ----------------------------------------------------------------------
