#ifndef Contained_wrapper_h
#define Contained_wrapper_h

#include <Stubs_IR3.h>

#include <list>
using namespace std;

class Contained_wrapper
{
 public:

  virtual list< CORBA::Contained_ptr > get_dependencies() = 0;
  virtual void dump_as_idl_language( ostream& os ) = 0;
};

class InterfaceDef_wrapper : public Contained_wrapper
{
 public:

  InterfaceDef_wrapper( CORBA::Contained_ptr the_contained,
			CORBA::ComponentIR::Repository_ptr );

  list< CORBA::Contained_ptr > get_dependencies();  
  void dump_as_idl_language( ostream& os );

 private:

  CORBA::InterfaceDef_ptr the_intf_def_;
  CORBA::ComponentIR::Repository_ptr the_repo_ref_;
};

class StructDef_wrapper : public Contained_wrapper
{
 public:

  StructDef_wrapper( CORBA::Contained_ptr the_contained,
		     CORBA::ComponentIR::Repository_ptr );

  list< CORBA::Contained_ptr > get_dependencies();
  void dump_as_idl_language( ostream& os );

 private:
  
  CORBA::StructDef_ptr the_struct_def_;
  CORBA::ComponentIR::Repository_ptr the_repo_ref_;
};

class ExceptionDef_wrapper : public Contained_wrapper
{
 public:

  ExceptionDef_wrapper( CORBA::Contained_ptr the_contained,
			CORBA::ComponentIR::Repository_ptr );

  list< CORBA::Contained_ptr > get_dependencies();
  void dump_as_idl_language( ostream& os );

 private:

  CORBA::ExceptionDef_ptr the_except_def_;
  CORBA::ComponentIR::Repository_ptr the_repo_ref_;
};

class EnumDef_wrapper : public Contained_wrapper
{
 public:

  EnumDef_wrapper( CORBA::Contained_ptr the_contained,
		   CORBA::ComponentIR::Repository_ptr rep );

  list< CORBA::Contained_ptr > get_dependencies();
  void dump_as_idl_language( ostream& os );

 private:

  CORBA::EnumDef_ptr the_enum_def_;
  CORBA::ComponentIR::Repository_ptr the_repo_ref_;
};

class Alias_wrapper : public Contained_wrapper
{
 public:

  Alias_wrapper( CORBA::Contained_ptr the_contained,
		 CORBA::ComponentIR::Repository_ptr rep );

  list< CORBA::Contained_ptr > get_dependencies();
  void dump_as_idl_language( ostream& os );

 private:

  CORBA::AliasDef_ptr an_alias_def_;
};

class Contained_wrapper_factory
{
  public:

  static Contained_wrapper* 
    create_contained_wrapper( CORBA::Contained_ptr cont,
			      CORBA::ComponentIR::Repository_ptr rep );

};

#endif // Contained_wrapper_h
