
// --------------------------------------------------------------------

template< typename S >
Correspondance_table< S >::Storage_item::Storage_item( )
{
  name = 0;
}

template< typename S >
Correspondance_table< S >::Storage_item::~Storage_item( )
{
  if( name ) delete[] name;
}

template< typename S >
void 
Correspondance_table< S >::Storage_item::set_name( const char* the_name )
{
  if( name ) delete[] name;
  name = new char[ strlen( the_name ) + 1 ];
  strcpy( name, the_name );
}

// ---------------------------------------------------------------------

template< typename S >
Correspondance_table< S >::Correspondance_table() : nb_items_( 0 )
{
  storage_ = 0;
}

template< typename S >
Correspondance_table< S >::~Correspondance_table()
{
  delete[] storage_;
}

template< typename S >
typename Correspondance_table< S >::iterator Correspondance_table< S >::begin()
{
  return storage_;
}

template< typename S >
typename Correspondance_table< S >::iterator Correspondance_table< S >::end()
{
  typename Correspondance_table< S >::Storage_item* to_be_returned = & storage_[ nb_items_ - 1 ];

  // xxx attention ici !!! c'est un ecrasement memoire a prevoir de facon
  // xxx generale ... ( la valeur de to_be_returned apres le ++ n'est pas
  // xxx forcement valide ... ) 
  to_be_returned++;

  return to_be_returned;
}

template< typename S >
const S& Correspondance_table< S >::operator[]( const char* key ) const
     throw( Correspondance_table< S >::No_such_item )
{
  Storage_item* current_item;

  for( int ct = 0; ct < nb_items_; ct++ )
    {
      current_item = &storage_[ ct ];

      if( strcmp( key, current_item->name ) == 0 )
        {
          return current_item->value;
        }
    }

  throw No_such_item();
}

template< typename S >
S& Correspondance_table< S >::operator[]( const char* key )
{
  Storage_item* current_item;

  for( int ct = 0; ct < nb_items_; ct++ )
    {
      current_item = &storage_[ ct ];

      if( strcmp( key, current_item->name ) == 0 )
        {
          return current_item->value;
        }
    }

  // --- otherwise : not found ...

  nb_items_++;

  Storage_item* new_storage_ = new Storage_item[ nb_items_ ];

  for( int ct = 0; ct < nb_items_ - 1; ct++ )
    {
      new_storage_[ ct ].value = storage_[ ct ].value;
      new_storage_[ ct ].set_name( storage_[ ct ].name );
    }

  if( storage_ ) delete[] storage_;

  storage_ = new_storage_;
  
  Storage_item& the_item = new_storage_[ nb_items_ - 1 ];

  the_item.set_name( key );

  return the_item.value;
}

template< typename S >
bool Correspondance_table< S >::exists( const char* key )
{
  for( int ct = 0; ct < nb_items_; ct++ )
    {
      if( strcmp( storage_[ ct ].name, key ) == 0 )
        {
          return true;
        }
    }

  return false;
}

