#ifndef Cpp_method_h
#define Cpp_method_h

#include <utility>
#include <string>
#include <vector>

using namespace std;

enum virtual_decl
  {
    is_virtual, is_pure_virtual, none
  };
 
class Cpp_method
{
public:
  Cpp_method();

  void set_prototype( string full_prototype );

  bool equals( const Cpp_method& cm );

  void set_return_type( string name_of_return_type );
  void set_name_of_method( string name_of_method );
  void change_name( string name_of_method );

  void set_virtual_decl( virtual_decl );
  void is_static();

  bool has_an_implementation( );

  string get_name_of_method();
  string get_return_type();

  void add_parameter( string type, string name );
  int get_nb_parameters();
  pair<string,string> get_parameter_nb( int i );

  void add_exception_thrown( string name_of_exception );

  string get_typedef_for_method_type( string in_this_class, string alias_name );

  string get_in_class_declaration();
  string get_outof_class_header( string name_of_class );

  string get_call();
  //  faire plutot
  //  string get_call_with_arg_names( vector<string> arg_names );

  friend ostream& operator<<( ostream& os, Cpp_method& meth );

private:

  bool is_static_;
  virtual_decl virtual_decl_;
  string emits_throw_declaration();

  string name_of_return_type_;
  string name_of_method_;
  vector< pair<string,string> > parameters; // "pair<type,name>" in this order

  vector< string > exceptions_thrown;
};

ostream& operator<<( ostream& os, Cpp_method& meth );
#endif // Cpp_method_h
