#include <Stubs_IR3.h>

#include <iostream>
#include <fstream>
using namespace std;

#include <dump_intf_from_ir.h>
#include <compute_idl_item_dependencies.h>
#include <repid_utils.h>
#include <typecode_utils.h>

#include <obtain_repo_ref.h>

void usage( int argc, char** argv )
{
  cerr << "usage : " << argv[ 0 ] << " intf_name " << endl;
  exit( 1 );
}

int main( int argc, char** argv )
{
  if( argc != 2 ) usage( argc, argv );

  CORBA::ORB_ptr the_orb = CORBA::ORB_init( argc, argv );

  CORBA::ComponentIR::Repository_ptr the_repo_ref 
    = obtain_the_repo_ref( the_orb );

  string name_of_IDL_item_to_generate_for( argv[ 1 ] );

  CORBA::Contained_ptr the_item 
    = the_repo_ref->lookup( name_of_IDL_item_to_generate_for.c_str() );

  CORBA::InterfaceDef_ptr as_intf_def
    = CORBA::InterfaceDef::_narrow( the_item );

  if( CORBA::is_nil( as_intf_def ) )
    {
      cerr << " item given is not an intf " << endl; exit( 1 );
    }
  
  string name_of_file_to_generate 
    = string( "microccm_" ) + name_of_IDL_item_to_generate_for + ".idl";

  fstream outfile( name_of_file_to_generate.c_str(), ios::out );
  //  Dump_idl_item_as_idl_language::dump_idl_interface_as_idl_language( outfile, as_intf_def );
  Dump_idl_item_as_idl_language::dump_with_dependencies( outfile, as_intf_def, the_repo_ref );
  outfile.close();
  
  return 0;
}
