#ifndef compute_idl_item_dependencies_h
#define compute_idl_item_dependencies_h

#include <Stubs_IR3.h>

#include <list>
#include <map>
#include <string>

using namespace std;

#include <tree.h>


class Compute_idl_item_dependencies
{
 public:
  static list< CORBA::Contained_ptr >
    compute_interface_dependencies( CORBA::InterfaceDef_ptr the_intf_def,
				    CORBA::ComponentIR::Repository_ptr the_repo_ref );
  
  static list< CORBA::Contained_ptr >
    compute_struct_dependencies( CORBA::StructDef_ptr the_struct_def,
				 CORBA::ComponentIR::Repository_ptr the_repo_ref );
  
  static list< CORBA::Contained_ptr >
    compute_exception_dependencies( CORBA::ExceptionDef_ptr the_except_def,
				    CORBA::ComponentIR::Repository_ptr the_repo_ref );
  
  static tree< CORBA::Contained_ptr > 
    compute_idl_item_dependencies( CORBA::Contained_ptr item,
				   CORBA::ComponentIR::Repository_ptr the_repo );

  static void add_dependencies( tree< CORBA::Contained_ptr >::tree_iterator& tree_iter,
			 CORBA::ComponentIR::Repository_ptr ref_repo );

  static bool is_typecode_authorised( CORBA::TypeCode_ptr typecode );

  static bool is_subnode_already_processed( CORBA::Contained_ptr item );

  static map<string, bool> processed_subnode_map;

};

#endif // compute_idl_item_dependencies_h
