#include <fstream>
#include <iostream>
#include <string>
using namespace std;

#include <IFR3_client_errors.h>

#include <obtain_repo_ref.h>

CORBA::ComponentIR::Repository_ptr 
obtain_the_repo_ref( CORBA::ORB_ptr the_orb )
{
// #ifdef USE_OPENCCM_IR3
//   const char* path_to_get_ior = getenv( "OpenCCM_CONFIG_DIR" );

//   if( !path_to_get_ior )
//     {
//       cerr << "Don't manage to get env var \"OpenCCM_CONFIG_DIR\" " << endl;
//       cerr << "Maybe you have not sourced the OpenCCM script appropriately" << endl;
//       exit( ERROR_NO_OpenCCM_CONFIG_DIR );
//     }

//   string path_to_ior_file = string( path_to_get_ior ) + "/IR3.IOR";

//   cerr << "retrieving IOR from " << path_to_ior_file << endl;
// #endif

// #ifdef USE_TAO_IR3
//   const char* microCCM_DIR = getenv( "microCCM_DIR" );

//   if( !microCCM_DIR )
//     {
//       cerr << "Don't manage to get env var \"OpenCCM_CONFIG_DIR\" " << endl;
//       cerr << "Maybe you have not sourced the OpenCCM script appropriately" << endl;
//       exit( ERROR_NO_OpenCCM_CONFIG_DIR );
//     }

//   string path_to_ior_file = string( microCCM_DIR ) + "/etc/IFR_ior.txt";
// #endif //

  const char* ifr_ior_dir = getenv( "IFR_IOR_DIR" );
  
  if( !ifr_ior_dir )
    {
      cerr << "Don't manage to get env var \"IFR_IOR_DIR\" " << endl;
      cerr << "Maybe this IFR repository is neither an OpenCCM IR, nor a TAO IR." << endl;
      exit( 1 );
    }

   const char* ifr_ior_file = getenv( "IFR_IOR_FILE" );
  
  if( !ifr_ior_file )
    {
      cerr << "Don't manage to get env var \"IFR_IOR_FILE\" " << endl;
      cerr << "Maybe this IFR repository is neither an OpenCCM IR, nor a TAO IR." << endl;
      exit( 1 );
    }
  
  string path_to_ior_file = string( ifr_ior_dir ) + "/" + string( ifr_ior_file );


  fstream infile( path_to_ior_file.c_str(), ios::in );

  if( !infile )
    {
      cerr << "Don't manage to open file " << path_to_ior_file << endl;
      exit( ERROR_NO_FILE_IR3_IOR );
    }

  if( !infile.good() )
    {
      cerr << "Nothing appropriate in the file " << path_to_ior_file << endl;
      exit( ERROR_FILE_IR3_IOR );
    }

  string the_ior;  infile >> the_ior; infile.close();

  CORBA::Object_ptr ref_ir3 = the_orb->string_to_object( the_ior.c_str() );

  if( CORBA::is_nil( ref_ir3 ) )
    {
      cerr << "Obtained nil reference to Object for interface repository" << endl;
      exit( ERROR_NIL_REF_IR3 );
    }

  CORBA::ComponentIR::Repository_ptr the_repo_ref;

  try
    {
      the_repo_ref = CORBA::ComponentIR::Repository::_narrow( ref_ir3 );
    }
  catch( CORBA::SystemException& exc )
    {
      cerr << "exception catched .. exc == " << exc << endl;
      exit( 1 );
    }

  return the_repo_ref;
}

