#include <iostream>
#include <Lw_ComponentsC.h>

#include <Trace_integrationC.h>
#include <microccm_IC.h>

#include <obtain_ref_home_finder.h>
#include <signal.h>

using namespace std;


int main(int argc, char* argv[])
{
  
  CORBA::ORB_var the_orb = CORBA::ORB_init( argc, argv );
  
  Components::HomeFinder_var the_home_finder 
    = obtain_ref_for_home_finder( the_orb.in() );
  
  Components::CCMHome_var C_home
    = the_home_finder->find_home_by_home_type( "IDL:C_home/1.0" );
  
  Components::HomeConfiguration_var the_home_config
    = Components::HomeConfiguration::_narrow( C_home.in() );
  
  StringSeq s_seq; s_seq.length( 2 );

  s_seq[ 0 ] = CORBA::string_dup( "facet1" );
  s_seq[ 1 ] = CORBA::string_dup( "do_something" );

  Components::ConfigValues the_config_values;
  the_config_values.length( 1 );

  the_config_values[ 0 ].name = CORBA::string_dup( "__trace_bidon" );
  the_config_values[ 0 ].value <<= s_seq;

  the_home_config->set_configuration_values( the_config_values );  

  Components::KeylessCCMHome_var kch
    = Components::KeylessCCMHome::_narrow( C_home.in() );

  Components::CCMObject_var comp_ref = kch->create_component();

  CORBA::Object_var obj_ref_I 
    = comp_ref->provide_facet( "facet1" );

  I_var the_i = I::_narrow( obj_ref_I.in() );

  the_i->do_something( "coucou", 23 );

  the_orb->shutdown();
}

