#ifndef _TFTP_DEF_H
#define _TFTP_DEF_H
#define K_MAX_CTX				8
#define K_RESERVE_CTX			K_MAX_CTX+1

#define K_FREE_STATE			0
#define K_WAIT_FREE				1
#define K_WAIT_TRF				2
#define K_WAIT_DATA				3
#define K_WAIT_ACK				4
#define K_WAIT_ACK_REQUEST		5
#define K_WAIT_FRAME			6
#define K_WAIT_END				7
#define K_WAIT_RESP				8

#define K_SIZE_BUFFER 			1024

#define K_MAX_DATA_TFTP			512
#define K_MIN_DATA_TFTP			64

#define K_TFTP_READ_REQUEST		1
#define K_TFTP_WRITE_REQUEST	2
#define K_TFTP_DATA				3
#define K_TFTP_ACK				4
#define K_TFTP_ERROR			5

#define K_MAX_ERROR_NUM			K_ERROR_NORESOURCE+1

#define K_NO_MODE				0

#define K_REPEAT				1
#define K_NEXT					2

#define K_MODE_STR				"octet"

#define K_PORT_TFTP_SERVER		69

#define K_AVANCEMENT			4

typedef struct t_tftp_header
{
	unsigned short op_tftp;
	union
	{
		unsigned short num_pkt;
		unsigned short error;
	} u;
}t_tftp_header;

typedef struct t_ctx_tftp
{
	int sock_number;
	unsigned short  port_dest;
	unsigned long ip_dest;
	int  timeout_emission;
	int  state;
	int  nbretry;
	char read_write;
	char mode;
	char local_file[256];
	char remote_file[256];
	unsigned char buffer[512];
	FILE *fd_file;
	int  lg_data;
	int  packetNumber;
	int  error;
	int  tramesrecues;
	int  tramesemises;
	int  tramesack;
	int  tramesackretry;
	int  tramesdata;
	int  tramesdataretry;
	int  bytesreceived;
	int  bytestransmitted;
	t_fct_callBack callback;
	void *args_callBack;
	t_access_file  *accessFile;
}t_ctx_tftp;

extern char *error_tftp_string[];
extern int g_comportement;

#endif /* _TFTP_DEF_H */
/* left blank for compiler compatibility */
