/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Jerome Offroy.
Contributor(s): ______________________________________.

====================================================================*/

package org.objectweb.corba.trace.PI;

import org.objectweb.util.monolog.api.Logger;
import org.objectweb.util.monolog.provider.lib.LoggerProviderSingleton;


/**
 * @author Jerome Offroy
 * 
 * this class defines all the logger and their associated topic needed in this package 
 *
 */
final public class MonologLogger{
    /**
     * use to optimize code at compilation time : remove trace code in all the package 
     */
    final static boolean enableTrace = true; 
    
    /**
     * Logger definition 
     */
    final static Logger loggerCI = LoggerProviderSingleton.createLogger(
        "interceptors.client",
        TraceCI.class,
        new String[] {"CORBA Interceptor Client"});

    /**
     * Logger definition 
     */
    final static Logger loggerSI = LoggerProviderSingleton.createLogger(
        "interceptors.server",
        TraceSI.class,
        new String[] {"CORBA Interceptor Server"});
}
