/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2003 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

====================================================================*/


package org.objectweb.openccm.Containers.MetaInformation;

/**
 * Type MI for attribute conceopt of CCM
 * An attribute can be bound to a comoponent, 
 * a home or an interface MI object.
 *
 * @author <a href="mailto:hameau@lifl.fr">Hameau</a>
 *
 * @version 0.1
 */

public class AttributeTypeImpl
extends TypeImpl
implements AttributeType {

  // ==================================================================
  //
  // Internal states.
  //
  // ==================================================================

  /** Type MI for component getter attribute*/
  protected GetterAttributeType _getter_attribute_type;
  /** Type MI for component getter attribute*/
  protected SetterAttributeType _setter_attribute_type;

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.AttributeTypeOperations#getter_attribute_type()
   */
  public GetterAttributeType getter_attribute_type()
  {
    return _getter_attribute_type;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.AttributeTypeOperations#setter_attribute_type()
   */
  public SetterAttributeType setter_attribute_type()
  {
    return _setter_attribute_type;
  }



}
