/*====================================================================

created on 21 mars 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.openccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.Components.Cookie;
import org.omg.Components.InvalidConnection;
import org.omg.Components.SubscriberDescription;


/**
 * @author hameau
 */
public class PublisherPortInstanceImpl 
extends EventPortInstanceImpl
implements PublisherPortInstance{

  protected Table _subscribers;

  public PublisherPortInstanceImpl()
  {
    _subscribers = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.PublisherPortInstanceOperations#subscribers()
   */
  public SubscriberDescription[] subscribers()
  {
    return (SubscriberDescription[]) _subscribers.values().toArray(new SubscriberDescription[0]);
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.PublisherPortInstanceOperations#subscribers(org.omg.Components.SubscriberDescription[])
   */
  public void subscribers(SubscriberDescription[] value)
  {
   // TODO : implement this !!!!!!!
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.PublisherPortInstanceOperations#add_subscriber_info(org.omg.Components.SubscriberDescription)
   */
  public void add_subscriber_info(SubscriberDescription info)
  {
   _subscribers.put(info.ck,info);
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.PublisherPortInstanceOperations#remove_subscriber_info(org.omg.Components.SubscriberDescription)
   */
  public void remove_subscriber_info(SubscriberDescription info)
  {
   _subscribers.remove(info.ck);
  }

  public SubscriberDescription get_subscriber_info(Cookie ck)
  throws InvalidConnection
  {
   SubscriberDescription tmp = (SubscriberDescription) _subscribers.get(ck);
   if(tmp == null)
     throw new InvalidConnection();
   
   return tmp;
  }
	

}
