/*
 * Created on 28 janv. 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package org.objectweb.openccm.Deployment;

import java.io.FileReader;
import java.io.File;
import org.objectweb.ccm.descriptor.componentassembly.beans.ComponentassemblyBean;
import org.objectweb.ccm.descriptor.componentassembly.beans.ComponentassemblyBeanImpl;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.FatalDeploymentException;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.HandlerContext;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.base.InitializationError;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.installer.DefaultDestinationDeployerFactory;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.managers.DefaultDeploymentLogger;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.managers.DefaultErrorManager;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.root.ComponentassemblyDeployer;
import org.objectweb.ccm.descriptor.componentassembly.ccm.deployer.root.ComponentassemblyDeployerHandler;
import org.objectweb.ccm.descriptor.deployerconfig.DeployerconfigImpl;
import org.objectweb.ccm.descriptor.deployerconfig.beans.DeployerconfigBeanImpl;
import org.omg.Components.Deployment.AssemblyPOA;
/**
 * @author briclet
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class AssemblyBase extends AssemblyPOA {


    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================
    // Console for emittion of message
    private org.objectweb.util.cmdline.api.Console console;
    
    //Root  of xml tree cad representation
    private ComponentassemblyBean assemblyObject;
        
    // State of the assembly
    private org.omg.Components.Deployment.AssemblyOperations etat;
       
    //Reference on the NameService
    private org.omg.CosNaming.NamingContextExt ns ;
    //Name component involve in the NS registration
    private org.omg.CosNaming.NameComponent [] ncomp;

    private java.util.zip.ZipFile zipFile;
    
    private AssemblyConfigurator configurator;
    
    private ComponentassemblyDeployerHandler handler;
    
    private String registrationName;
    
    private String assemblyWorkDirPath;
    
    private File assemblyWorkDir;
    
    private  DefaultDeploymentLogger ddl=null;
    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    public AssemblyBase(AssemblyConfigurator configurator){
        this.configurator=configurator;
        etat=new AssemblyImplInactive();
        assemblyObject=configurator.getComponentassemblyTree();
        init();
    }
    
   private void 
   init()
   {
      
       try{
           handler=((ComponentassemblyDeployerHandler)                  
                               assemblyObject
                               .getExtensionManager()
                               .getExtensionByName("ccm.deployer.root.Deployer"));                                 
           handler.connectHandlerContext(new HandlerContext());     
                 
           java.net.ServerSocket s = new java.net.ServerSocket(0);
                      
        

           handler.connectServerSocket(s);
           ddl=new DefaultDeploymentLogger(/*System.getProperty("WorkDir")
                                              +"DeploymentLog.txt"*/);
           handler.connectDeploymentLogger(ddl);

       }
       catch(Exception e)
          {
              e.printStackTrace(); 
             //hrow new org.omg.Components.CreateFailure();
          }
        
           try{
           						
                  FileReader fr=new FileReader
                      (System.getProperty("DeployerConfigFile"));
                  DeployerconfigImpl depl_conf=(DeployerconfigImpl) 
                                                DeployerconfigBeanImpl.unmarshal(fr,true);
                  DefaultErrorManager erm=new DefaultErrorManager(depl_conf);
                  erm.connectDeploymentLogger(ddl);
                  handler.connectErrorManager(erm);
               
                  DefaultDestinationDeployerFactory dddf=
                           new DefaultDestinationDeployerFactory(depl_conf);

                  handler.connectDestinationDeployerFactory(dddf);

              }
              catch(Exception e){
                /* getDeployer().getRootDeployerContext()
                              .getDeploymentLogger()
                              .log(">> Error manager : No configuration file precised");*/
                  e.printStackTrace();
                  System.err.println(">> Error manager : No configuration file precised");
              }
        
           configurator.configure(handler);
           
   }
           
    /**
     * Internal function to register the assembly with the specified name 
     * in cad descriptor in order to retrieve and tear_down the assembly later.
     */
    public void
    registerAssembly()
    {
      
        try{
            // retrieve the corba reference from the assembly object
            org.omg.Components.Deployment.Assembly assemblyRef=
                configurator.getAssembly();
            
            // Obtain the Name Service.
            ns=org.omg.CosNaming.NamingContextExtHelper
                .narrow(org.objectweb.openccm.corba
                        .TheNameService
                        .getNamingContext()
                        .getNamingContext());
            
            // Bind the server object in the name service.
            ncomp= org.objectweb.ccm.descriptor
                    .componentassembly
                    .ccm.deployer.registrar
                    .RegisterwithnamingDeployer
                        .rebind(ns,
                                System.getProperty("Assemblies_ns_dir")+
                                assemblyObject.getId(),
                                assemblyRef);
            registrationName=ns.to_string(ncomp).replace('/','.');
            //Now we have the assembly name we can create
            //the assembly work directory
            assemblyWorkDirPath=System.getProperty("WorkDir")+"/"+registrationName;
            assemblyWorkDir=new File(assemblyWorkDirPath);
            assemblyWorkDir.mkdirs();
            ddl.setLogFile(assemblyWorkDirPath+"/DeploymentLog.log");
            
            }
        catch(Exception e){
             System.err.println("Following exception occur during assembly registration");
             System.err.println(e.getMessage());
             System.err.println("Cannot register the assembly"+
                                System.getProperty("Assemblies_ns_dir") +
                                assemblyObject.getId());
             return ;
        }
        System.out.println("The Assembly"+
                               System.getProperty("Assemblies_ns_dir")+
                               assemblyObject.getId()+" is referenced");
    }
    
  
    /**
     * Unregister the assembly from the NameService
     */
    public void
    unregisterAssembly()    
    {
        try{   
            ComponentassemblyDeployer cad=(ComponentassemblyDeployer)
                
             handler.getInstance((ComponentassemblyBeanImpl)assemblyObject);
             cad.clearAllStream();
        }catch(Exception e)
        {
            e.printStackTrace();
           System.err.println("Problem occured during stream closing");
        }
        
        try{
            ns.unbind(ncomp);
            ddl.removeLogFile();            
            configurator.deleteTemporaryFile();
            assemblyWorkDir.delete();
        }
        catch(Exception e){
             System.err.println("Following exception occur during assembly unregistration");
             System.err.println(e.getMessage());
             System.err.println("Cannot unregister the assembly"+
                                System.getProperty("Assemblies_ns_dir")+
                                assemblyObject.getId());
        }
    }

    // ==================================================================
    //
    // Internal class.
    //
    // ==================================================================
     /**
     * Inactive state for the assembly
     */
    private class AssemblyImplInactive 
        implements  org.omg.Components.Deployment.AssemblyOperations 
    { 
        
        private java.io.File tmpZipFile;
        

       
        
        public void 
        build() 
        throws org.omg.Components.CreateFailure 
        {
            try{
                    
                ComponentassemblyDeployer cad=(ComponentassemblyDeployer)
                
                handler.getInstance((ComponentassemblyBeanImpl)assemblyObject);
                                
                cad.setWorkDir(assemblyWorkDirPath);
                
                cad.deploy();
                cad.configueCompleteComponents();               
              
            }
            catch(InitializationError er){
                er.printStackTrace();
                /*if(er.getInitialException()!=null)
                    er.getInitialException().printStackTrace();*/
                throw new org.omg.Components.CreateFailure();
            }
            catch(FatalDeploymentException fde){
                System.err.println(fde.getMessage());
                //fde.printStackTrace();
            }
           
            etat=(org.omg.Components.Deployment.AssemblyOperations) new AssemblyImplActive();
         }
    
            
        /**
         * Private function allowing inactive assembly to load 
         * tree representation of the xml cad file
         */
        
        
        /**
         * Break connection between composant and destroy them
         */ 
        public void tear_down() throws org.omg.Components.RemoveFailure
        {
            throw new  org.omg.Components.RemoveFailure();  
        }
        
        /**
         * Return the current assembly state    
         */
        public org.omg.Components.Deployment.AssemblyState get_state()
        {
            return  org.omg.Components.Deployment.AssemblyState.INACTIVE;
            
        }
    }   
    
    /**
     * Internal class which represent an deploied assembly, only 
     * tear_down() and get_state() operation are available 
     */
    private class AssemblyImplActive 
        implements org.omg.Components.Deployment.AssemblyOperations
    {
        /**
         * Alway thrown CreateFailure exception because the assembly
         * is already deploied. This function is non available
         */
        public void build() throws org.omg.Components.CreateFailure
        {
            throw new org.omg.Components.CreateFailure();
        }
        
        /**
         *  Tear_down the assembly in 2 part: 
         *      First tear_down connections
         *      Secondly erease instantiation
         *  Switch the internal state of the assembly to inactive state.
         */
        public void tear_down() throws org.omg.Components.RemoveFailure 
        {
            try{ 
                ComponentassemblyDeployer cad=
                   ((ComponentassemblyDeployer)
                     ((ComponentassemblyDeployerHandler)                  
                    assemblyObject
                    .getExtensionManager().getExtensionByName("ccm.deployer.root.Deployer"))                 
                    .getInstance((ComponentassemblyBeanImpl)assemblyObject));
                
                cad.tearDown();
                etat=(org.omg.Components.Deployment.AssemblyOperations)new AssemblyImplInactive();
                configurator.removeAssembly();
            }
            catch(Exception e){e.printStackTrace();}
            
        }
        
        /**
         * Break connection between composant and destroy them
         */ 
        public org.omg.Components.Deployment.AssemblyState get_state()
        {
            return org.omg.Components.Deployment.AssemblyState.INSERVICE;
        }
    }
    
    // ==================================================================
    //
    // Public methods.
    //
    // ==================================================================

  
        

    // ==================================================================
    //
    // Assembly interface methods    
    //
    // ==================================================================

    /*Delegation operation to the state assembly*/
    public void 
    build() 
    throws org.omg.Components.CreateFailure
    {
        etat.build();   
    }
    
    public void 
    tear_down() 
    throws org.omg.Components.RemoveFailure 
    {
        etat.tear_down();   
    }
    
    
    public org.omg.Components.Deployment.AssemblyState 
    get_state()
    {
        return etat.get_state();
    }
   
    


}
