/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/
package org.objectweb.openccm.descriptor.componentassembly.gui;

// Local Interface Import Statements
import org.objectweb.apollon.framework.Extension;
import org.objectweb.apollon.framework.ExtensionManager;

/**
 * This is an extension to the Apollon generated framework around componentassembly DTD
 *  it looks for subelements that could contain files to archive
 *  and calls their own zipper extensions to do the same job
 *  any found file name is sent to a zip factory
 *
 */
public class ProcesscollocationZipperHandler
     extends Extension
{

    private ExtensionManager _extManager;

    private ProcesscollocationZipper _zipper;

    public ProcesscollocationZipperHandler() {
        _zipper = new ProcesscollocationZipper();
    }

    public Object getInstance() {
        return (_zipper);
    }

    public String toString() {
        return("gui.Zipper");
    }

}
