/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s):

====================================================================*/

package org.objectweb.openccm.descriptor.corbacomponent.gui;

import org.objectweb.openccm.descriptor.corbacomponent.beans.*;
import org.objectweb.openccm.descriptor.corbacomponent.*;

/**
 * This is an extension to the Apollon generated framework around corbacomponent DTD
 *  it looks for subelements that could contain files to archive
 *  and calls their own zipper extensions to do the same job
 *  any found file name is sent to a zip factory
 *
 */
public class CorbacomponentZipper
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /**
     *  The constructor taking an event as parameter
     */
    public void
    zipCall(
        CorbacomponentBean corbacomponent
        , org.objectweb.openccm.packaging.ZipFactory zip_factory
        )
    {
        // coponent properties file
        ComponentpropertiesBean componentproperties
         = (ComponentpropertiesBean) corbacomponent.getComponentproperties();
        // goes through sub element and call its zip method
        if (componentproperties != null)
        {
            ComponentpropertiesZipper sub_zipper
             = (ComponentpropertiesZipper) componentproperties
                .getExtensionManager()
                .getExtensionByName("gui.Zipper")
                .getInstance();

            sub_zipper.zipCall(componentproperties, zip_factory);
        }

        // home properties file
        HomepropertiesBean homeproperties
         = (HomepropertiesBean) corbacomponent.getHomeproperties();
        // goes through sub element and call its zip method
        if (homeproperties != null)
        {
            HomepropertiesZipper sub_zipper
             = (HomepropertiesZipper) homeproperties
                .getExtensionManager()
                .getExtensionByName("gui.Zipper")
                .getInstance();

            sub_zipper.zipCall(homeproperties, zip_factory);
        }
    }
}
