/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.packaging;

import org.objectweb.apollon.gui.ApollonFrame;

/**
 * This is the CCM Menu Bar for OpenCCM's Packaging/Assembling Tool
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class CCMMenuBar
  implements java.awt.event.ActionListener
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    /** the associated frame */
    private ApollonFrame frame_;

    // ==================================================================
    //
    // Constructors
    //
    // ==================================================================

    public
    CCMMenuBar(ApollonFrame frame)
    {
        this.frame_ = frame;

        javax.swing.JMenu archive_menu =  new javax.swing.JMenu("CCM");

        javax.swing.JMenuItem openitem = new javax.swing.JMenuItem("Open Archive...");
        openitem.setActionCommand("Open");
        openitem.addActionListener(this);
        archive_menu.add(openitem);

        this.frame_.getJMenuBar().add(archive_menu);
    }

    /**
     *  When an action is performed on this frame.
     *
     */
    public void
    actionPerformed(java.awt.event.ActionEvent e)
    {

        if (e.getActionCommand().equals("Open"))
        {
            // get a file from an open dialog box
            java.io.File file=null;
            javax.swing.JFileChooser dialogBox
             = new javax.swing.JFileChooser(
                System.getProperty("user.dir")
                );
            int returnVal = dialogBox.showOpenDialog(new javax.swing.JPanel());

            if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION)
            {
                file = dialogBox.getSelectedFile().getAbsoluteFile();
            }
            else
                return;

            FileOperations.open_file(file,frame_);
        }
    }
}
