/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Contreras
Contributor(s): ___________________________________________________.

====================================================================*/

package org.objectweb.openccm.packaging;

import org.objectweb.apollon.gui.ApollonFrame;

/**
 * This is the GUI launcher for the Packaging and Assembly tools
 *
 * @author <a href="mailto:Christophe.Contreras@lifl.fr">Christophe Contreras</a>
 *
 */
public class ToolsGUI
{

    // ==================================================================
    //
    // Static public methods.
    //
    // ==================================================================

    /**
     * The main bootstrap method.
     *
     * @param args The command line arguments.
     */
    public static void
    main(String[] args)
    {
        // inits the graphical frame
        ApollonFrame frame
         = new ApollonFrame();

        // inits the split panel of the frame
        frame.set_split_panel(new CCMSplitPane());

        // Adds the CCM part of the Menubar to existing
        CCMMenuBar ccm_menubar
         = new CCMMenuBar(frame);

        // opens files given as arguments
        if (args.length !=0)
        {
            for (int i=0 ; i<args.length ; i++)
            {
                java.io.File file
                 = new java.io.File(args[i]);

                FileOperations.open_file(file, frame);
            }
        }
        frame.setVisible(true);
    }
}
