#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Areski Flissi
# Contributor(s): 
#
# ==============================================================================
#
# Starting the deployment process.
#
# Usage: ccm_deploy.sh -F <FactoryName> <AssemblyArchive>
#
# ==============================================================================

# $3 = path ZIP (.aar) archive to deploy

if [ $# != 3 ]
then
    echo "======================================================================="
    echo "Usage: ccm_deploy.sh -F <FactoryName> <AssemblyArchive>"
    echo "======================================================================="
    exit 1
fi

# Get the IOR of the started NS
ns_ior=`cat @OpenCCM_CONFIG_DIR@/NameService.IOR`

# Get the IOR of the started DCI Manager
dci_ior=`cat @OpenCCM_CONFIG_DIR@/DCI.IOR`


echo "Starting deployment process..."
@JVM@ -Dior_ns=$ns_ior -Dior_dci=$dci_ior org.objectweb.util.launcher.Launcher --runid deploy $1 $2 $3 @OpenCCM_DIR@/xml/launcher/Deployment.xml
echo "Demonstration is ready to be used"