#!/bin/sh -f
# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Areski Flissi
# Contributor(s): 
#
# ====================================================================
#
# Starting an OpenCCM Java Component Server.
#
# Usage: jcs_start.sh <ComponentServerName>
#
# ====================================================================


# Checks the command line.

if [ $# != 1 ]
then
    echo "========================================================="
    echo "Usage: jcs_start.sh <ComponentServerName>"
    echo "========================================================="
    exit 1
fi

# Get the IOR of the started NS
ns_ior=`cat @OpenCCM_CONFIG_DIR@/NameService.IOR`


echo "Starting an OpenCCM ComponentServer $1 "
@JVM@ -Dior_ns=$ns_ior org.objectweb.util.launcher.Launcher --runid jcs $1 @OpenCCM_CONFIG_DIR@/ComponentServers/$1.IOR @OpenCCM_DIR@/xml/launcher/JCS.xml
echo "The OpenCCM ComponentServer $1 is started and registered on $ns_ior "