/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Christophe Demarey.
Contributor(s): ________________________________________.

====================================================================*/

package org.objectweb.openccm.pss.generator.common.lib;

// Package dependencies


/**
 * This class choose the MappingObject implementation 
 * according to the persistent framework.
 *
 * @author <a href="mailto:Christophe.Demarey@lifl.fr">Christophe Demarey</a>
 * 
 * @version 0.1
 */

public class MappingObjectFactory
{
    public static Object
    getClass(String name)
    {
        String pf = null;
        String class_name = null;
        ClassLoader loader = null;
        
        pf = System.getProperty("openccm.pss.pf");
        loader = Thread.currentThread().getContextClassLoader();
                
        if (pf != null)
        {
            class_name = "org.objectweb.openccm.pss.generator."
                         + pf + ".lib." + name;
            try
            {
                Class clazz = Class.forName(class_name);
                try
                {
                    return clazz.newInstance();
                } catch (Exception e1) {
                    e1.printStackTrace();
                }
            } catch (ClassNotFoundException e) {
                // Give the common class
                class_name = "org.objectweb.openccm.pss.generator.common.lib."
                             + name;
                try
                {
                    Class clazz = Class.forName(class_name);
                    try
                    {
                        return clazz.newInstance();
                    } catch (Exception e1) {
                        e1.printStackTrace();
                    }
                } catch (ClassNotFoundException e2) {
                    // Should not happen!
                    e2.printStackTrace();
                }
            }
        }
        
        return null;
    }
}
