# ====================================================================
#
# OpenCCM: The Open CORBA Component Model Platform
# Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
# Contact: openccm@objectweb.org
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
# USA
#
# Initial developer(s): Pierre Carpentier.
# Contributor(s): Philippe Merle.
#
# --------------------------------------------------------------------
# $Id: NotCreatedException.cs,v 1.2 2004/04/20 13:17:50 carpentier Exp $
# ====================================================================
#
#  This class represents the exception thrown when a searched type
#  is not created.
#
# ====================================================================

class NotCreatedException
{

    # =================================================================
    # Empty Constructor for a NotCreatedException.
    # type - The type which doesn't exist in the model
    # =================================================================
    proc __NotCreatedException__(self, type)
    {
        self.type = type;
    }


    # =================================================================
    # Transforms the exception to a formatted String
    # for the presentation.
    # =================================================================
    proc toString(self)
    {
        formatString = "The type " + self.type + " is undefined.";
        return formatString;
    }

}
