/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: OptionMonolithic.java,v 1.1 2004/05/26 11:25:34 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.lib;

import org.objectweb.util.cmdline.lib.DefaultOptionBase;

/**
 * The '--monolithic' option to select the
 * kind of the Java Implementation.
 *
 * @author <a href="mailto:Pierre.Carpentier@lifl.fr">Pierre Carpentier</a>
 *
 * @version 0.1
 */

public class OptionMonolithic
     extends DefaultOptionBase
{
    // ==================================================================
    //
    // Internal state.
    //
    // ==================================================================

    // ==================================================================
    //
    // Constructors.
    //
    // ==================================================================

    /** The default constructor. */
    public
    OptionMonolithic(org.objectweb.openccm.uml.api.UML2CCM generator)
    {
        super(new String[] { "--monolithic"},
              new String[0],
              "Generate the monolithic version of the Java implementation (CIF Implementation by default)");
        this.generator = generator;
    }

    // ==================================================================
    //
    // Internal methods.
    //
    // ==================================================================
    
    /** The generator of the Java Implementation. */
    org.objectweb.openccm.uml.api.UML2CCM generator;

    // ==================================================================
    //
    // Public methods for interface org.objectweb.util.cmdline.api.Option
    //
    // ==================================================================

    /**
     * Consumes command line arguments from an iterator.
     *
     * @param iterator The command line argument iterator.
     */
    public void
    consume(org.objectweb.util.cmdline.api.Iterator iterator)
    {
        generator.setMonolithic(true);
    }

    // ==================================================================
    //
    // Other public methods.
    //
    // ==================================================================
}
