/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: JmiModfactUML14ModelContext.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.modfact;

import ispuml.mdaTransformation.model.jmi.JmiModelContext;
import javax.jmi.reflect.RefPackage;

/**
 * A translator context suitable to any JMI model.
 * This context handle UML14 related methods.
 * This class implements UML methods dedicated to UML 14.
 */
public class JmiModfactUML14ModelContext extends JmiModelContext {

    /**
     * Constructor.
     * This constructor use the default implementations and the Jmi14ModelUtil.
     * @param outermostRefPackage The JMI package containing the model.
     */
    public JmiModfactUML14ModelContext(RefPackage outermostRefPackage) {
        super(new JmiModFactUML14ModelUtil(outermostRefPackage));
    }

}
