/*====================================================================

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2004 INRIA - USTL - LIFL - GOAL
Contact: openccm@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Pierre Carpentier.
Contributor(s): Philippe Merle.

---------------------------------------------------------------------
$Id: GetEnumeratedType.java,v 1.1 2004/05/26 11:25:35 carpentier Exp $
====================================================================*/

package org.objectweb.openccm.uml.transformation.rules.xml;

import ispuml.mdaTransformation.TransformationException;
import ispuml.mdaTransformation.rules.xml.Rule;

/**
 * Rule to obtain directly an enumerated type.
 * 
 * @author Pierre Carpentier
 */
public class GetEnumeratedType extends Rule implements EnumerationRule {

    /**
     * Gets the equivalent value of the destination enumeration which 
     * corresponds to the value of the source enumeration.
     * @param object The source enumeration value.
     * @return The String representing the value of the destination enumeration.
     * @throws TransformationException
     */
    public String getEquivalentLabel(Object object) throws TransformationException {
        return (String)object;
    }

}
