/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_q816Components;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import ist.coach.coachEmfCommon.DeleteErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;

import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.ApplicationError;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.DeleteError;

/**
 **  Implementation skeleton class for the ::itut_q816Components::ContainmentServiceProvider component.
 **  Business operations MUST be completed !!!
 **/
public class ContainmentServiceProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_ContainmentServiceProvider,
                  intt.itu.itut_q816.CCM_Containment,
                  intt.itu.itut_q816.CCM_ContainmentComponent,
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_ContainmentServiceProvider_Context the_context_;

        /**** Business logic *****/

        // hashtable that records for each object the existing children
        // Key: the stringnified object Name
        // Value: Vector with stringnified children Names
    private java.util.Hashtable tree;

        // hashtable that looks-up parents of objects
        // needed during remove so that to index the tree table.
    private java.util.Hashtable reverse_tree;

	String _local_root = null;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    ContainmentServiceProviderMonolithicImpl()
    {
        the_context_ = null;
        tree = new java.util.Hashtable();
        reverse_tree = new java.util.Hashtable();
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_ContainmentServiceProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //


		System.err.println("Local Root = " + _local_root);
		if (_local_root != null && _local_root.length() > 0)
        	tree.put(_local_root, new java.util.Vector());

			// FSET: HACK : Registration in Naming Service must be done
			// during deployment!


		System.err.println("ContainmentServiceProvider configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_ContainmentServiceProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_ContainmentServiceProvider local interface.
    //
    // ==================================================================
    //
    //  IDL:coach.ist/itut_q816Components/CCM_ContainmentServiceProvider/get_containment_query:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_ContainmentServiceProvider::get_containment_query operation.
     **/
    public intt.itu.itut_q816.CCM_Containment
    get_containment_query()
    {
        return this;
    }
    //
    //  IDL:coach.ist/itut_q816Components/CCM_ContainmentServiceProvider/get_containment_admin:1.0
    //
    /**
     **  Implementation of the ::itut_q816Components::CCM_ContainmentServiceProvider::get_containment_admin operation.
     **/
    public intt.itu.itut_q816.CCM_ContainmentComponent
    get_containment_admin()
    {
        return this;
    }

    /**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::
     ** local_root attribute as accessor operation.  **/
    public java.lang.String
	local_root() {
		 //
        //  DONE : implement
        //
        return _local_root;
	}

	/**
     **  Implementation of the ::itut_x780Components::CCM_NamedComponent_Executor::
	 ** local_root attribute as mutator operation.  **/
    public void
	local_root(java.lang.String val)
    {
        //
        //  DONE : implement
        //
		_local_root = val;
		if (! tree.contains(_local_root))
            tree.put(_local_root, new java.util.Vector());
	 }

    // ==================================================================
    //
    // Public methods for the ::itut_q816::CCM_Containment local interface.
    //
    // ==================================================================
    //
    //  IDL:itu.intt/itut_q816/Containment/exists:1.0
    //
    /**
     **  Implementation of the ::itut_q816::Containment::exists operation.
     **/
    public boolean
    exists(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //

        if (tree.containsKey(Utils.name2string(name)))
            return true;
        else
            return false;

    }
    //
    //  IDL:itu.intt/itut_q816/Containment/getContained:1.0
    //
    /**
     **  Implementation of the ::itut_q816::Containment::getContained operation.
     **/
    public org.omg.CosNaming.NameComponent[][]
    getContained(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		//System.err.println("getContained was called for *" + Utils.name2string(name) + "*");
        //System.err.println("Size of tree is " + tree.size());

        org.omg.CosNaming.NameComponent[][] contained_objects =
				new org.omg.CosNaming.NameComponent[0][0];

		String name_str = Utils.name2string(name);
		if (tree.containsKey(name_str)) {
            java.util.Vector contained_vector = (java.util.Vector) tree.get(name_str);

            contained_objects =
				new org.omg.CosNaming.NameComponent[contained_vector.size()][0];

            for(int i = 0; i < contained_vector.size(); i++) {

                String child_name = (String) contained_vector.elementAt(i);

                if (child_name == null || child_name.length() == 0)
                     System.err.println("Note that a NULL child found!");
                else {
                    contained_objects[i] = Utils.string2name(child_name);
                }
            }
		}
		//System.err.println("getContained returns " +
		//		contained_objects.length  + " children");
		return contained_objects;

    }
    //
    //  IDL:itu.intt/itut_q816/Containment/getContainedByKind:1.0
    //
    /**
     **  Implementation of the ::itut_q816::Containment::getContainedByKind operation.
     **/
    public org.omg.CosNaming.NameComponent[][]
    getContainedByKind(org.omg.CosNaming.NameComponent[] name, java.lang.String kind)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		org.omg.CosNaming.NameComponent[][] contained_objects =
				new org.omg.CosNaming.NameComponent[0][0];
		String name_str = Utils.name2string(name);

		if (! tree.containsKey(name_str)) {
			ApplicationErrorInfoTypeImpl error_code =
					new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = ExceptionMessages.root_delete_error;

        	throw new ApplicationError(error_code);
		}
        java.util.Vector contained_vector = (java.util.Vector) tree.get(name_str);

		java.util.Vector contained_by_kind_vector = new java.util.Vector();
		String child_str;
		for (int i = 0; i < contained_vector.size(); i++) {
			child_str = (String) contained_vector.elementAt(i);

			if (kind.equals(Utils.name2kind(child_str))) {
				contained_by_kind_vector.add(child_str);
			}

		}
		contained_objects = new org.omg.CosNaming.NameComponent[
					contained_by_kind_vector.size()][0];

		for(int j = 0; j < contained_by_kind_vector.size(); j++) {

			child_str = (String) contained_by_kind_vector.elementAt(j);

            if (child_str == null || child_str.length() == 0)
                System.err.println("NULL child found!");
            else
                contained_objects[j] = Utils.string2name(child_str);
		}

        return contained_objects;
    }
    // ==================================================================
    //
    // Public methods for the ::itut_q816::CCM_ContainmentComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:itu.intt/itut_q816/ContainmentComponent/registerLocalRoot:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ContainmentComponent::registerLocalRoot
	 **  operation.
     **/
    public void
    registerLocalRoot(org.omg.CosNaming.NameComponent[] name,
		org.omg.CosNaming.NamingContext localRoot)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  DONE : implement
        //
		_local_root = Utils.name2string(name);
		if (! tree.contains(_local_root))
        	tree.put(_local_root, new java.util.Vector());
    }
    //
    //  IDL:itu.intt/itut_q816/ContainmentComponent/unregisterLocalRoot:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ContainmentComponent::unregisterLocalRoot operation.
     **/
    public void
    unregisterLocalRoot(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError
    {
        //
        //  TODO : implement
        //
    }
    //
    //  IDL:itu.intt/itut_q816/ContainmentComponent/addName:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ContainmentComponent::addName operation.
     **/
    public void
    addName(org.omg.CosNaming.NameComponent[] name,
		org.omg.CosNaming.NameComponent[] superior)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError
    {
        //
        //  DONE : implement
        //
    	java.util.Vector children = new java.util.Vector();
		String name_str = Utils.name2string(name);
		String superior_str = Utils.name2string(superior);

    	if (tree.containsKey(superior_str)) {
        	children =  (java.util.Vector) tree.get(superior_str);
    	}
    	else {
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
			error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.badName.value);
			error_code.details = ExceptionMessages.parent_object_error;
        	throw new ApplicationError(error_code);
    	}

    	if (tree.containsKey(name_str)) {
        	CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.duplicateName.value);

           	error_code.details = name_str + ExceptionMessages.not_exists_error;
            throw new CreateError(error_code);

    	}
    	else
        	tree.put(name_str, new java.util.Vector());


    	if (! children.contains(name_str)) {
        	children.add(name_str);
        	tree.put(superior_str, children);
			reverse_tree.put(name_str, superior_str);
    	}
    }
    //
    //  IDL:itu.intt/itut_q816/ContainmentComponent/removeName:1.0
    //
    /**
     **  Implementation of the ::itut_q816::ContainmentComponent::removeName operation.
     **/
    public void
    removeName(org.omg.CosNaming.NameComponent[] name)
    throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.DeleteError
    {
        //
        //  DONE : implement
        //
   	 	if (name.length <= 1) {
			ApplicationErrorInfoTypeImpl error_code =
					new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = ExceptionMessages.root_delete_error;

        	throw new ApplicationError(error_code);
		}

		String name_str = Utils.name2string(name);

    	if (!tree.containsKey(name_str)) {
			ApplicationErrorInfoTypeImpl error_code =
				new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
				intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.invalidParameter.value);
			error_code.details = name_str + ExceptionMessages.not_exists_error;

        	throw new ApplicationError(error_code);
    	}

		java.util.Vector children =  (java.util.Vector) tree.get(name_str);

		 // There must be no contained names registered with
         // the Containment service when a name is removed.

		if (children != null && children.size() > 0) {
			DeleteErrorInfoTypeImpl error_code =
                new DeleteErrorInfoTypeImpl();
			error_code.error = new UIDType(
                intt.itu.itut_x780.DeleteErrorConst.moduleName.value,
				intt.itu.itut_x780.DeleteErrorConst.containsObjects.value);
			error_code.details = name_str + ExceptionMessages.contains_object_error;

			throw new DeleteError(error_code);
		}

        tree.remove(name_str);
        String superior = (String) reverse_tree.remove(name_str);

        if (superior == null)
            return;

        java.util.Vector superior_children = (java.util.Vector) tree.get(superior);
        if (superior_children.contains(name_str)) {
            superior_children.remove(name_str);
            tree. put(superior, superior_children);
        	//System.err.println("\tProceeding to remove from " + name_str
			//		+ " from " + superior);
        }

	}

}
