/*====================================================================
Tnis file was produced by the OpenCCM ir3_jimpl generator.
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2000-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
Lesser General Public License for more details.
You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA
Initial developer(s): Philippe Merle, Mathieu Vadet.
Contributor(s): Sylvain Leblanc_______________________.
====================================================================*/
package ist.coach.itut_x780Components;

import ist.coach.coachEmfCommon.Utils;
import ist.coach.coachEmfCommon.ExceptionMessages;
import intt.itu.itut_x780.UIDType;
import intt.itu.itut_x780.CreateError;
import intt.itu.itut_x780.ApplicationError;

import intt.itu.itut_x780.ManagedObjectFactory;
import intt.itu.itut_x780.ManagedObjectFactoryHelper;
import ist.coach.coachEmfCommon.CreateErrorInfoTypeImpl;
import ist.coach.coachEmfCommon.ApplicationErrorInfoTypeImpl;


/**
 **  Implementation class for the ::itut_x780Components::ManagedObjectFactoryProvider component.
 **/
public class ManagedObjectFactoryProviderMonolithicImpl
       extends org.omg.CORBA.LocalObject
       implements CCM_ManagedObjectFactoryProvider, 
                  org.omg.Components.SessionComponent
{
    // ==================================================================
    //
    // Internal State.
    //
    // ===================================================================
    /**
     **  Context reference.
     **/
    private CCM_ManagedObjectFactoryProvider_Context the_context_;
	/* Business logic **/
	intt.itu.itut_q816.ContainmentComponent c_admin = null;
    intt.itu.itut_q816.Containment c_query = null;

	private static final String FACTORY_CLASS = "ManagedObjectFactory";
	ManagedObjectMgmt facade = null;
    // ==================================================================
    //
    // Constructor.
    //
    // ===================================================================
    /**
     **  The default constructor.
     **/
    public
    ManagedObjectFactoryProviderMonolithicImpl()
    {
        the_context_ = null;
    }
    // ==================================================================
    //
    // Internal methods.
    //
    // ===================================================================
    // ==================================================================
    //
    // Public methods.
    //
    // ===================================================================
    /**
     **  To obtain the context.
     **
     **  @return The context that has been previously set by
     **          the set_session_context operation.
     **/
    public CCM_ManagedObjectFactoryProvider_Context
    getContext()
    {
        return the_context_;
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::EnterpriseComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/EnterpriseComponent/configuration_complete:1.0
    //
    /**
     **  Completes the component configuration.
     **
     **  @throws org.omg.Components.InvalidConfiguration
     **          Thrown if the configuration is invalid.
     **/
    public void
    configuration_complete()
    throws org.omg.Components.InvalidConfiguration
    {
        //
        //  DONE : implement !!!
        //
		if ((facade = the_context_.get_connection_facade()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((c_admin = the_context_.get_connection_containment_admin()) == null)
			throw new org.omg.Components.InvalidConfiguration();

		if ((c_query = the_context_.get_connection_containment_query()) == null)
			throw new org.omg.Components.InvalidConfiguration();

			// If managers may create, then the factory must register to the
			// factory finder service
		intt.itu.itut_q816.FactoryFinderComponent factoryfinder_admin =
			the_context_.get_connection_factoryfinder_admin();

		org.omg.CORBA.Object myself_o;
		ManagedObjectFactory myself = null;

        try {
            myself_o = ((org.omg.Components.SessionContext) the_context_).get_CCM_object();
            myself = ManagedObjectFactoryHelper.narrow(myself_o);

            factoryfinder_admin.register(FACTORY_CLASS, myself);
			//factoryfinder_admin.register(FACTORY_CLASS, this);
		}
		catch(intt.itu.itut_x780.ApplicationError ex) {
			throw new org.omg.Components.InvalidConfiguration();
		}
		catch(Exception e) {
            System.err.println("ManagedObjectFactory has problems retrieving CCM component");
        }


		System.err.println("ManagedObjectFactoryProvider configuration completed...");
    }
    // ==================================================================
    //
    // Methods for the OMG IDL Components::SessionComponent local interface.
    //
    // ==================================================================
    //
    //  IDL:omg.org/Components/SessionComponent/set_session_context:1.0
    //
    /**
     *  Called by the container when the component session context will be fixed.
     *
     *  @param context The session context.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void
    set_session_context(org.omg.Components.SessionContext context)
    throws org.omg.Components.CCMException
    {
        the_context_ = (CCM_ManagedObjectFactoryProvider_Context)context;
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
    //
    /**
     *
     * Called by the container when the component will be activated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void 
    ccm_activate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
    //
    /**
     *
     * Called by the container when the component will be passivated.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void 
    ccm_passivate()
    throws org.omg.Components.CCMException
    {
        //
        // Unused by actual OpenCCM containers
        //
    }
    //
    //  IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
    //
    /**
     *
     * Called by the container when the component will be removed.
     *
     *  @throws org.omg.Components.CCMException
     *          Thrown if a system level error occured.
     */
    public void 
    ccm_remove()
    throws org.omg.Components.CCMException
    {
        //
        // TO DO: implement !!!
        //
    }
    // ==================================================================
    //
    // Public methods for the CCM_ManagedObjectFactoryProvider local interface.
    //
    // ==================================================================
	public org.omg.CosNaming.NameComponent[]
	create_base(String nameBinding,
				org.omg.CosNaming.NameComponent[] superior, 
				String reqId) 
	throws intt.itu.itut_x780.ApplicationError, intt.itu.itut_x780.CreateError {

		short deletePolicy = -1;
		boolean managerMayCreatePolicy = false;
		String objectKind = new String();
		String nameBinding_str = "intt.itu.itut_x780.NameBindings." +
				nameBinding;
		try {
			Class deletePolicyClass = 
				Class.forName(nameBinding_str + ".deletePolicy");

			deletePolicy = 
				deletePolicyClass.getDeclaredField("value").getShort(null);

			Class managerMayCreatePolicyClass = 
					Class.forName(nameBinding_str + ".managersMayCreate");
			managerMayCreatePolicy = 
				managerMayCreatePolicyClass.getDeclaredField("value").getBoolean(null);

			Class objectKindClass =
					 Class.forName(nameBinding_str + ".kind");
			objectKind = (String) objectKindClass.getDeclaredField("value").get(null);

	/*
			System.err.println("deletePolicy = " + deletePolicy + 
								"managerMayCreatePolicy = " + managerMayCreatePolicy +
								"objectKind = " + objectKind);
	*/

		}
		catch(java.lang.ClassNotFoundException ex) {
			System.err.println(nameBinding_str + " can not be found!" + ex.getMessage());
		 	CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);

            error_code.details = ExceptionMessages.namebinding_exists_error;
            throw new CreateError(error_code);

		}
		catch(java.lang.NoSuchFieldException ex_field) {
			System.err.println("java.lang.NoSuchFieldException caught " +
					ex_field.getMessage());
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);

            error_code.details = ExceptionMessages.namebinding_field_error;
            throw new CreateError(error_code);

        }
		catch(java.lang.IllegalAccessException ex_acc) {
			System.err.println("java.lang.IllegalAccessException caught " +
					ex_acc.getMessage());
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);

            error_code.details = ExceptionMessages.namebinding_field_error;
            throw new CreateError(error_code);

		}
		// Check if managers are allowed to create the object.
		if (!managerMayCreatePolicy) {
			CreateErrorInfoTypeImpl error_code = new CreateErrorInfoTypeImpl();
            error_code.error = new UIDType(
                intt.itu.itut_x780.CreateErrorConst.moduleName.value,
                intt.itu.itut_x780.CreateErrorConst.invalidNameBinding.value);

            error_code.details =  ExceptionMessages.manager_create_error;
            throw new CreateError(error_code);
		}

		// Check if the parent exists
		if (! c_query.exists(superior)) {
			ApplicationErrorInfoTypeImpl error_code = new ApplicationErrorInfoTypeImpl();
			error_code.error = new UIDType(
                intt.itu.itut_x780.ApplicationErrorConst.moduleName.value,
				intt.itu.itut_x780.ApplicationErrorConst.objectNotFound.value);

			error_code.details = Utils.name2string(superior) + 
							ExceptionMessages.parent_object_error;
		
			throw new ApplicationError(error_code);
		}

		// The system must have th capability of auto-naming objects
		String allocatedId = reqId;
		if (reqId == null || reqId.length() == 0) {

			System.err.println("Auto-naming gets activated..");
			org.omg.CosNaming.NameComponent[][] siblings = 
				c_query.getContained(superior);
			System.err.println("Parent has " + siblings.length +
					" children");

			boolean idFound = false;
			int id = 0, name_length = 0;
			while(! idFound) {
				id++;
				int i = 0;
				for(i = 0; i < siblings.length; i++) {
					if (siblings[i] !=null && (name_length=siblings[i].length) > 0) {
						if (siblings[i][name_length -2].id.equals(Integer.toString(id))) {
							break;
						}
					}
				}
				if (i >= siblings.length)  {
					idFound = true;
				}
			}
			allocatedId = Integer.toString(id);
		}
	
		// Construct the name of the new object
		org.omg.CosNaming.NameComponent[] name;

		int index = 0;
		if (superior.length == 1) {
			name = new org.omg.CosNaming.NameComponent[superior.length + 2];
                index = 1;
        }
        else {
			name = new org.omg.CosNaming.NameComponent[superior.length + 1];
                index = superior.length - 1;
        }
		int i = 0;
		for(i = 0; i < index; i++)
			name[i] = superior[i];

			// the before-last name component, contains the element's id info
		name[i++] = new org.omg.CosNaming.NameComponent(allocatedId, objectKind);
			
			// the last component contains the facade's info;
		name[i] = new org.omg.CosNaming.NameComponent("", Utils.name2facade(facade.facade_name()));
		
		System.err.println("Before invoking the facade " + 
					Utils.name2facade(facade.facade_name()) + " to create " + Utils.name2string(name));
		facade.create(name, objectKind, new String[0], deletePolicy,
					intt.itu.itut_x780.SourceIndicatorType.managementOperation);

		c_admin.addName(name, superior);

		System.err.println("create_base returns for " + Utils.name2string(name));
		return name;
	}
}
