/*====================================================================

created on 10 avr. 2003

OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/

package org.objectweb.openccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;

/**
 * @author hameau
 */

public class PublisherPortTypeListImpl
extends LocalObject
implements PublisherPortTypeList
{
  private Table _publishers;
  	
  public PublisherPortTypeListImpl()
  {
    _publishers = new Table();
  }
  
  public PublisherPortType[] get_all_publisher_port_types()
  {
    PublisherPortType[] result = new PublisherPortType[_publishers.size()];
    
    // Iterate on all the connections.
    int idx = 0;
    for(java.util.Enumeration elements = _publishers.elements(); elements.hasMoreElements(); )
    {
    		PublisherPortType info = (PublisherPortType)elements.nextElement();
    		result[idx++] = info;
    }
    return result;
  }
  
  public PublisherPortType[] get_named_publisher_port_types(String[] names)
  {
    PublisherPortType[] result = new PublisherPortType[names.length];
    
    // Iterate on all the connections.
    int i = 0;
    for(i=0;i<names.length;i++)
    {
    		result[i] = (PublisherPortType)_publishers.get(names[i]);
    }
    return result;
  }	
  
  public PublisherPortType get_publisher_port_type(String name)
  {
    return (PublisherPortType) _publishers.get(name);
  }
  
  public void add_publisher_port_type(PublisherPortType _opt)
  {
    _publishers.put(_opt.name(),_opt);
  }
  
  public void remove_publisher_port_type(String name)
  {
    _publishers.remove(name);
  }
}
