/*====================================================================

created on 14 ao?t 2003
OpenCCM: The Open CORBA Component Model Platform
Copyright (C) 2001-2002 USTL - LIFL - GOAL
Contact: openccm-team@objectweb.org

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
USA

Initial developer(s): Hameau Fabien.
Contributor(s): ______________________________________.

*/
package org.objectweb.openccm.Containers.MetaInformation;

import org.objectweb.ccm.util.Table;
import org.omg.CORBA.LocalObject;
import org.omg.Components.InvalidName;

/**
 * @author hameau
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class ReceptaclePortInstanceListImpl
extends LocalObject
implements ReceptaclePortInstanceList
{
  
  private Table _receptacles;

  public ReceptaclePortInstanceListImpl()
  {
     _receptacles = new Table();
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ReceptaclePortInstanceListOperations#get_receptacle_port_instance(java.lang.String)
   */
  public ReceptaclePortInstance 
  get_receptacle_port_instance(String name) 
  throws InvalidName
  {
    ReceptaclePortInstance result = (ReceptaclePortInstance) _receptacles.get(name);
    if(result == null)
      throw new InvalidName();
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ReceptaclePortInstanceListOperations#get_named_receptacle_port_instanceS(java.lang.String[])
   */
  public ReceptaclePortInstance[] 
  get_named_receptacle_port_instanceS(String[] names) 
  throws InvalidName
  {
    ReceptaclePortInstance[] result = new ReceptaclePortInstance[names.length];

 // Iterate on all the connections.
  
 int i = 0;
 for(i=0;i<names.length;i++)
 {
   result[i] = (ReceptaclePortInstance)_receptacles.get(names[i]);
     
   if(result[i] == null)
   {
     throw new InvalidName();
   }
  }
   
 return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ReceptaclePortInstanceListOperations#get_all_receptacle_port_instanceS()
   */
  public ReceptaclePortInstance[] 
  get_all_receptacle_port_instanceS()
  {
    ReceptaclePortInstance[] result = new ReceptaclePortInstance[_receptacles.size()];
  
    // Iterate on all the connections.
    int idx = 0;
    for(java.util.Enumeration elements = _receptacles.elements(); elements.hasMoreElements(); )
    {
      ReceptaclePortInstance info = (ReceptaclePortInstance)elements.nextElement();
        result[idx++] = info;
    }
    return result;
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ReceptaclePortInstanceListOperations#add_receptacle_port_instance(org.objectweb.openccm.Containers.MetaInformation.ReceptaclePortInstance)
   */
  public void 
  add_receptacle_port_instance(ReceptaclePortInstance rpi)
  {
    String key = rpi.type_reference().name() ;//+ rpi.toString().substring(rpi.toString().lastIndexOf("@"));
    _receptacles.put(key,rpi);
  }

  /* (non-Javadoc)
   * @see org.objectweb.openccm.Containers.MetaInformation.ReceptaclePortInstanceListOperations#remove_receptacle_port_instance(java.lang.String)
   */
  public void 
  remove_receptacle_port_instance(String name) 
  throws InvalidName
  {
    Object result = _receptacles.remove(name);
    
    if (result == null) throw new InvalidName();
  }
}
